/* addressbook.c
 *
 *
 * $Author: mtm $
 * $Date: 1995/05/09 01:27:15 $
 * $Id: addressbook.c,v 1.1 1995/05/09 01:27:15 mtm Exp mtm $
 *
 * Mike Macgirvin <Mike_Macgirvin@CAMIS.Stanford.EDU>
 *
 * Copyright 1995 by The Leland Stanford Junior University.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notices appear in all copies and that both the
 * above copyright notices and this permission notice appear in supporting
 * documentation, and that the name of The Leland Stanford Junior University 
 * not be used in advertising or publicity pertaining to distribution of the 
 * software without specific, written prior permission.  This software is made 
 * available "as is", and THE LELAND STANFORD JUNIOR UNIVERSITY DISCLAIMS ALL 
 * WARRANTIES, EXPRESS OR IMPLIED, WITH REGARD TO THIS SOFTWARE, INCLUDING 
 * WITHOUT LIMITATION ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE, AND IN NO EVENT SHALL THE LELAND STANFORD JUNIOR 
 * UNIVERSITY BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR 
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER 
 * IN AN ACTION OF CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, 
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
 * SOFTWARE.
 *
 */

/*
 * $Log: addressbook.c,v $
 * Revision 1.1  1995/05/09  01:27:15  mtm
 * Initial revision
 *
 * 
 */

#include "ml.h"

Menu address_file_menu[] = {
  { NULL, "add", NUL_TERM,
      address_add, NULL, 0, NULL, NULL, BTN_SELECTION },
  { NULL, "remove", NUL_TERM,
      address_remove, NULL, 0, NULL, NULL, BTN_NOSELECTION },
  { NULL, "modify", NUL_TERM,
      address_modify, NULL, 0, NULL, NULL, BTN_NOSELECTION },
  { NULL, "close_window", NUL_TERM,
      address_close_window, NULL, 0, NULL, NULL, BTN_ON },

};

Menu address_option_menu[] = {
  { NULL, "search", NUL_TERM,
      address_search, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "reset", NUL_TERM,
      address_reset, NULL, 0, NULL, NULL, BTN_ON },

};

Menu address_book_menu[] = {
  { NULL, "file_menu", NUL_TERM,
      NULL, address_file_menu, XtNumber(address_file_menu),
      NULL, NULL, BTN_ON },

  { NULL, "option_menu", NUL_TERM,
      NULL, address_option_menu, XtNumber(address_option_menu),
      NULL, NULL, BTN_ON },

  { NULL, "HELP", NUL_TERM,
      address_help, NULL, 0, NULL, NULL, BTN_ON },

};



#ifdef __STDC__
void create_address_book_window(Widget w)
#else
void create_address_book_window(w)
     Widget w;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  Address_Book *address_book;
  Widget form, menubar;

  if(session.address_book == NULL) {
    address_book = (Address_Book *) fs_get(sizeof(Address_Book));
    address_book->is_realized = FALSE;
    session.address_book = address_book;
    address_book->address_book_info = NULL;
  }
  else
    address_book = session.address_book;

  if(session.address_book->is_realized == TRUE) {
    de_iconify(address_book->shell);
    return;
  }

  address_book->current = NULL;
  address_book->button_state = BTN_ON | BTN_NOSELECTION;

  address_book->shell = XtAppCreateShell("MLaddress","MLaddress",
					 topLevelShellWidgetClass,display, 
					 args, n); 
  n = 0;

  setup_editres(address_book->shell);

  if(addr_icon != (Pixmap) None)
    XtVaSetValues(address_book->shell,
		  XmNiconPixmap,addr_icon,
		  NULL);

  form = XmCreateForm(address_book->shell, "form", args, n );         n = 0;

  XtSetArg(args[n], XmNtopAttachment,   XmATTACH_FORM);               n ++;
  XtSetArg(args[n], XmNleftAttachment,  XmATTACH_FORM);               n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);               n ++;
  menubar = XmCreateMenuBar(form, "menubar", args, n);                n = 0;
  XtManageChild(menubar);

  create_buttons(NULL, menubar, address_book_menu, 
		 XtNumber(address_book_menu),
		 address_book->button_state, 
		 (XtPointer) address_book,
		 ROOTMENULEVEL);

  address_book->name =
    create_text_field(form, menubar, 
		      "name", NULL, 0, NULL, NULL);

  address_book->address =
    create_text_field(form, address_book->name, 
		      "addr", NULL, 0, NULL, NULL);

  address_book->comment =
    create_text_field(form, address_book->address,
		      "cmmt", NULL, 0, NULL, NULL);

  XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmSTATIC);             n ++;
  XtSetArg(args[n], XmNlistSizePolicy,         XmCONSTANT);           n ++;
  XtSetArg(args[n], XmNselectionPolicy,        XmSINGLE_SELECT);      n ++;
  address_book->list = XmCreateScrolledList(form,"list",args,n);      n = 0;

  XtAddCallback(address_book->list, XmNsingleSelectionCallback, 
		(XtCallbackProc) address_book_select, address_book);
  XtAddCallback(address_book->list, XmNdefaultActionCallback, 
		(XtCallbackProc) address_book_select, address_book);

  XtSetArg(args[n], XmNtopAttachment,          XmATTACH_WIDGET);       n ++;
  XtSetArg(args[n], XmNtopWidget,              address_book->comment); n ++;
  XtSetArg(args[n], XmNleftAttachment,         XmATTACH_FORM);         n ++;
  XtSetArg(args[n], XmNrightAttachment,        XmATTACH_POSITION);     n ++;
  XtSetArg(args[n], XmNrightPosition,          50);                    n ++;
  XtSetArg(args[n], XmNbottomAttachment,       XmATTACH_FORM);         n ++;

  XtSetValues(XtParent(address_book->list), args, n);                  n = 0;

  XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmSTATIC);              n ++;
  XtSetArg(args[n], XmNlistSizePolicy,         XmCONSTANT);            n ++;
  XtSetArg(args[n], XmNselectionPolicy,        XmSINGLE_SELECT);       n ++;
  address_book->search_list = 
    XmCreateScrolledList(form,"slist",args,n);                 n = 0;

  XtAddCallback(address_book->search_list, XmNsingleSelectionCallback, 
		(XtCallbackProc) address_book_select, address_book);
  XtAddCallback(address_book->search_list, XmNdefaultActionCallback, 
		(XtCallbackProc) address_book_select, address_book);

  XtSetArg(args[n], XmNtopAttachment,          XmATTACH_WIDGET);       n ++;
  XtSetArg(args[n], XmNtopWidget,              address_book->comment); n ++;
  XtSetArg(args[n], XmNrightAttachment,        XmATTACH_FORM);         n ++;
  XtSetArg(args[n], XmNleftAttachment,         XmATTACH_POSITION);     n ++;
  XtSetArg(args[n], XmNleftPosition,           50);                    n ++;
  XtSetArg(args[n], XmNbottomAttachment,       XmATTACH_FORM);         n ++;

  XtSetValues(XtParent(address_book->search_list), args, n);           n = 0;

  XtAddCallback(address_book->shell, XmNdestroyCallback, 
		(XtCallbackProc) address_destroy_window, address_book);

  address_sort(address_book);
  stuff_address_book(address_book);

  XtManageChild(address_book->search_list);
  XtManageChild(address_book->list); 

  XtManageChild(form);
  XtRealizeWidget(address_book->shell); 
  address_book->is_realized = TRUE;
  return;
}

#ifdef __STDC__
void address_close_window(Widget w,Address_Book *address_book,XtPointer xp)
#else
void address_close_window(w,address_book,xp)
     Widget w;
     Address_Book *address_book;
     XtPointer xp;
#endif
{
  XtRemoveCallback(address_book->shell, XmNdestroyCallback, 
		   (XtCallbackProc) address_destroy_window, address_book);
  XtDestroyWidget(address_book->shell);
  address_book->is_realized = FALSE;
  return;
}

#ifdef __STDC__
void address_destroy_window(Widget w,Address_Book *address_book,XtPointer xp)
#else
void address_destroy_window(w,address_book,xp)
     Widget w;
     Address_Book *address_book;
     XtPointer xp;
#endif
{
  address_book->is_realized = FALSE;
  return;
}

#ifdef __STDC__
void address_book_select(Widget w, Address_Book *address_book,
			 XmListCallbackStruct *cb)
#else
void address_book_select(w,address_book,cb)
     Widget w;
     Address_Book *address_book;
     XmListCallbackStruct *cb;
#endif
{
  unsigned char *str;
  Address_Book_Info *info;
  Widget other;

  if(w == address_book->list)
    other = address_book->search_list;
  else
    other = address_book->list;

  XmListDeselectAllItems(other);

  XmStringGetLtoR(cb->item,XmSTRING_DEFAULT_CHARSET,(char **)&str);

  if((address_book->current != NULL) && 
     (ml_strcoll(str,address_book->current->name) == STRMATCH) &&
     (address_book->current_list == w)) { 
    address_book_context_switch(address_book,address_book->current,NULL);
    address_book->button_state |= BTN_NOSELECTION;
    address_book->button_state &= ~BTN_SELECTION;
  }
  else {
    for(info = address_book->address_book_info; info ; info = info->prev ) {
      if((ml_strcoll(info->name,str)) == STRMATCH) {
	address_book_context_switch(address_book,address_book->current, info);
	address_book->button_state |= BTN_SELECTION;
	address_book->button_state &= ~BTN_NOSELECTION;
      }
    }
  }

  fs_give((void **) &str);
  address_book->current_list = w;
  check_buttons(address_book_menu, XtNumber(address_book_menu), 
		NULL, address_book->button_state);
  return;
}


#ifdef __STDC__
void address_book_context_switch(Address_Book *address_book,
				 Address_Book_Info *old,
				 Address_Book_Info *new)
#else
void address_book_context_switch(address_book,old,new)
     Address_Book *address_book;
     Address_Book_Info *old; 
     Address_Book_Info *new;
#endif
{
  
  if(old != NULL) {
    if(old->name != NULL) 
      fs_give((void **) &old->name);
    old->name = GetUnTextField(address_book->name);
    if(old->address != NULL)
      fs_give((void **) &old->address);
    old->address = GetUnTextField(address_book->address);
    if(old->comment != NULL)
      fs_give((void **) &old->comment);
    old->comment = GetUnTextField(address_book->comment);
  }
  if(new != NULL) {
    TextSetString(address_book->name,    
		  (new->name != NULL)    
		  ? new->name    
		  : (unsigned char *) EMPTYSTR);
    TextSetString(address_book->address,
		  (new->address != NULL) 
		  ? new->address 
		  : (unsigned char *) EMPTYSTR);
    TextSetString(address_book->comment,
		  (new->comment != NULL) 
		  ? new->comment 
		  : (unsigned char *) EMPTYSTR);
    
  }
  else {
    TextSetString(address_book->name,   (unsigned char *) EMPTYSTR);
    TextSetString(address_book->address,(unsigned char *) EMPTYSTR);
    TextSetString(address_book->comment,(unsigned char *) EMPTYSTR);
  }

  address_book->current = new;
  return;
}

#ifdef __STDC__
void stuff_address_book(Address_Book *address_book)
#else
void stuff_address_book(address_book)
     Address_Book *address_book;
#endif
{
  Address_Book_Info *info;
  XmString xstr;
  
  for(info = address_book->address_book_info; info ; info = info->prev) {
    xstr = XmStringCreateSimple((char *) info->name);
    XmListAddItemUnselected(address_book->list,xstr,0);
    XmStringFree(xstr);
  }
  return;
}

#ifdef __STDC__
void address_search(Widget w, Address_Book *address_book, XtPointer xp)
#else
void address_search(w,address_book,xp)
     Widget w;
     Address_Book *address_book;
     XtPointer xp;
#endif
{
  Address_Book_Info *info;
  XmString xstr;
  Boolean found = FALSE;

  /* Search on the current window contents */

  unsigned char *name     = GetUnTextField(address_book->name);
  unsigned char *address  = GetUnTextField(address_book->address);
  unsigned char *comment  = GetUnTextField(address_book->comment);

  /* Nothing to search for. */

  if((*name == NUL_TERM) && (*address == NUL_TERM) && (*comment == NUL_TERM))
    return;

  /* Let 'em know we're busy. */

  push_cursor(WATCH_CURSOR);

  address_book->current = NULL;
  XmListDeleteAllItems(address_book->search_list);

  /* 
   * Find a match on any field in our internal list, and
   * put it in the search list widget
   */

  for(info = address_book->address_book_info; info; info = info->prev) {
    if((address_searchit(info->name,name))
       || (address_searchit(info->address,address))
       || (address_searchit(info->comment,comment))) {
      found = TRUE;
      xstr = XmStringCreateSimple((char *) info->name);
      XmListAddItemUnselected(address_book->search_list,xstr,0);
      XmStringFree(xstr);
    }
  }

  /* 
   * Popup the first one in the list. This will call our selection
   * callback before it's done, so we don't have to tweak anything.
   */

  if(found) {
    XmListSelectPos(address_book->search_list,1,TRUE);
  }

  pop_cursor();
  return;
}


/*
 * This isn't the best search algorithm, but it doesn't have to be.
 * We're looking for any substring match, case insensitive.
 * Empty strings or null strings don't count.
 */

/* i18n-broken */

#ifdef __STDC__
Boolean address_searchit(unsigned char *str,unsigned char *pat)
#else
Boolean address_searchit(str,pat)
     unsigned char *str;
     unsigned char *pat;
#endif
{
  register unsigned char *ptr;

  if((str == NULL) || (pat == NULL) || (*pat == NUL_TERM))
    return(FALSE);
  for(ptr = str; *ptr; ptr ++ ) 
    if(strncasecmp((char *) ptr,(char *) pat,strlen((char *)pat)) == STRMATCH)
      return(TRUE);
  return(FALSE);
}

#ifdef __STDC__
void address_remove(Widget w, Address_Book *address_book, XtPointer xp)
#else
void address_remove(w,address_book,xp)
     Widget w;
     Address_Book *address_book;
     XtPointer xp;
#endif
{
  Address_Book_Info *info = address_book->current;

  if(! info)
    return;

  if(info->prev)
    info->prev->next = info->next;
  if(info->next)
    info->next->prev = info->prev;
  else
    address_book->address_book_info = info->prev;

  if(address_book->current == info)
    address_book->current = NULL;

  free_address_book_info(info);
  
  push_cursor(WATCH_CURSOR);
  save_defaults();
  address_reset(w,address_book, NULL);
  pop_cursor();
  return;
}

#ifdef __STDC__
void address_add(Widget w, Address_Book *address_book, XtPointer xp)
#else
void address_add(w,address_book,xp)
     Widget w;
     Address_Book *address_book;
     XtPointer xp;
#endif
{
  Address_Book_Info *info;
  Address_Book_Info *curr;

  info = new_address_book_info();

  info->name = GetUnTextField(address_book->name);

  if((info->name == NULL) || (*info->name == NUL_TERM)) {
    free_address_book_info(info);
    return;
  }
    
  for(curr = address_book->address_book_info; curr; curr = curr->prev) {
    if(ml_strcoll(curr->name,info->name) == STRMATCH) {
      free_address_book_info(info);
      return;
    }
  }

  push_cursor(WATCH_CURSOR);
  info->address = GetUnTextField(address_book->address);
  info->comment = GetUnTextField(address_book->comment);
  info->next = NULL;
  info->prev = address_book->address_book_info;
  if(info->prev)
    info->prev->next = info;
  address_book->address_book_info = info;
  address_sort(address_book);
  save_defaults();
  address_reset(w,address_book, NULL);
  pop_cursor();
  return;
}

#ifdef __STDC__
void address_modify(Widget w, Address_Book *address_book, XtPointer xp)
#else
void address_modify(w,address_book,xp)
     Widget w;
     Address_Book *address_book;
     XtPointer xp;
#endif
{
  Address_Book_Info *info;
  unsigned char *name = GetUnTextField(address_book->name);

  info = address_book->current;

  if((! info) || (*name == NUL_TERM))
    return;

  push_cursor(WATCH_CURSOR);

  if(info->name)
    fs_give((void **) &info->name);
  info->name = name;

  if(info->address)
    fs_give((void **) &info->address);
  info->address = GetUnTextField(address_book->address);

  if(info->comment)
    fs_give((void **) &info->comment);
  info->comment = GetUnTextField(address_book->comment);

  address_sort(address_book);
  save_defaults();
  address_reset(w,address_book, NULL);
  pop_cursor();
  return;
}

#ifdef __STDC__
void address_reset(Widget w, Address_Book *address_book, XtPointer xp)
#else
void address_reset(w,address_book,xp)
     Widget w;
     Address_Book *address_book;
     XtPointer xp;
#endif
{
  if(address_book == NULL)
    return;

  XmListDeleteAllItems(address_book->search_list);
  XmListDeselectAllItems(address_book->search_list);
  XmListDeselectAllItems(address_book->list);
  XmListDeleteAllItems(address_book->list);
  address_book->button_state |= BTN_NOSELECTION;
  address_book->button_state &= ~BTN_SELECTION;

  address_book_context_switch(address_book,address_book->current, NULL);
  stuff_address_book(address_book);
  check_buttons(address_book_menu, XtNumber(address_book_menu),
		NULL, address_book->button_state);
  return;
}

#ifdef __STDC__
int address_compare(const void *adr1, const void *adr2)
#else
int address_compare(adr1,adr2)
     const void *adr1;
     const void *adr2;
#endif
{
  Address_Book_Info **a1 = (Address_Book_Info **) adr1;
  Address_Book_Info **a2 = (Address_Book_Info **) adr2;
  return(ml_strcoll((*(a1))->name,(*(a2))->name));
}


#ifdef __STDC__
void address_sort(Address_Book *address_book)
#else
void address_sort(address_book)
     Address_Book *address_book;
#endif
{
  Address_Book_Info **sort;
  Address_Book_Info *info;
  int n = 0;
  int total = 0;

  if(address_book->address_book_info == NULL)
    return;

  for(info = address_book->address_book_info; info; info = info->prev)
    total ++;

  if(total < 2)
    return;

  sort = (Address_Book_Info **) fs_get(total * sizeof(Address_Book_Info *));

  for(info = address_book->address_book_info; info; info = info->prev) {
    sort[n] = info; 
    n ++;
  }

  qsort((char *) sort,total,sizeof(Address_Book_Info **),address_compare);

  for(n = 0; n < total; n ++) {
    info = sort[n];
    if(n == 0) {
      address_book->address_book_info = info;
      info->next = NULL;
      info->prev = sort[n + 1];
    }
    else {
      info->next = sort[n - 1];
      if(n == (total - 1))
	info->prev = NULL;
      else
	info->prev = sort[n + 1];
    }
  }
  fs_give((void **) &sort);
  return;
}


#ifdef __STDC__
void address_help(Widget w, Address_Book *address_book, XtPointer xp)
#else
void address_help(w,address_book,xp)
     Widget w;
     Address_Book *address_book;
     XtPointer xp;
#endif
{
  help(address_book->shell, ADDRBOOKHELPTITLE, 
       ADDRESSBOOKHELPFILE, DOCTYPE_ENRICHED);
  return;
}
