/* btntable.c
 *
 *
 * $Author$
 * $Date$
 * $Id$
 *
 * Mike Macgirvin <Mike_Macgirvin@CAMIS.Stanford.EDU>
 *
 * Copyright 1995 by The Leland Stanford Junior University.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notices appear in all copies and that both the
 * above copyright notices and this permission notice appear in supporting
 * documentation, and that the name of The Leland Stanford Junior University 
 * not be used in advertising or publicity pertaining to distribution of the 
 * software without specific, written prior permission.  This software is made 
 * available "as is", and THE LELAND STANFORD JUNIOR UNIVERSITY DISCLAIMS ALL 
 * WARRANTIES, EXPRESS OR IMPLIED, WITH REGARD TO THIS SOFTWARE, INCLUDING 
 * WITHOUT LIMITATION ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE, AND IN NO EVENT SHALL THE LELAND STANFORD JUNIOR 
 * UNIVERSITY BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR 
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER 
 * IN AN ACTION OF CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, 
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
 * SOFTWARE.
 *
 */

/*
 * $Log$
 */

#include "ml.h"

Menu btn_file_menu[] = {
  { NULL, "add", NUL_TERM,
      btn_add, NULL, 0, NULL, NULL, BTN_NOSELECTION },
  { NULL, "remove", NUL_TERM,
      btn_remove, NULL, 0, NULL, NULL, BTN_SELECTION },
  { NULL, "modify", NUL_TERM,
      btn_modify, NULL, 0, NULL, NULL, BTN_SELECTION },
  { NULL, "close_window", NUL_TERM,
      btn_close_window, NULL, 0, NULL, NULL, BTN_ON },

};


Menu btn_window_menu[] = {
  { NULL, "viewwin", NUL_TERM,
      btn_set_viewwin, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "composewin", NUL_TERM,
      btn_set_composewin, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "readwin", NUL_TERM,
      btn_set_readwin, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "mailboxwin", NUL_TERM,
      btn_set_mailboxwin, NULL, 0, NULL, NULL, BTN_ON },
};

Menu btnwin_menu[] = {
  { NULL, "file_menu", NUL_TERM,
      NULL, btn_file_menu, XtNumber(btn_file_menu),
      NULL, NULL, BTN_ON },
  { NULL, "window_menu", NUL_TERM,
      NULL, btn_window_menu, XtNumber(btn_window_menu),
      NULL, NULL, BTN_ON },
  { NULL, "moveup", NUL_TERM,
      btn_moveup, NULL, 0, NULL, NULL, BTN_SELECTION },
  { NULL, "movedown", NUL_TERM,
      btn_movedown, NULL, 0, NULL, NULL, BTN_SELECTION },
  { NULL, "HELP", NUL_TERM,
      btn_help, NULL, 0, NULL, NULL, BTN_ON },

};

#ifdef __STDC__
void create_btn_window(void)
#else
void create_btn_window()
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  Btn *btn;
  Widget form, menubar;

  if(session.btn == NULL) {
    btn = (Btn *) fs_get(sizeof(Btn));
    btn->is_realized = FALSE;
    session.btn = btn;
  }
  else
    btn = session.btn;

  if(session.btn->is_realized == TRUE) {
    de_iconify(btn->shell);
    return;
  }

  view_default_buttons();
  btn->type      = VIEW_BTN_MENU;
  btn->button_table = view_get_table();
  btn->btn_count = view_number_buttons();
  btn->button_menu = session.buttons[VIEW_BTN_MENU];
  btn->button_state = BTN_ON | BTN_SELECTION | BTN_NOSELECTION ;
  btn->selected1 = 0;
  btn->selected2 = NULL;

  btn->shell = XtAppCreateShell("MLbutton","MLbutton",
				topLevelShellWidgetClass,display, 
				args, n); 
  n = 0;

  setup_editres(btn->shell);

  if(ml_icon != (Pixmap) None)
    XtVaSetValues(btn->shell,
		  XmNiconPixmap,ml_icon,
		  NULL);

  form = XmCreateForm(btn->shell, "form", args, n ); n = 0;

  XtSetArg(args[n], XmNtopAttachment,   XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment,  XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  menubar = XmCreateMenuBar(form, "menubar", args, n); n = 0;
  XtManageChild(menubar);

  create_buttons(NULL, menubar, btnwin_menu, 
		 XtNumber(btnwin_menu),
		 btn->button_state, 
		 (XtPointer) btn,
		 ROOTMENULEVEL);

  btn->namew =
    create_text_field(form, menubar, 
		      "name", NULL, 0, NULL, NULL);

  btn->funcw =
    create_text_field(form, btn->namew, 
		      "func", NULL, 0, NULL, NULL);

  XtSetArg(args[n], XmNeditable, FALSE); n ++;
  XtSetValues(btn->funcw, args, n ); n = 0;

  XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmSTATIC);             n ++;
  XtSetArg(args[n], XmNlistSizePolicy,         XmCONSTANT);           n ++;
  XtSetArg(args[n], XmNselectionPolicy,        XmSINGLE_SELECT);      n ++;
  btn->list = XmCreateScrolledList(form,"list",args,n);      
  n = 0;

  XtAddCallback(btn->list, XmNsingleSelectionCallback, 
		(XtCallbackProc) btn_select1, btn);
  XtAddCallback(btn->list, XmNdefaultActionCallback, 
		(XtCallbackProc) no_op, btn);

  XtSetArg(args[n], XmNtopAttachment,          XmATTACH_WIDGET);       n ++;
  XtSetArg(args[n], XmNtopWidget,              btn->funcw);            n ++;
  XtSetArg(args[n], XmNleftAttachment,         XmATTACH_FORM);         n ++;
  XtSetArg(args[n], XmNrightAttachment,        XmATTACH_POSITION);     n ++;
  XtSetArg(args[n], XmNrightPosition,          50);                    n ++;
  XtSetArg(args[n], XmNbottomAttachment,       XmATTACH_FORM);         n ++;

  XtSetValues(XtParent(btn->list), args, n);                          n = 0;

  XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmSTATIC);              n ++;
  XtSetArg(args[n], XmNlistSizePolicy,         XmCONSTANT);            n ++;
  XtSetArg(args[n], XmNselectionPolicy,        XmSINGLE_SELECT);       n ++;
  btn->curr_list = 
    XmCreateScrolledList(form,"currlist",args,n);                 n = 0;

  XtAddCallback(btn->curr_list, XmNsingleSelectionCallback, 
		(XtCallbackProc) btn_select2, btn);
  XtAddCallback(btn->curr_list, XmNdefaultActionCallback, 
		(XtCallbackProc) no_op, btn);

  XtSetArg(args[n], XmNtopAttachment,          XmATTACH_WIDGET);       n ++;
  XtSetArg(args[n], XmNtopWidget,              btn->funcw);            n ++;
  XtSetArg(args[n], XmNrightAttachment,        XmATTACH_FORM);         n ++;
  XtSetArg(args[n], XmNleftAttachment,         XmATTACH_POSITION);     n ++;
  XtSetArg(args[n], XmNleftPosition,           50);                    n ++;
  XtSetArg(args[n], XmNbottomAttachment,       XmATTACH_FORM);         n ++;

  XtSetValues(XtParent(btn->curr_list), args, n);           n = 0;

  XtAddCallback(btn->shell, XmNdestroyCallback, 
		(XtCallbackProc) btn_destroy_window, btn);

/*  btn_sort(btn); */

  stuff_btn(btn);

  XtManageChild(btn->curr_list);
  XtManageChild(btn->list); 

  XtManageChild(form);
  XtRealizeWidget(btn->shell); 
  btn->is_realized = TRUE;
  return;
}

#ifdef __STDC__
void btn_close_window(Widget w,Btn *btn,XtPointer xp)
#else
void btn_close_window(w,btn,xp)
     Widget w;
     Btn *btn;
     XtPointer xp;
#endif
{
  XtRemoveCallback(btn->shell, XmNdestroyCallback, 
		   (XtCallbackProc) btn_destroy_window, btn);
  XtDestroyWidget(btn->shell);
  btn->is_realized = FALSE;

  return;
}

#ifdef __STDC__
void btn_destroy_window(Widget w,Btn *btn,XtPointer xp)
#else
void btn_destroy_window(w,btn,xp)
     Widget w;
     Btn *btn;
     XtPointer xp;
#endif
{
  btn->is_realized = FALSE;
  return;
}

#ifdef __STDC__
void stuff_btn(Btn *btn)
#else
void stuff_btn(btn)
     Btn *btn;
#endif
{
  Button_Menu *button_menu;
  int cnt;
  XmString xstr;

  XmListDeselectAllItems(btn->list);
  XmListDeleteAllItems(btn->list);
  XmListDeselectAllItems(btn->curr_list);
  XmListDeleteAllItems(btn->curr_list);
  btn->selected1 = 0;
  btn->selected2 = NULL;

  for(cnt = 0; cnt < btn->btn_count; cnt ++) {
    xstr = XmStringCreateSimple(btn->button_table[cnt].desc);
    XmListAddItemUnselected(btn->list, xstr, 0);
    XmStringFree(xstr);
  }

  for(button_menu = btn->button_menu; 
      button_menu; button_menu = button_menu->next) {
    xstr = XmStringCreateSimple(btn_lookup_func(btn->button_table,
						btn->btn_count,
						(void *) button_menu->func));
    XmListAddItemUnselected(btn->curr_list,xstr,0);
    XmStringFree(xstr);
  }

  btn->button_state = BTN_ON | BTN_SELECTION | BTN_NOSELECTION ;
  check_buttons(btnwin_menu, XtNumber(btnwin_menu), NULL, btn->button_state);
  return;
}

#ifdef __STDC__
char *btn_lookup_func(Button_Table *button_table, int nitems, void *func)
#else
char *btn_lookup_func(button_table, nitems, func)
     Button_Table *button_table;
     int nitems;
     void *func;
#endif
{
  int cnt;
  for(cnt = 0; cnt < nitems; cnt ++) 
    if(func == (void *) button_table[cnt].func)
      return(button_table[cnt].desc);
  return(NULL);
}

#ifdef __STDC__
Button_Table *btn_lookup_desc(Button_Table *button_table, int nitems, char *desc)
#else
Button_Table *btn_lookup_desc(button_table, nitems, desc)
     Button_Table *button_table;
     int nitems;
     char *desc;
#endif
{
  int cnt;
  for(cnt = 0; cnt < nitems; cnt ++)
    if((strcasecmp(button_table[cnt].desc,desc)) == STRMATCH)
      return(&button_table[cnt]);
  return(NULL);
}

#ifdef __STDC__
void btn_select1(Widget w, Btn *btn, XmListCallbackStruct *cb)
#else
void btn_select1(w,btn,cb)
     Widget w;
     Btn *btn;
     XmListCallbackStruct *cb;
#endif
{
  Button_Menu *button_menu;
  Button_Table *button_table;
  int n;
  char *str;
  void *func;

  XmListDeselectAllItems(btn->curr_list);
  btn->selected1 = 0;
  btn->selected2 = NULL;

  XmStringGetLtoR(cb->item,XmSTRING_DEFAULT_CHARSET,&str);

  for(n = 0; n < btn->btn_count; n ++ ) {
    if((strcmp(btn->button_table[n].desc,str)) == STRMATCH) {
      btn->selected1 = n;
      XmTextSetString(btn->namew,btn->button_table[n].label);
      XmTextSetString(btn->funcw,btn->button_table[n].desc);
      break;
    }
  }

  btn->button_state |= BTN_SELECTION;
  btn->button_state &= ~(BTN_NOSELECTION);

  check_buttons(btnwin_menu, XtNumber(btnwin_menu), NULL, btn->button_state);

  XmListSelectPos(btn->list,cb->item_position,FALSE);
  fs_give((void **) &str);
  return;
}

#ifdef __STDC__
void btn_select2(Widget w, Btn *btn, XmListCallbackStruct *cb)
#else
void btn_select2(w,btn,cb)
     Widget w;
     Btn *btn;
     XmListCallbackStruct *cb;
#endif
{
  Button_Menu *button_menu;
  Button_Table *button_table;
  char *str;
  void *func;

  XmListDeselectAllItems(btn->list);
  btn->selected1 = 0;
  btn->selected2 = NULL;

  XmStringGetLtoR(cb->item,XmSTRING_DEFAULT_CHARSET,&str);

  button_table = btn_lookup_desc(btn->button_table, btn->btn_count, str);

  if(button_table) {
    for(button_menu = btn->button_menu; button_menu; 
	button_menu = button_menu->next) {
      if(button_table->func == button_menu->func) {
	btn->selected2 = button_menu;
	break;
      }
    }
    if(btn->selected2) {
      XmTextSetString(btn->namew,btn->selected2->label);
      XmTextSetString(btn->funcw,button_table->desc);
    }
  }

  btn->button_state |= BTN_NOSELECTION;
  btn->button_state &= ~(BTN_SELECTION);

  check_buttons(btnwin_menu, XtNumber(btnwin_menu), NULL, btn->button_state);

  XmListSelectPos(btn->curr_list,cb->item_position,FALSE);
  fs_give((void **) &str);
  return;

}




#ifdef __STDC__
void btn_moveup(Widget w, Btn *btn, XtPointer xp)
#else
void btn_moveup(w,btn,xp)
     Widget w;
     Btn *btn;
     XtPointer xp;
#endif
{
  Button_Menu *button_menu;
  Button_Menu *next;
  int count;
  

  if((btn->selected2 == NULL) || (btn->selected2->prev == NULL))
    return;

  /* first remove the current guy from the chain. */

  if(btn->selected2->next)
    btn->selected2->next->prev = btn->selected2->prev;
  if(btn->selected2->prev)
    btn->selected2->prev->next = btn->selected2->next;
  else {
    session.buttons[btn->type] = btn->selected2->next;
    btn->button_menu = btn->selected2->next;
  }

  /* set "next" to this guy's "prev" and relink */

  next = btn->selected2->prev;

  btn->selected2->next = next;

  btn->selected2->prev = next->prev;

  if(next->prev)
    next->prev->next = btn->selected2;
  else {
    session.buttons[btn->type] = btn->selected2;
    btn->button_menu = btn->selected2;
  }
  next->prev = btn->selected2;

  count = 0;
  for(button_menu = btn->button_menu; button_menu; 
      button_menu = button_menu->next) {
    count ++;
    if(button_menu == btn->selected2)
      break;
  }

  btn_reset(btn);
  XmListSelectPos(btn->curr_list,count, TRUE);
  btn_apply(NULL, btn, NULL);
  save_defaults();
  return;
}


#ifdef __STDC__
void btn_movedown(Widget w, Btn *btn, XtPointer xp)
#else
void btn_movedown(w,btn,xp)
     Widget w;
     Btn *btn;
     XtPointer xp;
#endif
{
  Button_Menu *button_menu;
  Button_Menu *prev;
  int count;
  

  if((btn->selected2 == NULL) || (btn->selected2->next == NULL))
    return;

  /* first remove the current guy from the chain. */

  btn->selected2->next->prev = btn->selected2->prev;
  if(btn->selected2->prev)
    btn->selected2->prev->next = btn->selected2->next;
  else {
    session.buttons[btn->type] = btn->selected2->next;
    btn->button_menu = btn->selected2->next;
  }

  /* set "prev" to this guy's "next" and relink */

  prev = btn->selected2->next;

  btn->selected2->prev = prev;
  btn->selected2->next = prev->next;
  if(prev->next)
    prev->next->prev = btn->selected2;
  prev->next = btn->selected2;

  count = 0;
  for(button_menu = btn->button_menu; button_menu; 
      button_menu = button_menu->next) {
    count ++;
    if(button_menu == btn->selected2)
      break;
  }

  btn_reset(btn);
  XmListSelectPos(btn->curr_list,count, TRUE);
  btn_apply(NULL, btn, NULL);
  save_defaults();
  return;
}


#ifdef __STDC__
void btn_add(Widget w, Btn *btn, XtPointer xp)
#else
void btn_add(w,btn,xp)
     Widget w;
     Btn *btn;
     XtPointer xp;
#endif
{
  Button_Menu *button_menu;
  Button_Menu *prev;
  Button_Table *button_table;
  char *name;
  char *desc;
  
  name = XmTextGetString(btn->namew);
  desc = XmTextGetString(btn->funcw);

  button_table = btn_lookup_desc(btn->button_table,btn->btn_count,desc);
  if(button_table != NULL) {
    button_menu = new_button_menu();
    button_menu->label = cpystr(name);
    button_menu->statemap = button_table->statemap;
    button_menu->func = button_table->func;
    if(session.buttons[btn->type] == NULL)
      session.buttons[btn->type] = button_menu;
    else {
      for(prev = session.buttons[btn->type]; prev->next; prev = prev->next)
	;
      prev->next = button_menu;
      button_menu->prev = prev;
    }
  }
  fs_give((void **) &name);
  fs_give((void **) &desc);
  save_defaults();
  btn_reset(btn);
  btn_apply(NULL, btn, NULL);
  return;
}

#ifdef __STDC__
void btn_modify(Widget w, Btn *btn, XtPointer xp)
#else
void btn_modify(w,btn,xp)
     Widget w;
     Btn *btn;
     XtPointer xp;
#endif
{
  if(btn->selected2 == NULL)
    return;
  fs_give((void **) &btn->selected2->label);
  btn->selected2->label = XmTextGetString(btn->namew);
  save_defaults();
  btn_apply(NULL, btn, NULL);
  return;
}

#ifdef __STDC__
void btn_remove(Widget w, Btn *btn, XtPointer xp)
#else
void btn_remove(w,btn,xp)
     Widget w;
     Btn *btn;
     XtPointer xp;
#endif
{
  if(btn->selected2 == NULL)
    return;
  if(btn->selected2->next)
    btn->selected2->next->prev = btn->selected2->prev;
  if(btn->selected2->prev)
    btn->selected2->prev->next = btn->selected2->next;
  else 
    session.buttons[btn->type] = btn->selected2->next;
  
  if((btn->selected2->widget != NULL) && 
     (XtIsRealized(btn->selected2->widget)))
     XtDestroyWidget(btn->selected2->widget);

  fs_give((void **) &btn->selected2->label);
  fs_give((void **) &btn->selected2);

  if(session.buttons[btn->type] == NULL)
    btn_apply(NULL, btn, NULL);

  save_defaults();
  btn_reset(btn);
  return;
}


#ifdef __STDC__
void btn_reset(Btn *btn)
#else
void btn_reset(btn)
     Btn *btn;
#endif
{
  XmTextSetString(btn->namew, EMPTYSTR);
  XmTextSetString(btn->funcw, EMPTYSTR);

  btn->selected1 = 0;
  btn->selected2 = NULL;

  switch(btn->type) {
  case VIEW_BTN_MENU:
    btn_set_viewwin(NULL, btn, NULL);
    break;
  case READ_BTN_MENU:
    btn_set_readwin(NULL, btn, NULL);
    break;
  case COMPOSE_BTN_MENU:
    btn_set_composewin(NULL, btn, NULL);
    break;
  case MAILBOX_BTN_MENU:
    btn_set_mailboxwin(NULL, btn, NULL);
    break;
  default:
    break;
  }

  btn->button_state = BTN_ON | BTN_SELECTION | BTN_NOSELECTION ;
  check_buttons(btnwin_menu, XtNumber(btnwin_menu), NULL, btn->button_state);

  return;
}

#ifdef __STDC__
void btn_apply(Widget w, Btn *btn, XtPointer xp)
#else
void btn_apply(w,btn,xp)
     Widget w;
     Btn *btn;
     XtPointer xp;
#endif
{
  switch(btn->type) {
  case VIEW_BTN_MENU:
    view_reset_buttons();
    break;
  case READ_BTN_MENU:
    read_reset_buttons();
    break;
  case COMPOSE_BTN_MENU:
    compose_reset_buttons();
    break;
  case MAILBOX_BTN_MENU:
    mailboxes_reset_buttons();
    break;
  default:
    break;
  }
  return;
}

#ifdef __STDC__
void btn_set_viewwin(Widget w, Btn *btn, XtPointer xp)
#else
void btn_set_viewwin(w,btn,xp)
     Widget w;
     Btn *btn;
     XtPointer xp;
#endif
{
  view_default_buttons();
  btn->type          = VIEW_BTN_MENU;
  btn->button_table  = view_get_table();
  btn->btn_count     = view_number_buttons();
  btn->button_menu   = session.buttons[VIEW_BTN_MENU];
  stuff_btn(btn);
  return;
}

#ifdef __STDC__
void btn_set_readwin(Widget w, Btn *btn, XtPointer xp)
#else
void btn_set_readwin(w,btn,xp)
     Widget w;
     Btn *btn;
     XtPointer xp;
#endif
{
  read_default_buttons();
  btn->type          = READ_BTN_MENU;
  btn->button_table  = read_get_table();
  btn->btn_count     = read_number_buttons();
  btn->button_menu   = session.buttons[READ_BTN_MENU];
  stuff_btn(btn);
  return;
}

#ifdef __STDC__
void btn_set_composewin(Widget w, Btn *btn, XtPointer xp)
#else
void btn_set_composewin(w,btn,xp)
     Widget w;
     Btn *btn;
     XtPointer xp;
#endif
{
  compose_default_buttons();
  btn->type          = COMPOSE_BTN_MENU;
  btn->button_table  = compose_get_table();
  btn->btn_count     = compose_number_buttons();
  btn->button_menu   = session.buttons[COMPOSE_BTN_MENU];
  stuff_btn(btn);
  return;
}
#ifdef __STDC__
void btn_set_mailboxwin(Widget w, Btn *btn, XtPointer xp)
#else
void btn_set_mailboxwin(w,btn,xp)
     Widget w;
     Btn *btn;
     XtPointer xp;
#endif
{
  mailboxes_default_buttons();
  btn->type          = MAILBOX_BTN_MENU;
  btn->button_table  = mailboxes_get_table();
  btn->btn_count     = mailboxes_number_buttons();
  btn->button_menu   = session.buttons[MAILBOX_BTN_MENU];
  stuff_btn(btn);
  return;
}

#ifdef __STDC__
void btn_help(Widget w, Btn *btn, XtPointer xp)
#else
void btn_help(w,btn,xp)
     Widget w;
     Btn *btn;
     XtPointer xp;
#endif
{
  help(btn->shell, BUTTONHELPTITLE, 
      BUTTONHELPFILE, DOCTYPE_ENRICHED);
  return;
}




