/* compose.c
 *
 *
 * $uthor$
 * $Date: 1995/05/09 01:27:15 $
 * $Id: compose.c,v 1.1 1995/05/09 01:27:15 mtm Exp mtm $
 *
 * Mike Macgirvin <Mike_Macgirvin@CAMIS.Stanford.EDU>
 *
 * Copyright 1995 by The Leland Stanford Junior University.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notices appear in all copies and that both the
 * above copyright notices and this permission notice appear in supporting
 * documentation, and that the name of The Leland Stanford Junior University 
 * not be used in advertising or publicity pertaining to distribution of the 
 * software without specific, written prior permission.  This software is made 
 * available "as is", and THE LELAND STANFORD JUNIOR UNIVERSITY DISCLAIMS ALL 
 * WARRANTIES, EXPRESS OR IMPLIED, WITH REGARD TO THIS SOFTWARE, INCLUDING 
 * WITHOUT LIMITATION ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE, AND IN NO EVENT SHALL THE LELAND STANFORD JUNIOR 
 * UNIVERSITY BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR 
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER 
 * IN AN ACTION OF CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, 
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
 * SOFTWARE.
 *
 */

/*
 * $Log: compose.c,v $
 * Revision 1.1  1995/05/09  01:27:15  mtm
 * Initial revision
 *
 * 
 */

#include "ml.h"

char compose_address_translations[] = "<Key>Tab: complete-address()\n";

Menu compose_list_menu[] = {
  { NULL, "cancel", NUL_TERM,
      compose_list_cancel, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "HELP", NUL_TERM,
      compose_list_help, NULL, 0, NULL, NULL, BTN_ON },
};


Menu compose_file_menu[] = {
  { NULL, "load_draft", NUL_TERM, 
      compose_load_draft, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "save_draft", NUL_TERM, 
      compose_save_draft, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "print", NUL_TERM, 
      compose_print, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "insert_file", NUL_TERM,
      compose_insert_file, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "address_book", NUL_TERM,
      main_address_book, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "note_book", NUL_TERM,
      main_note_book, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "close_window", NUL_TERM, 
      compose_close_window,   NULL, 0, NULL, NULL, BTN_ON },
};


Menu compose_attach_menu[] = {
  { NULL, "attach_file", NUL_TERM,
      compose_attach_file, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "attach_multi", NUL_TERM,
      compose_attach_multi, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "createattach", NUL_TERM,
      compose_createattach, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "delete_part", NUL_TERM,
      compose_delete_part, NULL, 0, 
      NULL, NULL, BTN_NOATTACH|BTN_NOATTACHSELECT },
};


Menu compose_edit_menu[] = {
  { NULL, "reply_insert", NUL_TERM,
      compose_reply_insert, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "custom_insert", NUL_TERM,
      compose_custom_insert, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "edit_tool", NUL_TERM,
      compose_edit_tool, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "spell", NUL_TERM,
      compose_spell, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "attach_menu", NUL_TERM,
      NULL, compose_attach_menu, XtNumber(compose_attach_menu),
      NULL, NULL, BTN_ON },
  { NULL, "wrap_on", NUL_TERM,
      compose_wrap_on, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "wrap_off", NUL_TERM,
      compose_wrap_off, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "destroy_current", NUL_TERM,
      compose_destroy_current, NULL, 0, NULL, NULL, BTN_ON },
};


Menu compose_key_submenu[] = {
  { NULL, "pgp_sign", NUL_TERM,
      compose_pgp_sign, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "pgp_encrypt", NUL_TERM,
      compose_pgp_cryp, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "pgp_both", NUL_TERM,
      compose_pgp_both, NULL, 0, NULL, NULL, BTN_ON },
};

Menu compose_option_menu[] = {
  { NULL, "watch_delivery", NUL_TERM,
      compose_watch_delivery, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "keep_open", NUL_TERM,
      compose_keep_open, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "parameters", NUL_TERM,
      compose_parameters, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "set_eight", NUL_TERM,
      compose_eight, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "set_seven", NUL_TERM,
      compose_seven, NULL, 0, NULL, NULL, BTN_ON },
#ifdef PGP
  { NULL, "key_menu", NUL_TERM,
      NULL, compose_key_submenu, XtNumber(compose_key_submenu), 
      NULL, NULL, BTN_ON|BTN_NOPGP },
#endif /* PGP */
};


Menu compose_send_menu[] = {
  { NULL, "send_message", NUL_TERM, 
      send_message, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "send_autograph", BTN_ON,
      compose_send_autograph, NULL, 0, NULL, NULL, BTN_NOSIGFILE },
};

Menu compose_menu[] = {
  { NULL, "file_menu", NUL_TERM, 
      NULL, compose_file_menu, XtNumber(compose_file_menu), 
      NULL, NULL, BTN_ON },
  { NULL, "edit_menu", NUL_TERM, 
      NULL, compose_edit_menu, XtNumber(compose_edit_menu), 
      NULL, NULL, BTN_ON },
  { NULL, "option_menu", NUL_TERM,
      NULL, compose_option_menu, XtNumber(compose_option_menu), 
      NULL, NULL, BTN_ON },
  { NULL, "send_menu", NUL_TERM,
      NULL, compose_send_menu, XtNumber(compose_send_menu), 
      NULL, NULL, BTN_ON },
  { NULL, "prevwin", NUL_TERM,
      compose_prev, NULL, 0, NULL, NULL, BTN_NOPREV },
  { NULL, "listwin", NUL_TERM,
      compose_window_list, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "nextwin", NUL_TERM,
      compose_next, NULL, 0, NULL, NULL, BTN_NONEXT },
  { NULL, "HELP", NUL_TERM, 
      compose_help, NULL, 0,
      NULL, NULL, BTN_ON },
};

Menu compose_format_menu[] = {
  { NULL, "dismiss", NUL_TERM,
      compose_edit_dismiss, NULL, 0, NULL, NULL, BTN_ON },
  { NULL,  "HELP", NUL_TERM,
      compose_edit_help, NULL, 0, NULL, NULL, BTN_ON },
};

Button_Table MLcompose_button_table[] = {

  { "LoadDraft", "compose-load-draft",
      compose_load_draft, BTN_ON },
  { "SaveDraft", "compose-save-draft",
      compose_save_draft, BTN_ON },
  { "Print",     "compose-print",
      compose_print, BTN_ON },
  { "InsertFile", "compose-insert-file",
      compose_insert_file, BTN_ON },
  { "Addressbook", "compose-addressbook",
      main_address_book, BTN_ON },
  { "Notebook", "compose-notebook",
      main_note_book, BTN_ON },
  { "Cancel", "compose-close-window",
      compose_close_window,   BTN_ON },
  { "AttachFile", "compose-attach-file",
      compose_attach_file, BTN_ON },
  { "AttachMulti", "compose-attach-multipart",
      compose_attach_multi, BTN_ON },
  { "CreateAttach", "compose-create-attachment",
      compose_createattach, BTN_ON },
  { "DeleteAttach", "compose-delete-attachment",
      compose_delete_part, BTN_NOATTACH|BTN_NOATTACHSELECT },
  { "Insert", "compose-insert-reply",
      compose_reply_insert, BTN_ON },
  { "Insert", "compose-custom-insert",
      compose_custom_insert, BTN_ON },
  { "EditTool", "compose-edit-tool",
      compose_edit_tool, BTN_ON },
  { "Spell", "compose-spellcheck",
      compose_spell, BTN_ON },
  { "Wrap", "compose-wrap-on",
      compose_wrap_on, BTN_ON },
  { "NoWrap", "compose-wrap-off",
      compose_wrap_off, BTN_ON },
  { "Cancel", "compose-cancel-current",
      compose_destroy_current, BTN_ON },
  { "PGPsign", "compose-pgp-sign",
      compose_pgp_sign, BTN_ON },
  { "Encrypt", "compose-pgp-encrypt",
      compose_pgp_cryp, BTN_ON },
  { "SignEncrypt", "compose-pgp-sign-encrypt",
      compose_pgp_both, BTN_ON },
  { "Trace", "compose-watch-delivery",
      compose_watch_delivery, BTN_ON },
  { "Keep", "compose-keep-message",
      compose_keep_open, BTN_ON },
  { "Param", "compose-set-parameters",
      compose_parameters, BTN_ON },
  { "Intl", "compose-eightbit-transfer",
      compose_eight, BTN_ON },
  { "Normal", "compose-sevenbit-transfer",
      compose_seven, BTN_ON },
  { "Send", "compose-send-message",
      send_message, BTN_ON },
  { "Send", "compose-send-with-sig",
      compose_send_autograph, BTN_NOSIGFILE },
};


Button_Menu MLcompose_default_buttons[] = {
  { "InsertFile",  compose_insert_file,     NULL, BTN_ON, NULL },
  { "AttachFile",  compose_attach_file,     NULL, BTN_ON, NULL },
  { "Insert",      compose_reply_insert,    NULL, BTN_ON, NULL },
  { "Send",        send_message,            NULL, BTN_ON, NULL },
  { "Cancel",      compose_destroy_current, NULL, BTN_ON, NULL },
  { "Dismiss",     compose_close_window,    NULL, BTN_ON, NULL },
};

#ifdef __STDC__
int compose_number_buttons(void)
#else
int compose_number_buttons()
#endif
{
  return(XtNumber(MLcompose_button_table));
}

#ifdef __STDC__
Button_Table *compose_get_table(void)
#else
Button_Table *compose_get_table()
#endif
{
  return(MLcompose_button_table);
}


#ifdef __STDC__
void compose_default_buttons(void)
#else
void compose_default_buttons()
#endif
{
  if(session.buttons[COMPOSE_BTN_MENU] == NULL)
    setup_default_buttons(&session.buttons[COMPOSE_BTN_MENU],
			  MLcompose_default_buttons,
			  XtNumber(MLcompose_default_buttons));
  return;
}

#ifdef __STDC__
void compose_reset_buttons(void)
#else
void compose_reset_buttons()
#endif
{
  Button_Menu *button_menu;

  if((session.compose == NULL) 
     || (session.compose->current == NULL)
     || (session.compose->is_realized == FALSE))
    return;
  for(button_menu = session.buttons[COMPOSE_BTN_MENU];
      button_menu; button_menu = button_menu->next)
    if(button_menu->widget != NULL)
      XtDestroyWidget(button_menu->widget);

  compose_default_buttons();

  make_pbuttons(session.compose->rowcol, session.buttons[COMPOSE_BTN_MENU], 
		session.compose->current->button_state, 
		(XtPointer) session.compose);

  return;
}

/*
 * Here's the logical layout...
 * We have a Compose structure which contains window information,
 * and it contains a linked list of Compose_Info structures,
 * which point to the data used by any particular compose session.
 * The window itself can be closed during the mail session, but
 * the messages-in-progress will survive when it is invoked
 * again. The "Window" menu bar contains the functions for
 * navigating between compose sessions. A successful send or
 * message kill removes that session and brings back the previous
 * session in the list, or the next if there's no previous, or
 * shuts the window if there's nothing left. The main Compose
 * structure is only created once during the program, although
 * the widgets it holds may need to be recreated. We keep a reference
 * to this structure in the top level Session structure.
 */


#ifdef __STDC__
Compose_Info *compose(char *title, int behaviour, 
		      Compose_Type type, Read_Info *read_info, 
		      Lview *lview, Message *message)
#else
Compose_Info *compose(title,behaviour,type,read_info,lview, message)
     char *title;
     int behaviour;
     Compose_Type type;
     Read_Info *read_info;
     Lview *lview;
     Message *message;

#endif
{
  Compose *compose = session.compose;
  Compose_Info *compose_info;
  Boolean preserve = FALSE;

  /* 
   * If the first time through -- grab a Compose structure and 
   * initialize it.
   *
   */

  if(compose == NULL) {
    compose = (Compose *) fs_get(sizeof(Compose));
    session.compose = compose;
    compose->compose_info = NULL;
    compose->is_realized = FALSE;
    compose->current = NULL;
    compose->compose_info = NULL;
    compose->edit = new_edit();
    compose->search_win = NULL;
    compose->list_is_realized = FALSE;
  }

  /* 
   * Create a Compose_Info structure for this compose session.
   */
  
  compose_info = new_compose_info();

  compose_info->title = cpystr(title);

  /* Set the initial CHARSET parameter, if not "US-ASCII" */

  if((strcasecmp(preferences.charset,US_ASCII_STR) != STRMATCH)) {
    compose_info->parameters = mail_newbody_parameter();
    compose_info->parameters->attribute = cpystr(CHARSET_STR);
    compose_info->parameters->value = cpystr(preferences.charset);
  }


  /* 
   * Link in the Compose_Info structure to our other sessions. This will
   * become the "last" session, and anything else is pushed back, i.e. they
   * become "previous" sessions. Set the buttons of our next-door neighbor 
   * so that its button state reflects the fact that we are now in the chain.
   *
   */

  compose_info->prev = compose->compose_info;

  if(compose_info->prev == NULL)
    compose_info->button_state |= BTN_NOPREV;
  else
    compose_info->prev->button_state &= (~BTN_NONEXT);

  compose_info->button_state |= BTN_NONEXT;

  if(preferences.pgp_pathname && *preferences.pgp_pathname) {
    if((access(preferences.pgp_pathname,X_OK)) == SYSCALL_FAILURE)
      compose_info->button_state |= BTN_NOPGP;
  }
  else
    compose_info->button_state |= BTN_NOPGP;
    
  if(compose->compose_info != NULL) 
    compose->compose_info->next = compose_info;

  compose->compose_info = compose_info;

  /* 
   * Either the compose window has never been created,
   * or it was closed at some point, and we need to re-create
   * our widgets. 
   */  

  if(compose->is_realized == FALSE) {
    create_compose_window(compose,behaviour, CC_BEHAVIOUR);
    preserve = TRUE; /* create_compose_window() will set is_realized. */
                     /* We still will need to know this state later.  */
  }
  else
    de_iconify(compose->shell);

  XmUpdateDisplay(compose->shell);

  if((preferences.signature_file == NULL)
     || (*preferences.signature_file == NUL_TERM) 
     || ((access(preferences.signature_file,R_OK)) != SYSCALL_SUCCESS))
    compose_info->button_state |= BTN_NOSIGFILE;

  /* 
   * Stuff the present structure with anything applicable, such as
   * forwarding or remailed text.
   *
   */

  if(read_info != NULL || type == COMPOSE_NEW) 
    load_compose_info(compose_info,type,read_info);
  else
    load_compose_info_message(compose_info,type,lview, message);


  /* 
   * Now make this new session the active one. When it comes
   * back, we will be compose->current, the window will hold
   * our new editing sesion, and the buttons will have been checked.
   * The preserve check is because if the window has been regenerated,
   * it will now be empty. We don't want to store the current contents
   * into our old structures, because it will overwrite them.
   */

  XFlush(display);

  compose_context_switch(compose,
			 (preserve == TRUE) ? NULL : compose_info->prev,
			 compose_info);

  stuff_compose_window_list(compose,TRUE); 

  session.button_state &= (~BTN_NOCOMPOSEOPEN);
  update_main_buttons(); 

  return(compose_info);
}



#ifdef __STDC__
void load_compose_info(Compose_Info *compose_info, Compose_Type type,
		       Read_Info *read_info)
#else
void load_compose_info(compose_info,type,read_info)
     Compose_Info *compose_info;
     Compose_Type type;
     Read_Info *read_info;
#endif
{

  char *to;                  /* don't free */
  char *reply_subject;       /* don't free */
  char *cc;                  /* don't free */
  char *msgid;
  char *ptr1;
  char *ptr2;

  char *fulltext;
  char *fulleverything;
  PART *part;
  BODY *body;
  char *tmp;

  if((type == COMPOSE_NEW) || (read_info == NULL))
    return;

  compose_info->compose_type = type;
  compose_info->mailstream   = read_info->mailstream;
  compose_info->msgno        = read_info->msgno;

  push_cursor(WATCH_CURSOR);

  switch(type) {

  case COMPOSE_REPLYALL:
    ptr1 = get_header_field_contents("newsgroups", read_info->header);
    if(ptr1) {
      fs_give((void **) &compose_info->newsgroups);
      compose_info->newsgroups = cpystr(ptr1);
      fs_give((void **) &ptr1);
      compose_info->has_ng = TRUE;
    }
    ptr1 = get_header_field_contents("to",read_info->header);
    if(ptr1 == NULL)
      ptr1 = cpystr(EMPTYSTR);
    ptr2 = get_header_field_contents("cc",read_info->header);
    if(ptr2 == NULL)
      ptr2 = cpystr(EMPTYSTR);
    cc = (char *) fs_get(strlen(ptr1) + strlen(ptr2) + 8 );
    *cc = NUL_TERM;
    
    if(*ptr1 != NUL_TERM) {
      strcpy(cc,ptr1);
      if(*ptr2 != NUL_TERM)
	strcat(cc,", ");
    }
    if(*ptr2 != NUL_TERM)
      strcat(cc,ptr2);
    fs_give((void **) &ptr1);
    fs_give((void **) &ptr2);
    fs_give((void **) &compose_info->cc);
    compose_info->cc = cc;
    
    /* fall through to set other info */
    
  case COMPOSE_REPLY:
    to = get_header_field_contents("reply-to",read_info->header);
    if(to == NULL)
      to = get_header_field_contents("from", read_info->header);
    if(to) {
      fs_give((void **) &compose_info->to);
      compose_info->to = to; 
    }
    reply_subject = get_reply_subject(read_info->header);
    fs_give((void **) &compose_info->subject);
    compose_info->subject = reply_subject;
    msgid = get_header_field_contents("message-id", read_info->header);
    compose_info->in_reply_to = msgid;
    if(read_info->alt_text)
      compose_info->reply_text = cpystr(read_info->alt_text);
    else
      if(read_info->current_text)
	compose_info->reply_text = cpystr(read_info->current_text);
    break;
  case COMPOSE_FORWARD:
    if(read_info->alt_text) {
      fs_give((void **) &compose_info->text);
      compose_info->text = get_forward_text(read_info->alt_text);
    }
    else {
      if(read_info->current_text) {
	fs_give((void **) &compose_info->text);
	compose_info->text = get_forward_text(read_info->current_text);
      }
    }
    fs_give((void **) &compose_info->subject);
    compose_info->subject = get_forward_subject(read_info->header);
    break;
  case COMPOSE_FORWARDATTACH:
    if((read_info->mailstream == NULL) 
       || (read_info->msgno == 0L)) {
      mm_log(WAS_EXPUNGED,WARN);
      break;
    }
    fulltext = mail_fetchtext(read_info->mailstream,read_info->msgno);
    if(! fulltext)
      break;
    stripcr(fulltext);
    fulleverything = (char *) fs_get(strlen(read_info->header) +
				     strlen(fulltext) + 256);
    strcpy(fulleverything,read_info->header);
    strcat(fulleverything,LFSTR);
    strcat(fulleverything,fulltext);
    part = mail_newbody_part();
    body = &part->body;
    
    body->type = TYPEMESSAGE;
    body->subtype = cpystr("RFC822");
    body->description = get_forward_subject(read_info->header);
    body->encoding = ENC7BIT;
    body->contents.msg.text = fulleverything;
    compose_info->attachments = part;
    break;
    
  case COMPOSE_REMAIL:
    if(read_info->mailstream && read_info->msgno) {
      compose_info->remail_header 
	= cpystr(mail_fetchheader(read_info->mailstream,read_info->msgno));
      fs_give((void **) &compose_info->text);
      compose_info->text 
	= cpystr(mail_fetchtext(read_info->mailstream, read_info->msgno));
      stripcr(compose_info->text);
    }
    break;
    
  default:
    break;
  }

  if((preferences.default_cc != NULL)
     && (*preferences.default_cc != NUL_TERM)) {
    tmp = (char *) fs_get(strlen(compose_info->cc) 
			  + strlen(preferences.default_cc) + 16);
    if(strlen(compose_info->cc)) {
      strcpy(tmp,compose_info->cc);
      strcat(tmp,", ");
      strcat(tmp,preferences.default_cc);
    }
    else
      strcpy(tmp,preferences.default_cc);
    fs_give((void **) &compose_info->cc);
    compose_info->cc = tmp;

  }

  if((preferences.default_bcc != NULL) 
     && (*preferences.default_bcc != NUL_TERM)) {
    fs_give((void **) &compose_info->bcc);
    compose_info->bcc = cpystr(preferences.default_bcc);

  }

  pop_cursor();
  return;
}

#ifdef __STDC__
void load_compose_info_message(Compose_Info *compose_info, Compose_Type type,
			       Lview *lview, Message *message)
#else
void load_compose_info_message(compose_info,type, lview, message)
     Compose_Info *compose_info;
     Compose_Type type;
     Lview *lview;
     Message *message;
#endif
{

  char *tmp;
  char *to;                  /* don't free */
  char *reply_subject;       /* don't free */
  char *cc;                  /* don't free */
  char *msgid;
  char *ptr1;
  char *ptr2;

  char *fulleverything;
  PART *oldpart;
  PART *part;
  BODY *body;

  char *fetched_header = NULL;
  char *fetched_text = NULL;

  Message_List *message_list;


  compose_info->compose_type = type;

  push_cursor(WATCH_CURSOR);

  if(message) {
    compose_info->mailstream   = message->mailstream;
    compose_info->msgno        = message->msgno;

    fetched_header = cpystr(mail_fetchheader(message->mailstream,
					     message->msgno));
    
    stripcr(fetched_header);
    
    if(fetched_header[strlen(fetched_header) - 1] == LFCHAR)
      fetched_header[strlen(fetched_header) - 1] = NUL_TERM;
    
    fetched_text = cpystr(mail_fetchtext(message->mailstream,
					 message->msgno));
    
    stripcr(fetched_text);
  }
  
  switch(type) {
    
  case COMPOSE_REPLYALL:
    ptr1 = get_header_field_contents("newsgroups", fetched_header);
    if(ptr1) {
      fs_give((void **) &compose_info->newsgroups);
      compose_info->newsgroups = cpystr(ptr1);
      fs_give((void **) &ptr1);
      compose_info->has_ng = TRUE;
    }
    ptr1 = get_header_field_contents("to",fetched_header);
    if(ptr1 == NULL)
      ptr1 = cpystr(EMPTYSTR);
    ptr2 = get_header_field_contents("cc",fetched_header);
    if(ptr2 == NULL)
      ptr2 = cpystr(EMPTYSTR);
    cc = (char *) fs_get(strlen(ptr1) + strlen(ptr2) + 8 );
    *cc = NUL_TERM;
    
    if(*ptr1 != NUL_TERM) {
      strcpy(cc,ptr1);
      if(*ptr2 != NUL_TERM)
	strcat(cc,", ");
    }
    if(*ptr2 != NUL_TERM)
      strcat(cc,ptr2);
    fs_give((void **) &ptr1);
    fs_give((void **) &ptr2);
    fs_give((void **) &compose_info->cc);
    compose_info->cc = cc;
    
    /* fall through to set other info */
    
  case COMPOSE_REPLY:
    to = get_header_field_contents("reply-to",fetched_header);
    if(to == NULL)
      to = get_header_field_contents("from", fetched_header);
    if(to) {
      fs_give((void **) &compose_info->to);
      compose_info->to = to; 
    }
    reply_subject = get_reply_subject(fetched_header);
    fs_give((void **) &compose_info->subject);
    compose_info->subject = reply_subject;
    msgid = get_header_field_contents("message-id", fetched_header);
    compose_info->in_reply_to = msgid;
    if(fetched_text)
      compose_info->reply_text = cpystr(fetched_text);
    break;
  case COMPOSE_FORWARD:
    compose_info->mailstream   = NULL;
    compose_info->msgno        = 0L;

    get_multi_forward_info(lview,compose_info);
    break;
    
  case COMPOSE_FORWARDATTACH:
    compose_info->mailstream   = NULL;
    compose_info->msgno        = 0L;

    for(message_list = lview->message_list;
	message_list; message_list = message_list->next) {
      if(message_list->selected == TRUE) {
	
	fetched_header 
	  = cpystr(mail_fetchheader(message_list->message->mailstream,
				    message_list->message->msgno));
	
	stripcr(fetched_header);
	
	if(fetched_header[strlen(fetched_header) - 1] == LFCHAR)
	  fetched_header[strlen(fetched_header) - 1] = NUL_TERM;
	
	fetched_text 
	  = cpystr(mail_fetchtext(message_list->message->mailstream,
				  message_list->message->msgno));
	
	stripcr(fetched_text);
	
	
	fulleverything = (char *) fs_get(strlen(fetched_header) +
					 strlen(fetched_text) + 256);
	strcpy(fulleverything,fetched_header);
	strcat(fulleverything,LFSTR);
	strcat(fulleverything,fetched_text);
	part = mail_newbody_part();
	body = &part->body;
	
	body->type = TYPEMESSAGE;
	body->subtype = cpystr("RFC822");
	body->description = get_forward_subject(fetched_header);
	body->encoding = ENC7BIT;
	body->contents.msg.text = fulleverything;
	if(compose_info->attachments == NULL)
	  compose_info->attachments = part;
	else {
	  for(oldpart = compose_info->attachments; oldpart->next;
	      oldpart = oldpart->next)
	    ;
	  oldpart->next = part;
	}
	fs_give((void **) &fetched_header);
	fs_give((void **) &fetched_text);
      }
    }
    break;
    
  case COMPOSE_REMAIL:
    compose_info->remail_header = cpystr(fetched_header);
    fs_give((void **) &compose_info->text);
    compose_info->text = cpystr(fetched_text);
    break;
    
  default:
    break;
  }

  if(fetched_header)  
    fs_give((void **) &fetched_header);
  if(fetched_text)
    fs_give((void **) &fetched_text);



  if((preferences.default_cc != NULL)
     && (*preferences.default_cc != NUL_TERM)) {
    tmp = (char *) fs_get(strlen(compose_info->cc) 
			  + strlen(preferences.default_cc) + 16);
    if(strlen(compose_info->cc)) {
      strcpy(tmp,compose_info->cc);
      strcat(tmp,", ");
      strcat(tmp,preferences.default_cc);
    }
    else
      strcpy(tmp,preferences.default_cc);
    fs_give((void **) &compose_info->cc);
    compose_info->cc = tmp;

  }

  if((preferences.default_bcc != NULL) 
     && (*preferences.default_bcc != NUL_TERM)) {
    fs_give((void **) &compose_info->bcc);
    compose_info->bcc = cpystr(preferences.default_bcc);

  }

  pop_cursor();
  return;
}

#ifdef __STDC__
void get_multi_forward_info(Lview *lview, Compose_Info *compose_info)
#else
void get_multi_forward_info(lview,compose_info)
  Lview *lview;
  Compose_Info *compose_info;
#endif
{
  Message_List *message_list;
  unsigned long count = 0L;
  Message *message = NULL;
  char *old_header = NULL;
  char *old_text = NULL;
  char *new_header = NULL;
  char *new_text = NULL;
  char *tmp_header = NULL;
  char *tmp_text = NULL;
  char *fetched_header = NULL;
  char *fetched_text = NULL;
  char *ret = NULL;

  for(message_list = lview->message_list; message_list; 
      message_list = message_list->next) {
    if(message_list->selected) {
      message = message_list->message;
      count ++;
    }
  }

  if(count == 0)
    return;

  if((count == 1) && (message)) {
    fetched_header = cpystr(mail_fetchheader(message->mailstream,
					     message->msgno));
    stripcr(fetched_header);
    if(fetched_header[strlen(fetched_header) - 1] == LFCHAR)
      fetched_header[strlen(fetched_header) - 1] = NUL_TERM;
    
    fetched_text = cpystr(mail_fetchtext(message->mailstream,
					 message->msgno));
    stripcr(fetched_text);
    fs_give((void **) &compose_info->text);
    compose_info->text = get_forward_text(fetched_text);
    
    fs_give((void **) &compose_info->subject);
    compose_info->subject = get_forward_subject(fetched_header);
    return;
  }

  count = 0;

  fs_give((void **) &compose_info->subject);
  compose_info->subject = cpystr("[Multiple Messages Forwarded]");
  old_header = cpystr("--- Forwarded Messages:\n\n");
  old_text = cpystr(EMPTYSTR);

  for(message_list = lview->message_list; message_list; 
      message_list = message_list->next) {
    if(message_list->selected) {
      message = message_list->message;
      count ++;

      fetched_header = cpystr(mail_fetchheader(message->mailstream,
					       message->msgno));
      stripcr(fetched_header);
      if(fetched_header[strlen(fetched_header) - 1] == LFCHAR)
	fetched_header[strlen(fetched_header) - 1] = NUL_TERM;
      
      tmp_header = get_short_forward_line(fetched_header,count);
      new_header = (char *)fs_get(strlen(old_header) + strlen(tmp_header) + 1);
      strcpy(new_header,old_header);
      strcat(new_header,tmp_header);
      fs_give((void **) &old_header);
      fs_give((void **) &tmp_header);
      fs_give((void **) &fetched_header);
      old_header = new_header;

      fetched_text = cpystr(mail_fetchtext(message->mailstream,
					   message->msgno));
			    
      stripcr(fetched_text);
      tmp_text = get_forward_text(fetched_text);
      new_text = (char *) fs_get(strlen(old_text) + strlen(tmp_text) + 2);
      strcpy(new_text,old_text);
      strcat(new_text,LFSTR);
      strcat(new_text,tmp_text);
      fs_give((void **) &old_text);
      fs_give((void **) &tmp_text);
      fs_give((void **) &fetched_text);
      old_text = new_text;


    }
  }

  ret = (char *) fs_get(strlen(old_header) + strlen(old_text) + 1);
  strcpy(ret,old_header);
  strcat(ret,old_text);

  fs_give((void **) &old_header);
  fs_give((void **) &old_text);

  fs_give((void **) &compose_info->text);
  compose_info->text = ret;
  return;
}

/*
 * Create a Compose_Info structure, and fill it with default values. The 
 * defaults are good for an original (new) mail message. 
 */

#ifdef __STDC__
Compose_Info *new_compose_info(void)
#else
Compose_Info *new_compose_info()
#endif
{

  Compose_Info *compose_info = (Compose_Info *) fs_get(sizeof(Compose_Info));

  compose_info->mailstream      = NULL;
  compose_info->msgno           = 0;

  compose_info->title           = cpystr(EMPTYSTR);
  compose_info->from            = cpystr(preferences.reply_address);
  compose_info->to              = cpystr(EMPTYSTR);
  compose_info->newsgroups      = cpystr(EMPTYSTR);
  compose_info->subject         = cpystr(EMPTYSTR);
  compose_info->cc              = cpystr(EMPTYSTR);
  compose_info->bcc             = cpystr(EMPTYSTR);
  compose_info->text            = cpystr(EMPTYSTR);
  compose_info->remail_header   = NULL;
  compose_info->in_reply_to     = NULL;
  compose_info->reply_text      = NULL;
  compose_info->has_ng          = FALSE;
  compose_info->charset         = NULL;
  compose_info->parameters      = NULL;
  compose_info->language        = NULL;
  compose_info->send_eight      = preferences.send_eight;
  compose_info->button_state    = BTN_ON | BTN_NOATTACH | BTN_NOATTACHSELECT;
  compose_info->selected        = FALSE;
  compose_info->behaviour       = MAIL_BEHAVIOUR;
  compose_info->ccbehaviour     = CC_BEHAVIOUR;
  compose_info->watch_send      = preferences.smtp_debug;
  compose_info->keep_open       = FALSE;
  compose_info->wrap            = TRUE;
  compose_info->compose_type    = COMPOSE_NEW;
  compose_info->attachments     = NULL;
  compose_info->part_list       = NULL;
  compose_info->selection       = 0;
  compose_info->next            = NULL;
  compose_info->prev            = NULL;
  
  return(compose_info);
}


/* 
 * Called on message kill or successful delivery to remove the current
 * session, and free up its data. We're done with it. 
 *
 */


#ifdef __STDC__
void compose_destroy_current(Widget w, Compose *compose, XtPointer xp)
#else
void compose_destroy_current(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{

  Compose_Info *doomed;   /* This guy is history. */

  Boolean has_prev = FALSE;
  Boolean has_next = FALSE;

  if((compose == NULL) || (compose->current == NULL))
    return;

  doomed = compose->current;

  /* 
   * Extract ourselves form the double linked list.
   * At the same time set our neighbors' button states
   * to reflect the change in neighbors.
   */

  if(doomed->prev) { 
    doomed->prev->next = doomed->next;
    if(doomed->prev->next) 
      doomed->prev->button_state &= (~BTN_NONEXT);
    else
      doomed->prev->button_state |= BTN_NONEXT;
    has_prev = TRUE;
  }

  if(doomed->next) {
    doomed->next->prev = doomed->prev;
    if(doomed->next->prev)
      doomed->next->button_state &= (~BTN_NOPREV);
    else
      doomed->next->button_state |= BTN_NOPREV;
    has_next = TRUE;
  }
  else
    compose->compose_info = doomed->prev;

  /* Bring up whichever neighbor we might have, older first.  */

  if(has_prev == TRUE)
    compose_context_switch(compose,doomed,doomed->prev);
  else {
    if(has_next == TRUE)
      compose_context_switch(compose,doomed,doomed->next);
    else {                      /* no neighbors... */
      compose->current = NULL;
      compose->compose_info = NULL;
    }
  }

  free_compose_info(doomed);

  /* No more messages in the queue? Close the window. Bye, bye... */

  stuff_compose_window_list(compose,TRUE);

  if(compose->current == NULL) {
    session.button_state |= BTN_NOCOMPOSEOPEN;
    update_main_buttons();
    compose_close_window(w,compose,xp);
  }    

}


/*
 * This functions frees the memory of a once used Compose_Info structure.
 */

#ifdef __STDC__
void free_compose_info(Compose_Info *compose_info)
#else
void free_compose_info(compose_info)
     Compose_Info *compose_info;
#endif
{

  if(! compose_info)
    return;

  if(compose_info->title)
    fs_give((void **) &compose_info->title);
  if(compose_info->from)
    fs_give((void **) &compose_info->from);
  if(compose_info->to)
    fs_give((void **) &compose_info->to);
  if(compose_info->newsgroups)
    fs_give((void **) &compose_info->newsgroups);
  if(compose_info->subject)
    fs_give((void **) &compose_info->subject);
  if(compose_info->cc)
    fs_give((void **) &compose_info->cc);
  if(compose_info->bcc)
    fs_give((void **) &compose_info->bcc);
  if(compose_info->text)
    fs_give((void **) &compose_info->text);

  if(compose_info->remail_header)
    fs_give((void **) &compose_info->remail_header);
  if(compose_info->in_reply_to)
    fs_give((void **) &compose_info->in_reply_to);

  if(compose_info->reply_text)
    fs_give((void **) & compose_info->reply_text);

  if(compose_info->attachments)
    mail_free_body_part(&compose_info->attachments);

  if(compose_info->parameters)
    mail_free_body_parameter(&compose_info->parameters);

  if(compose_info->part_list) {
    destroy_part_list(compose_info->part_list);
    compose_info->part_list = NULL;
  }

  fs_give((void **) &compose_info);

  return;

}


/* 
 * This function toggles the window contents between two
 * editing sessions, saving the contents of the old session, (currently
 * visible), setting the contents appropriate to the new session,
 * (making it visible) and sets compose->current to the new one. It 
 * also sets the button sensitivity applicable to this sesion. 
 *
 */


#ifdef __STDC__
void compose_context_switch(Compose *compose, 
			    Compose_Info *old, Compose_Info *new)
#else
void compose_context_switch(compose, old, new ) 
     Compose *compose;
     Compose_Info *old;
     Compose_Info *new;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  char buffer[FILEBUFFLEN];
  char *s;
  if(compose == NULL)
    return;


  if((compose->search_win != NULL) 
     && (compose->search_win->is_realized == TRUE))
    spell_cancel(NULL, compose->search_win, NULL);

  if(old != NULL) {

    fs_give((void **) &old->to);
    old->to = GetTextField(compose->to_text);
    fs_give((void **) &old->newsgroups);
    old->newsgroups = GetTextField(compose->ng_text);
    fs_give((void **) &old->subject);
    old->subject = GetTextField(compose->subject_text);
    fs_give((void **) &old->cc);
    old->cc = GetTextField(compose->cc_text);
    fs_give((void **) &old->bcc);
    old->bcc = GetTextField(compose->bcc_text);
    fs_give((void **) &old->text);
    old->text = XmTextGetString(compose->compose_text);

  }

  if(new != NULL) {

    if(new->parameters != NULL) {
      s = param_to_str(new->parameters);
      if(s == NULL)
	s = cpystr(EMPTYSTR);
      sprintf(buffer,"%s%s [%s]", (new->has_ng) ? NEWS_TITLE : EMPTYSTR,
	      new->title, s);
      fs_give((void **) &s);
    }
    else
      strcpy(buffer, new->title);

    XtSetArg(args[n],XmNtitle, buffer); n ++;
    XtSetValues(compose->shell, args, n); n = 0;

    XmTextSetString(compose->to_text,new->to);
    XmTextSetString(compose->ng_text,new->newsgroups);
    XmTextSetString(compose->subject_text,new->subject);
    XmTextSetString(compose->cc_text,new->cc);
    XmTextSetString(compose->bcc_text,new->bcc);
    XmTextSetString(compose->compose_text,new->text);


    compose->current = new;
    /* make_attachment_list() will also set our buttons. */
    make_attachment_list(compose);

    if(old != NULL) {
      new->behaviour = old->behaviour;
      new->ccbehaviour = old->ccbehaviour;
    }

    XmUpdateDisplay(compose->shell);

    if(*new->to == NUL_TERM)
      XmProcessTraversal(compose->to_text,XmTRAVERSE_CURRENT);
    else {
      if(*new->subject == NUL_TERM)
	XmProcessTraversal(compose->subject_text,XmTRAVERSE_CURRENT);
      else
	XmProcessTraversal(compose->compose_text, XmTRAVERSE_CURRENT);
    }

  }

  if((old != NULL) && (new != NULL) && (old->wrap != new->wrap)) {
    if(new->wrap == TRUE)
      compose_wrap_on(NULL, compose, NULL);
    else
      compose_wrap_off(NULL, compose, NULL);
  }
  
  return;

}

#ifdef __STDC__
void compose_help(Widget w, Compose *compose, XtPointer xp)
#else 
void compose_help(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  help(compose->shell, COMPOSEHELPTITLE, 
       COMPOSEHELPFILE, DOCTYPE_ENRICHED );
  return;
}


#ifdef __STDC__
void compose_keep_open(Widget w, Compose *compose, XtPointer xp)
#else 
void compose_keep_open(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  if((compose) && (compose->current)) {
    compose->current->keep_open = TRUE;
  }
  return;
}


/* Go to the next sesion on the list. */


#ifdef __STDC__
void compose_next(Widget w, Compose *compose, XtPointer xp)
#else 
void compose_next(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{

  if(compose) {
    if(compose->current->next)
      compose_context_switch(compose,compose->current,compose->current->next);
    stuff_compose_window_list(compose,TRUE);
    check_buttons(compose_menu,XtNumber(compose_menu),
		  session.buttons[COMPOSE_BTN_MENU], 
		  compose->current->button_state); 
  }
  return;
}


/* Go to the previous session on the list. */

#ifdef __STDC__
void compose_prev(Widget w, Compose *compose, XtPointer xp)
#else
void compose_prev(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  if(compose) {
    if(compose->current->prev)
      compose_context_switch(compose,compose->current,compose->current->prev);
    stuff_compose_window_list(compose,TRUE);
    check_buttons(compose_menu,XtNumber(compose_menu),
		  session.buttons[COMPOSE_BTN_MENU], 
		  compose->current->button_state);
  } 
  return;
}


/* 
 * Called when there are either no more compose sessions, or
 * the user closes the window. All we do is remove the widgets,
 * so if there are any compose sessions, they'll still be there.
 */


#ifdef __STDC__
void compose_close_window(Widget w, Compose *compose, XtPointer xp)
#else
void compose_close_window(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{

  if(compose) {

    /* save the current window contents */
    compose_context_switch(compose,compose->current, NULL);
    compose->current = NULL;
    stuff_compose_window_list(compose, TRUE);
    XtRemoveCallback(compose->shell, XmNdestroyCallback, 
		     (XtCallbackProc) compose_destroy, compose);
    XtDestroyWidget(compose->shell);
    compose->is_realized = FALSE;
  }
  return;
}

/*
 * Called when something external to the window kills it. We should
 * save the current edit, and make sure the is_realized flag gets
 * set to false or we'll never be able to open it again.
 */

#ifdef __STDC__
void compose_destroy(Widget w, Compose *compose, XtPointer xp)
#else
void compose_destroy(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  if(compose && compose->is_realized) {
    /* save the current window contents */
    compose_context_switch(compose,compose->current, NULL);
    compose->current = NULL;
    stuff_compose_window_list(compose, TRUE);
    compose->is_realized = FALSE;
  }
  return;
}

#ifdef __STDC__
void compose_eight(Widget w, Compose *compose, XtPointer xp)
#else
void compose_eight(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  if(compose && compose->current)
    compose->current->send_eight = TRUE;
  return;
}

#ifdef __STDC__
void compose_seven(Widget w, Compose *compose, XtPointer xp)
#else
void compose_seven(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  if(compose && compose->current)
    compose->current->send_eight = FALSE;
  return;
}


/* 
 * Turn on the mail debugging flag. We can also do it globally
 * from preferences.smtp_debug. This sets it for the current
 * message only. There is no way to turn it off again.
 */

#ifdef __STDC__
void compose_watch_delivery(Widget w, Compose *compose, XtPointer xp)
#else
void compose_watch_delivery(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  if(compose && compose->current)
    compose->current->watch_send = TRUE;
  return;
}


/* 
 * Change the window to reflect a NEWS message, with a "Newsgroups:"
 * line instead of "To:". "Cc" and "Bcc" are on all messages,
 * but only go through SMTP. Newsgroups go through NNTP. You can 
 * mix and match either. Note that the window which is hidden as 
 * a result of this is still active. If it has contents,
 * they will be used at delivery time.
 *
 */


#ifdef __STDC__
void compose_toggle_news(Widget w, Compose *compose, XtPointer xp)
#else
void compose_toggle_news(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  char *txt;
  char *s;
  char buffer[FILEBUFFLEN];

  if((compose != NULL) && (compose->current != NULL)) {

    if(compose->current->behaviour == NEWS_BEHAVIOUR) {
      txt = XmTextGetString(compose->ng_text);
      if(txt) {
	if(*txt != NUL_TERM) {
	  compose->current->has_ng = TRUE;
	  if(compose->current->parameters != NULL) {
	    s = param_to_str(compose->current->parameters);
	    if(s == NULL)
	      s = cpystr(EMPTYSTR);
	    sprintf(buffer,"%s%s [%s]", 
		    (compose->current->has_ng) ? NEWS_TITLE : EMPTYSTR,
		    compose->current->title, s);
	    fs_give((void **) &s);
	  }
	  else
	    strcpy(buffer, compose->current->title);

	  XtSetArg(args[n],XmNtitle, buffer); n ++;
	  XtSetValues(compose->shell, args, n); n = 0;
	  fs_give((void **) &txt);
	}
	else
	  compose->current->has_ng = FALSE;
      }
      compose->current->behaviour = MAIL_BEHAVIOUR;
      XtUnmanageChild(compose->ng_label);
      XtUnmanageChild(compose->ng_text);
      XtManageChild(compose->to_label);
      XtManageChild(compose->to_text);
      
    }
    else { /* (compose->current->behaviour == MAIL_BEHAVIOUR) */
      compose->current->behaviour = NEWS_BEHAVIOUR;
      XtUnmanageChild(compose->to_label);
      XtUnmanageChild(compose->to_text);
      XtManageChild(compose->ng_label);
      XtManageChild(compose->ng_text);
      
    }
  }
  return;
}


#ifdef __STDC__
void compose_toggle_cc(Widget w, Compose *compose, XtPointer xp)
#else
void compose_toggle_cc(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  if((compose != NULL) && (compose->current != NULL)) {

    if(compose->current->ccbehaviour == CC_BEHAVIOUR) {
      compose->current->ccbehaviour = BCC_BEHAVIOUR;
      XtUnmanageChild(compose->cc_label);
      XtUnmanageChild(compose->cc_text);
      XtManageChild(compose->bcc_label);
      XtManageChild(compose->bcc_text);
      
    }
    else { /* (compose->current->behaviour == BCC_BEHAVIOUR) */
      compose->current->ccbehaviour = CC_BEHAVIOUR;
      XtUnmanageChild(compose->bcc_label);
      XtUnmanageChild(compose->bcc_text);
      XtManageChild(compose->cc_label);
      XtManageChild(compose->cc_text);
    }
  }
  return;
}


#ifdef __STDC__
char *iso_encode_subject(char *s)
#else
char *iso_encode_subject(s)
     char *s;
#endif
{
  unsigned char *ptr;
  Boolean needs_encoding = FALSE;
  char *ret;
  int linelen = 0;
  char buffer[80];

  if((strcasecmp(preferences.charset,US_ASCII_STR)) == STRMATCH)
    return(cpystr(s));
  for(ptr = (unsigned char *) s; *ptr; ptr ++)
    if(*ptr >= 0x80)
      needs_encoding = TRUE;
  if(needs_encoding == FALSE)
    return(cpystr(s));

  ret = (char *) fs_get((strlen(s) * 5) + 128);
  sprintf(buffer,"=?%s?Q?",preferences.charset);
  linelen = strlen(buffer);
  strcpy(ret,buffer);
  ptr = (unsigned char *) s;
  while((*(ptr)) != NUL_TERM) {
    if((linelen > 70) && ((*(ptr +1)) != NUL_TERM)) {
      strcat(ret,"?=\n ");
      strcat(ret,buffer);
      linelen = strlen(buffer + 1);
    }
    if(*ptr == SPACECHAR) {
      strcat(ret,"_");
      linelen ++;
      ptr ++;
      continue;
    }
    if((*ptr == '?') || (*ptr == '=') || (*ptr == '_') || (*ptr >= 0x80)) {
      strcat(ret,qhexstr((int) *ptr));
      linelen += 3;
      ptr ++;
      continue;
    }
    strncat(ret,(char *) ptr,1);
    linelen ++;
    ptr ++;
  }
  strcat(ret,"?=");
  return(ret);
}


#ifdef __STDC__
void iso_encode_address(ADDRESS *ad)
#else
void iso_encode_address(ad)
     ADDRESS *ad;
#endif
{

  ADDRESS *curr;
  unsigned char *ptr;
  Boolean needs_encoding = FALSE;
  Boolean in_encoding    = FALSE;
  char *ret;
  unsigned char *comment;
  unsigned char *end_comment;

  int linelen = 0;
  char buffer[80];

  if((strcasecmp(preferences.charset,US_ASCII_STR)) == STRMATCH)
    return;

  for(curr = ad; curr; curr = curr->next) {
    if(curr->personal == NULL)
      continue;
    for(ptr = (unsigned char *) curr->personal; *ptr; ptr++)
      if(*ptr > 0x80)
	needs_encoding = TRUE;
    if(needs_encoding == FALSE)
      continue;

    ret = (char *) fs_get((strlen(curr->personal) * 5) + 128);
    sprintf(buffer,"=?%s?Q?",preferences.charset);

    ptr = (unsigned char *) curr->personal;

    comment = (unsigned char *) strchr((char *) ptr,'(');
    if(comment)
      end_comment = (unsigned char *) strchr((char *) comment,')');

    if(comment == ptr) {
      in_encoding = FALSE;
      linelen = 0;
    }    
    else {
      strcpy(ret,buffer);
      in_encoding = TRUE;
      linelen = strlen(buffer);
    }
    
    while((*(ptr)) != NUL_TERM) {
      if(ptr == comment) {
	if(in_encoding) {
	  strcat(ret,"?= ( ");
	  linelen += 5;
	  in_encoding = FALSE;
	}
	else {
	  strcat(ret," ( ");
	  linelen += 3;
	}
      }
      if(ptr == end_comment) {
	if(in_encoding) {
	  strcat(ret, "?=  ) ");
	  linelen += 5;
	  in_encoding = FALSE;
	}
	else {
	  strcat(ret, " ) ");
	  linelen += 3;
	}
      }
      if((linelen > 70) && ((*(ptr +1)) != NUL_TERM)) {
	if(in_encoding) {
	  strcat(ret,"?=\n ");
	  strcat(ret,buffer);
	  linelen = strlen(buffer + 1);
	}
	else {
	  strcat(ret,"\n ");
	  linelen = 2;
	}
      }
      
      if(*ptr == SPACECHAR) {
	strcat(ret,"_");
	linelen ++;
	ptr ++;
	continue;
      }
      
      if((!isalnum(*ptr)) || (*ptr >= 0x80)) {
	strcat(ret,qhexstr((int) *ptr));
	linelen += 3;
	ptr ++;
	continue;
      }
      strncat(ret,(char *) ptr,1);
      linelen ++;
      ptr ++;
    }
    if(in_encoding)
      strcat(ret,"?= ");
    fs_give((void **) &curr->personal);
    curr->personal = ret;
  }
  return;
}


/* Not necessarily efficient, but it does the job. */

static char qhexbuffer[4];

#ifdef __STDC__
char *qhexstr(int c)
#else
char *qhexstr(c)
  int c;
#endif
{
  sprintf(qhexbuffer,"=%02X",c);
  return(qhexbuffer);
}

#ifdef __STDC__
struct mail_body_parameter *copy_params(struct mail_body_parameter *src)
#else
struct mail_body_parameter *copy_params(src)
     struct mail_body_parameter *src;
#endif
{
  struct mail_body_parameter  *curr;
  struct mail_body_parameter *new;
  struct mail_body_parameter *prev = NULL;
  struct mail_body_parameter *ret = NULL;

  if(src == NULL)
    return(NULL);

  for(curr = src; curr; curr = curr->next) {
    new = mail_newbody_parameter();
    new->attribute = cpystr(curr->attribute);
    new->value = cpystr(curr->value);
    if(ret == NULL)
      ret = new;
    if(prev)
      prev->next = new;
    prev = new;
  }

  return(ret);
}


/*
 * This is a fat function, and does almost all the dirty work. When it 
 * comes back, the message should be on its way.
 *
 * It takes a compose structure which
 * points to an open compose window, extracts the stuff from
 * the windows (which are presumably more current than the Compose_Info
 * structures), connects any attachments, and sends it off. It also 
 * determines whether it is appropriate to send news, mail or both.
 * On success, the current session is killed; the compose window is 
 * restored to any previous (or next) composings, or otherwise closes 
 * the window. On failure the message is left intact so the user can 
 * take some form of action to correct the condition, or perhaps save 
 * the work, or whatever.
 */

#ifdef __STDC__
void send_message(Widget w, Compose *compose, XtPointer xp)
#else
void send_message(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{

  SMTPSTREAM *smtp_stream = NIL;
  SMTPSTREAM *nntp_stream = NIL;
  ENVELOPE *envelope = NULL;
  ENVELOPE *news_envelope = NULL;
  BODY *body = NULL;
  BODY *currbody = NULL;
  PART *part = NULL;
  char **mailhosts = NULL;
  char **newshosts = NULL;
  Boolean intl     = FALSE;
  char *chk;
  unsigned long len;
  char *default_host = NULL;
  long openflags = 0L;

  Boolean sendnews    = FALSE;
  Boolean sendmail    = TRUE;
  Boolean retry       = compose->current->keep_open;
  Boolean attach_text = FALSE;
  char *from          = NULL;
  char *to            = NULL;
  char *newsgroups    = NULL;
  char *subject       = NULL;
  char *cc            = NULL;
  char *bcc           = NULL;
  char *temp_text     = NULL;
  char *text          = NULL;
  char *fixed_subject = NULL;
  char msgno_string[32];

  int errors          = 0;

  if((preferences.default_domain != NULL) 
     && (*preferences.default_domain != NUL_TERM))
    default_host = cpystr(preferences.default_domain);
  else {
    if((preferences.imap_server != NULL)
       && (*preferences.imap_server != NUL_TERM))
      default_host = cpystr(preferences.imap_server);
    else
      default_host = cpystr(EMPTYSTR); /* And you're asking for trouble... */
  }

  push_cursor(WATCH_CURSOR);

  if(! default_host)
    default_host = cpystr(EMPTYSTR);

  mailhosts = (char **) fs_get( 2 * sizeof(char *));
  mailhosts[0] = cpystr(preferences.smtp_server);
  mailhosts[1] = NULL;

  newshosts = (char **) fs_get( 2 * sizeof(char *));
  newshosts[0] = cpystr(preferences.nntp_server);
  newshosts[1] = NULL;

  from       = cpystr(compose->current->from);
  newsgroups = GetTextField(compose->ng_text);
  to         = GetTextField(compose->to_text);
  subject    = GetTextField(compose->subject_text);
  cc         = GetTextField(compose->cc_text);
  bcc        = GetTextField(compose->bcc_text);
  text       = XmTextGetString(compose->compose_text);

  /* See if the text has iso chars we might need to encode */

  for(chk = text; (*chk != NUL_TERM) ; chk ++ ) 
    if(((unsigned char) *chk) >= (unsigned char) 0x80)
      intl = TRUE;


  /* 
   * Do two conversions. First translate paragraphs to LF terminated
   * text. Then turn LF to CRLF for sending. The reason for doing this
   * in two steps is so we can allocate approximately the right amount 
   * of space in each function, and not have to overkill the memory 
   * requirements. It also compartmentalizes the functionality.
   *
   */

  if(compose->current->wrap == TRUE)
    temp_text = wrap_text(text, COMPOSEWIDTH - 1);
  else
    temp_text = cpystr(text);

  fs_give((void **) &text);
  text = lftocrlf(temp_text);
  fs_give((void **) &temp_text);

  if(intl == TRUE)
    temp_text = (char *)
      rfc822_8bit((unsigned char *) text, (unsigned long) strlen(text), &len);
  else
    temp_text = NULL;

  if((newsgroups != NULL) && (*(first_nonwhite(newsgroups)) != NUL_TERM))
    sendnews = TRUE;

  if(   (*(first_nonwhite(to))  == NUL_TERM) 
     && (*(first_nonwhite(cc))  == NUL_TERM) 
     && (*(first_nonwhite(bcc)) == NUL_TERM))
    sendmail = FALSE;

  /* No recipients. Make sure it fails. */
  if((sendnews == FALSE) && (sendmail == FALSE))
    retry = TRUE;

  if(compose->current->watch_send == TRUE)
    openflags |= SOP_DEBUG;

  if(sendnews == TRUE) {
    nntp_stream = nntp_open(newshosts, openflags);
    if(nntp_stream == NIL) {
      mm_log(NNTP_OPEN_ERR, WARN);
      retry = TRUE;
    }
  }

  if(compose->current->send_eight == TRUE)
    openflags |= SOP_ESMTP;

  if(sendmail == TRUE) {
    smtp_stream = smtp_open(mailhosts, openflags);
    if(smtp_stream == NIL) {
      mm_log(SMTP_OPEN_ERR, WARN);
      retry = TRUE;
    }
  }

  /* 
   *  We've got our neccessary stream(s) open. Now build the message.
   */
 
  body = mail_newbody();
  envelope = mail_newenvelope();

  /* Don't send any empty multiparts. Won't work */

  fix_empty_attachments(compose);


  if(compose->current->attachments) {
    body->contents.part = compose->current->attachments;
    body->type = TYPEMULTIPART;
    body->encoding = ENC7BIT;

    /* 
     * Our text portion (if there is one)
     * will become the first part of the multipart 
     */
    
    if(*text != NUL_TERM) {
      attach_text = TRUE;
      part = mail_newbody_part();
      currbody = &(part->body);
      part->next = body->contents.part;
      body->contents.part = part;
    }
    else
      currbody = NULL;
  }
  else   /* Not a multipart. Just the text message. */
    currbody = body;

  /*
   * Attach our text to the body.
   * If we have 8-bit chars, we start off with 8bit encoding
   * for NNTP. After that's sent we'll have to check and perhaps
   * switch to Q-P if desired or the mailstream doesn't support it.
   */

  if(currbody) {
    currbody->type = TYPETEXT;
    currbody->encoding = (intl == TRUE) ? ENC8BIT : ENC7BIT;
    currbody->contents.text = (unsigned char *) text;
    currbody->size.bytes = (unsigned long) strlen((char *) text);
    currbody->parameter = copy_params(compose->current->parameters);
  }

  /*
   * Now build the appropriate envelope(s).
   * Warning: The c-client appears to trash the calling text strings 
   * in rfc822_parse_addr(), which text_to_address() calls... So, don't 
   * parse the same  string twice to get a duplicate. Use copy_address() 
   * instead.
   */

  envelope->from        = text_to_address(from,default_host);
  envelope->to          = text_to_address(to,  default_host);
  envelope->cc          = text_to_address(cc,  default_host);
  envelope->bcc         = text_to_address(bcc, default_host);

  envelope->reply_to    = copy_address(envelope->from); 

  envelope->return_path = mail_newaddr();
  envelope->return_path->mailbox = cpystr(envelope->from->mailbox);
  envelope->return_path->host    = cpystr(envelope->from->host);

  /* 
   * The sender field is our real bonafide Unix name.
   * This is done to thwart forgeries. This address is also used
   * for delivery bounces. Making certain that it can be used for
   * this purpose is a local system administration issue. That is,
   * if incoming SMTP is not allowed on the system, it should be 
   * MX forwarded to a mail hub which can process the errors.
   */

  if(compose->current->compose_type == COMPOSE_REMAIL) {
    envelope->remail = cpystr(compose->current->remail_header);
    body->type = TYPETEXT;
    if(body->subtype)
      fs_give((void **) &body->subtype);
    body->subtype = NULL;
    body->encoding = ENC7BIT;
  }
  else {
    envelope->sender = mail_newaddr();
    envelope->sender->mailbox = cpystr(local_auth.username);
    envelope->sender->host    = cpystr(local_auth.hostname);
  }

  envelope->subject     = cpystr(subject);

  if(compose->current->in_reply_to)
    envelope->in_reply_to = cpystr(compose->current->in_reply_to);

  /* 
   * Generate a message-id and date. Note that we also supply the
   * real Unix credentials here as the second stage of
   * forgery suppression. The preferences references are for my own use
   * when somebody sends in a bug report or complaint about why their
   * buttons are funny. I can tell at a glance what their app-defaults
   * configuration is.
   */

  envelope->message_id = (char *) fs_get(MESSAGE_ID_LENGTH);
  sprintf(envelope->message_id,"<%s-%s.%d.%d.%s@%s>",
	  PROGRAM, MLVERSION, 
	  time(NULL), rand() % 10000, 
	  local_auth.username, local_auth.hostname);

  envelope->date = (char *) fs_get(MESSAGE_ID_LENGTH);
  rfc822_date(envelope->date);


  if((sendnews == TRUE) && (nntp_stream != NIL)) {

    /* 
     * We create a separate envelope for news posts, containing
     * newsgroups line, and stripping out to,cc,bcc. We don't need to,
     * but partitioning like this will prevent older pine clients
     * from reporting "bogus newsgroups". The reasons are amusing if you
     * look closely at c-client/rfc822.c.
     */

    news_envelope = mail_newenvelope();
    news_envelope->from        = copy_address(envelope->from);
    news_envelope->reply_to    = copy_address(envelope->reply_to);
    news_envelope->return_path = copy_address(envelope->return_path);
    news_envelope->sender      = copy_address(envelope->sender);
    news_envelope->subject     = cpystr(envelope->subject);
    news_envelope->message_id  = cpystr(envelope->message_id);
    news_envelope->date        = cpystr(envelope->date);
    news_envelope->newsgroups  = cpystr(newsgroups);
    errors = nntp_mail(nntp_stream, news_envelope, body);
    if(errors != T ) {
      mm_log(NNTP_SEND_ERR,WARN);
      retry = TRUE;
    }
    else
      mm_log(NEWSSENT,NIL);
    smtp_close(nntp_stream);
  }

  if((sendmail == TRUE) && (smtp_stream != NIL)) {

    /* 
     * OK. Now we've got to see if 8-bit text is allowed, and otherwise
     * do some last minute patching of the message if it's got 8-bit
     * text.
     */

    if((intl == TRUE) && (compose->current->send_eight == TRUE)) {
      if(! smtp_stream->ok_8bitmime) {
	mm_log(SEND8DENIED, WARN);
	mm_log(ENCODING_WARN, WARN);
	compose->current->send_eight = FALSE;
      }
    }

    if(compose->current->send_eight == TRUE)
      fs_give((void **) &temp_text);   /* Well, we sure don't need you now */
    else  {
      if((intl == TRUE) && (currbody != NULL)) {
	currbody->encoding = ENCQUOTEDPRINTABLE;
	fs_give((void **) &text);
	currbody->contents.text = (unsigned char *) temp_text;
	currbody->size.bytes = (unsigned long) strlen((char *) temp_text);
      }
      iso_encode_address(envelope->from);
      iso_encode_address(envelope->to);
      iso_encode_address(envelope->cc);
      iso_encode_address(envelope->bcc);
      iso_encode_address(envelope->reply_to);
      iso_encode_address(envelope->return_path);
      if(envelope->subject)
	fs_give((void **) &envelope->subject);
      envelope->subject = iso_encode_subject(subject);
    }

    errors = smtp_mail(smtp_stream,"MAIL", envelope, body);
    if(errors != T ) {
      mm_log(SMTP_SEND_ERR, WARN);
      retry = TRUE;
    }
    else 
      mm_log(MAILSENT,NIL);
    smtp_close(smtp_stream);
  }

  if(retry == FALSE) {
    if((sendnews == TRUE) && (sendmail == TRUE))
      envelope->newsgroups = cpystr(newsgroups);
    log_message(compose, body, envelope);
  }

  if(sendnews == TRUE)
    mail_free_envelope(&news_envelope);
  if(sendmail == TRUE)
    mail_free_envelope(&envelope);

  /* 
   * If the send failed, protect all our attachments. mail_free_body()
   * is recursive. If the first part is our text, we'll let it go,
   * since it will be rebuilt next time through. This also means we
   * don't explicity free it. It will be nuked as a result of
   * mail_free_body().
   */

  if(retry == TRUE) {
    if(attach_text == TRUE) 
      body->contents.part->next = NIL;
    else 
      body->contents.part = NIL;
  }
  else {

    /* Set answered flag on original message if appropriate */

    if(((compose->current->compose_type == COMPOSE_REPLY) ||
       (compose->current->compose_type == COMPOSE_REPLYALL))
       && compose->current->mailstream && compose->current->msgno) {
      sprintf(msgno_string,"%lu",compose->current->msgno);
      push_cursor(WATCH_CURSOR);
      mail_setflag(compose->current->mailstream,
		   msgno_string, ANSWERED_FLAG );
      mm_flags(compose->current->mailstream,
	       compose->current->msgno);

      pop_cursor();
    }
  }

  /*
   * Clean up everything and go home.
   */

  mail_free_body(&body);    /* and therefore our allocated text */

  fs_give((void **) &from);
  fs_give((void **) &to);
  fs_give((void **) &newsgroups);
  fs_give((void **) &subject);
  fs_give((void **) &cc);
  fs_give((void **) &bcc);

  fs_give((void **) &mailhosts[0]);
  fs_give((void **) &mailhosts);
  fs_give((void **) &newshosts[0]);
  fs_give((void **) &newshosts);

  fs_give((void **) &default_host);

  if(retry == FALSE) {
    /*
     * Our attachments are already gone. Make sure we don't
     * free them a second time.
     */
    compose->current->attachments = NIL;
    compose_destroy_current(w,compose,xp);
  }

  pop_cursor();
  return;
}

#ifdef __STDC__
void fix_empty_attachments(Compose *compose)
#else
void fix_empty_attachments(compose)
     Compose *compose;
#endif
{
  Part_List *part_list;
  BODY *body;
  PART *part;
  BODY *newbody;
  Boolean changed = FALSE;
  
  for(part_list = compose->current->part_list;
      part_list; part_list = part_list->next) {
    body = &(part_list->part->body);

    if((body->type == TYPEMULTIPART) && (body->contents.part == NULL)) {
      /* 
       * Somebody tried to send an empty part. It would be rather
       * painful to try and prune it, so we'll gratuitously supply
       * a part for them. Otherwise, the c-client will core dump.
       *
       */
      part = mail_newbody_part();
      body->contents.part = part;
      newbody = &part->body;
      newbody->type = TYPETEXT;
      newbody->encoding = ENC7BIT;
      newbody->description = cpystr(FAKEPART);
      newbody->subtype = cpystr("plain");
      newbody->contents.text = (unsigned char *) cpystr(EMPTYSTR);
      newbody->size.bytes = 0;
      changed = TRUE;
    }
  }
  if(changed == TRUE) {
    mm_log(EMPTYMULTIWARN,WARN);
    make_attachment_list(compose);
  }
  return;
}


#ifdef __STDC__
void log_message(Compose *compose, BODY *body, ENVELOPE *envelope)
#else
void log_message(compose, body, envelope)
     Compose *compose;
     BODY *body;
     ENVELOPE *envelope;
#endif
{
  extern  STRINGDRIVER mail_string;
  STRING bs;
  char *fixedname;
  char *mailboxname;
  char tmp[16 * FILEBUFFLEN];
  char tmpfile[MAXPATHLEN];
  char log[FILEBUFFLEN];
  Binary_Buffer *binary_buffer;
  Boolean same_server = FALSE;
  FILE *fp;

  if(*preferences.sendlog == NUL_TERM)
    return;
  fixedname = fix_mailboxpath(preferences.sendlog);
  mailboxname = format_mailbox_name(preferences.imap_server,
				    fixedname,MAILBOX_TYPE_MAIL);
  fs_give((void **) &fixedname);
  if(preferences.log_full == FALSE) {
    log_short_message(compose,mailboxname,body,envelope);
    return;
  }

  tmpnam(tmpfile);
  if((fp = fopen(tmpfile,"w")) == NULL) {
    sprintf(log,CANNOT_WRITE_FILE,tmpfile);
    mm_log(log,WARN);
    fs_give((void **) &mailboxname);
    return;
  }
  chmod(tmpfile,S_IRWXU);
  rfc822_output(tmp,envelope, body, ml_file_soutr, fp);
  fclose(fp);

  binary_buffer = load_binary_file(tmpfile);
  unlink(tmpfile);

  if(binary_buffer) {
    if(binary_buffer->data) {
      stripcr((char *) binary_buffer->data);
      binary_buffer->length = strlen((char *) binary_buffer->data);
      INIT(&bs,mail_string,binary_buffer->data, binary_buffer->length);
      if((mail_append_full(server_to_mailstream(preferences.imap_server), 
			   mailboxname, NIL, NIL, &bs)) == NIL)
	mm_log(APPEND_FAIL,WARN);
    }
    free_binary_buffer(binary_buffer);
  }
  return;
}

#ifdef __STDC__
long ml_file_soutr(void *stream, char *s)
#else
long ml_file_soutr(stream,s)
     void *stream;
     char *s;
#endif
{
  FILE *fp = stream;
  char c, *t;

  if (s[0] == '.') fputs(".",fp);
				/* find lines beginning with a "." */
  while (t = ML_Strstr (s,"\015\012.")) {
    c = *(t += 3);		/* remember next character after "." */
    *t = '\0';			/* tie off string */
				/* output prefix */
    if ((fputs(s,fp)) == EOF)
      return NIL;
    *t = c;			/* restore delimiter */
    s = t - 1;			/* push pointer up to the "." */
  }
  if(*s) {
    if((fputs(s,fp)) == EOF)
      return(NIL);
    else
      return(T);
  }
  else
    return(T);

}

#ifdef __STDC__
void log_short_message(Compose *compose, char *mailboxname,
		       BODY *body, ENVELOPE *envelope)
#else
void log_short_message(compose, mailboxname, body, envelope)
     Compose *compose;
     char *mailboxname;
     BODY *body;
     ENVELOPE *envelope;
#endif
{
  extern  STRINGDRIVER mail_string;
  STRING bs;
  char *from;
  char *newsgroups;
  char *to;
  char *subject;
  char *cc;
  char *bcc;
  char *text;
  char *date;
  char *temp_text;
  char *bigbuf;
  char *ret;

  from       = cpystr(compose->current->from);
  newsgroups = GetTextField(compose->ng_text);
  to         = GetTextField(compose->to_text);
  subject    = GetTextField(compose->subject_text);
  cc         = GetTextField(compose->cc_text);
  bcc        = GetTextField(compose->bcc_text);
  temp_text  = XmTextGetString(compose->compose_text);
  date = (char *) fs_get(MESSAGE_ID_LENGTH);
  rfc822_date(date);

  if(compose->current->wrap == TRUE)
    text = wrap_text(temp_text, COMPOSEWIDTH - 1);
  else
    text = cpystr(temp_text);

  fs_give((void **) &temp_text);

  bigbuf = (char *) fs_get(  ((from)       ? strlen(from)       : 0) 
			   + ((newsgroups) ? strlen(newsgroups) : 0)
			   + ((to)         ? strlen(to)         : 0)
			   + ((subject)    ? strlen(subject)    : 0)
			   + ((cc)         ? strlen(cc)         : 0)
			   + ((bcc)        ? strlen(bcc)        : 0)
			   + ((date)       ? strlen(date)       : 0)
			   + ((envelope->in_reply_to) ?
			      strlen(envelope->in_reply_to)     : 0)
			   + ((envelope->message_id) ?
			      strlen(envelope->message_id)      : 0)
			   + ((text)       ? strlen(text)       : 0)
			   +                                    512);

  *bigbuf = NUL_TERM;

  if(from) {
    if(*from) {
      strcat(bigbuf,FROM_TEXT);
      strcat(bigbuf,SPACESTR);
      strcat(bigbuf,from);
      strcat(bigbuf,LFSTR);
    }
    fs_give((void **) &from);
  }

  if(newsgroups) {
    if(*newsgroups) {
      strcat(bigbuf,NG_TEXT);
      strcat(bigbuf,SPACESTR);
      strcat(bigbuf,newsgroups);
      strcat(bigbuf,LFSTR);
    }
    fs_give((void **) &newsgroups);
  }
  if(to) {
    if(*to) {
      strcat(bigbuf,TO_TEXT);
      strcat(bigbuf,SPACESTR);
      strcat(bigbuf,to);
      strcat(bigbuf,LFSTR);
    }
    fs_give((void **) &to);
  }
  if(subject) {
    if(*subject) {
      strcat(bigbuf,SUBJECT_TEXT);
      strcat(bigbuf,SPACESTR);
      strcat(bigbuf,subject);
      strcat(bigbuf,LFSTR);
    }
    fs_give((void **) &subject);
  }
  if(cc) {
    if(*cc) {
      strcat(bigbuf,CC_TEXT);
      strcat(bigbuf,SPACESTR);
      strcat(bigbuf,cc);
      strcat(bigbuf,LFSTR);
    }
    fs_give((void **) &cc);
  }
  if(bcc) {
    if(*bcc) {
      strcat(bigbuf,BCC_TEXT);
      strcat(bigbuf,SPACESTR);
      strcat(bigbuf,bcc);
      strcat(bigbuf,LFSTR);
    }
    fs_give((void **) &bcc);
  }
  if(date) {
    if(*date) {
      strcat(bigbuf,DATE_TEXT);
      strcat(bigbuf,SPACESTR);
      strcat(bigbuf,date);
      strcat(bigbuf,LFSTR);
    }
    fs_give((void **) &date);
  }
  if(envelope->in_reply_to) {
    if(*envelope->in_reply_to) {
      strcat(bigbuf,INREP_TEXT);
      strcat(bigbuf,SPACESTR);
      strcat(bigbuf,envelope->in_reply_to);
      strcat(bigbuf,LFSTR);
    }
  }
  if(envelope->message_id) {
    if(*envelope->message_id) {
      strcat(bigbuf,MSGID_TEXT);
      strcat(bigbuf,SPACESTR);
      strcat(bigbuf,envelope->message_id);
      strcat(bigbuf,LFSTR);
    }
  }
  strcat(bigbuf,LFSTR);

  if(text) {
    if(*text) 
      strcat(bigbuf,text);
    strcat(bigbuf,LFSTR);
    fs_give((void **) &text);
  }

  ret = lftocrlf(bigbuf);
  fs_give((void **) &bigbuf);
  if(ret) {
    INIT(&bs,mail_string,ret,strlen(ret));
    if((mail_append_full(server_to_mailstream(preferences.imap_server), 
			 mailboxname, NIL, NIL, &bs)) == NIL)
      mm_log(APPEND_FAIL,WARN);
    fs_give((void **) &ret);
  }

  if(mailboxname)
    fs_give((void **) &mailboxname);
  return;

}

#ifdef __STDC__
char *param_to_str(PARAMETER *parameter)
#else
char *param_to_str(parameter)
     PARAMETER *parameter;
#endif
{
  char buffer[FILEBUFFLEN];
  PARAMETER *p;

  if(parameter == NULL)
    return(cpystr(EMPTYSTR));

  strcpy(buffer,EMPTYSTR);
  for(p = parameter; p; p = p->next) {
    if((p->attribute == NULL) || (p->value == NULL))
      continue;
    if(*buffer != NUL_TERM)
      strcat(buffer,SPACESTR);

    strcat(buffer,p->attribute);
    strcat(buffer,EQUALSTR);
    strcat(buffer,p->value);

  }
  return(cpystr(buffer));
}

#ifdef __STDC__
PARAMETER *str_to_param(char *str)
#else
PARAMETER *str_to_param(str)
     char *str;
#endif
{

  char *p;
  char *ptr;
  char *last = str;
  PARAMETER *parameter = NULL;
  PARAMETER *first     = NULL;
  PARAMETER *lastp     = NULL;
  Boolean reached_end  = FALSE;
  Boolean bad_input    = FALSE;

  if((str == NULL) || (*str == NUL_TERM))
    return(NULL);

  for(ptr = str; *ptr != NUL_TERM ; ptr ++) {
    if(reached_end == TRUE)
      break;
    if(*ptr != EQUALCHAR)
      continue;

    *ptr = NUL_TERM;
    ptr ++;
    parameter = mail_newbody_parameter();
    parameter->attribute = cpystr(last);
    p = ptr;
    if(*p == DQUOTECHAR) {
      p ++;
      while((*p != NUL_TERM) && (*p != DQUOTECHAR))
	p ++;
      while((*p != NUL_TERM) && (*p != SPACECHAR))
	p ++;
    }
    else {
      while ((*p != NUL_TERM) && (*p != SPACECHAR))
	p ++;
    }
    if(*p == NUL_TERM)
      reached_end = TRUE;
    *p = NUL_TERM;
    parameter->value = cpystr(ptr);
    if(first == NULL) {
      first = parameter;
      lastp = parameter;
    }
    else {
      lastp->next = parameter;
      lastp = parameter;
    }
    if(reached_end == TRUE)
      break;
    else {
      last = p + 1;
      ptr = p + 1;
      while((*last != NUL_TERM) && (isspace(*last)))
	last ++;
      if(*last == NUL_TERM)
	break;
    }
  }
  
  /* Now check for bad input.... */
  
  for(parameter = first; parameter != NULL; parameter = parameter->next) {
    if((parameter->attribute == NULL) || (parameter->value == NULL))
      bad_input = TRUE;
  }
  
  if(bad_input) {
    mm_log(INVALID_MAILPARAMS, ERROR);
    mail_free_body_parameter(&first);
  }

  return(first);
}


#ifdef __STDC__
void compose_delete_part(Widget w, Compose *compose, XtPointer xp)
#else
void compose_delete_part(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{

  Part_List *part_list;
  BODY *body = NULL;

  if((compose->current->selection == 0) 
     || (compose->current->part_list == NULL))
    return;
  
  /* point to the Part_List of the selected part.*/

  for(part_list = compose->current->part_list; 
      part_list->partnumber != compose->current->selection; 
      part_list = part_list->next);
    

  /* First see if it's a multipart which still has contents */

  body = &(part_list->part->body);
  if(body->type == TYPEMULTIPART 
     && (body->contents.part != NULL)) {
    mm_log(MULTI_NOT_EMPTY, WARN);
    return;
  }

  /* first part in our attachment list */

  if(part_list->part == compose->current->attachments) {
    compose->current->attachments = part_list->part->next;
    part_list->part->next = NULL;
    mail_free_body_part(&part_list->part);
    make_attachment_list(compose);
    return;
  }

  /* Some other part. See if our previous neighbor points to us. */

  if((part_list->prev) && (part_list->prev->part->next == part_list->part)) {
    part_list->prev->part->next = part_list->part->next;
    part_list->part->next = NULL;
  }
  else {
    /* Hmmm. Heirarchical. Find the parent. */
    body = (part_list->prev) ? &(part_list->prev->part->body) : NULL;
    if((body) && (body->type == TYPEMULTIPART))
      body->contents.part = part_list->part->next;
    part_list->part->next = NULL;
  }

  mail_free_body_part(&part_list->part);
  make_attachment_list(compose);
  return;
}


/* 
 * Callback when an item in the attachment list is selected. 
 */

#ifdef __STDC__
void select_attach(Widget w, Compose *compose, XmListCallbackStruct *xp)
#else
void select_attach(w,compose,xp)
     Widget w;
     Compose *compose;
     XmListCallbackStruct *xp;
#endif
{
    
  if(xp->item_position == compose->current->selection) {
    compose->current->selection = 0;
    compose->current->button_state |= BTN_NOATTACHSELECT;
  }
  else {
    compose->current->selection = xp->item_position;
    compose->current->button_state &= ~(BTN_NOATTACHSELECT);
  }
  
  check_buttons(compose_menu,XtNumber(compose_menu),
		session.buttons[COMPOSE_BTN_MENU], 
		compose->current->button_state);
  return;
}


#ifdef __STDC__
void double_click_attach(Widget w, Compose *compose, XmListCallbackStruct *xp)
#else
void double_click_attach(w,compose,xp)
     Widget w;
     Compose *compose;
     XmListCallbackStruct *xp;
#endif
{
  Part_List *part_list;
  BODY *body;

  if(! xp->item_position)
    return;

  for(part_list = compose->current->part_list; 
      part_list && part_list->partnumber != xp->item_position; 
      part_list = part_list->next);

  if(! part_list)
    return;

  /* Make sure the window shows it as selected */

  XmListDeselectAllItems(compose->compose_attach);
  compose->current->selection = xp->item_position;
  compose->current->button_state &= ~(BTN_NOATTACHSELECT);
  XmListSelectPos(compose->compose_attach,xp->item_position,FALSE);


  check_buttons(compose_menu,XtNumber(compose_menu),
		session.buttons[COMPOSE_BTN_MENU], 
		compose->current->button_state);

  body = &(part_list->part->body);

  /* invoke message handler */

  show_mime(compose->shell, body);
  return;
}


#ifdef __STDC__
void make_attachment_list(Compose *compose)
#else
void make_attachment_list(compose)
     Compose *compose;
#endif
{
  if(! compose->current)
    return;

  /* Erase current list contents and start over */

  XmListDeselectAllItems(compose->compose_attach);
  XmListDeleteAllItems(compose->compose_attach); 

  compose->current->selection = 0;
  compose->current->button_state |= BTN_NOATTACHSELECT;

  /* No contents. Check buttons and get outa' here */

  if(compose->current->attachments == NULL) { 
    compose->current->button_state |= BTN_NOATTACH;
    check_buttons(compose_menu,XtNumber(compose_menu),
		  session.buttons[COMPOSE_BTN_MENU], 
		  compose->current->button_state);
    return;
  }

  if(compose->current->part_list) {
    destroy_part_list(compose->current->part_list);
  }

  compose->current->part_list = NULL;

  /* 
   * Recursively add strings to the attachment list widget 
   * and add to our part_list structure. We use this to look up
   * specific parts from the list management functions without having
   * to go through all this recursive hullabaloo all over again.
   */

  add_attach_strings(compose->compose_attach, compose,
		     compose->current->attachments,0);

  compose->current->button_state &= ~(BTN_NOATTACH);
  check_buttons(compose_menu,XtNumber(compose_menu),
		session.buttons[COMPOSE_BTN_MENU], 
		compose->current->button_state);

  return;
}

#ifdef __STDC__
void destroy_part_list(Part_List *part_list)
#else
void destroy_part_list(part_list)
  Part_List *part_list;
#endif
{
  if(part_list == NULL)
    return;
  destroy_part_list(part_list->next);
  if(part_list->partstr)
    fs_give((void **) &part_list->partstr);
  fs_give((void **) &part_list);
  part_list = NULL;
  return;
}


#ifdef __STDC__
void add_attach_strings(Widget w, Compose *compose, PART *part, int level)
#else
void add_attach_strings(w,compose,part,level)
     Widget w;
     Compose *compose;
     PART *part;
     int level;
#endif
{
  int len;
  PART *curr;
  char buffer[FILEBUFFLEN];
  XmString xstr;
  Part_List *part_list;
  Part_List *curr_part_list;
  struct mail_body_parameter *params;

  if(part == NULL)
    return;

  for(curr = part; curr; curr = curr->next) {
    strcpy(buffer,EMPTYSTR);
    for(len = 0; len < level; len ++)
      strcat(buffer,SPACESTR);
    strcat(buffer,type_to_name(curr->body.type));
    strcat(buffer,TYPE_SEPARATOR_STR);
    strcat(buffer,(curr->body.subtype) ? curr->body.subtype : NOSUBTYPE );
    for(len = strlen(buffer); len < (COMPOSEWIDTH/2); len ++)
      strcat(buffer,SPACESTR);
    strncat(buffer,
	   (curr->body.description) ? curr->body.description : EMPTYSTR,
	    COMPOSEWIDTH);
    buffer[COMPOSEWIDTH - 2] = NUL_TERM;
    for(params = curr->body.parameter; 
	params; params = params->next) {
      if((int) (strlen(buffer) + strlen(params->attribute) 
	  + strlen(params->value) + 2) >= FILEBUFFLEN)
	break;
      strcat(buffer,SPACESTR);
      strcat(buffer,params->attribute);
      strcat(buffer,"=");
      strcat(buffer,params->value);
    }

    xstr = XmStringCreateSimple(buffer);
    XmListAddItemUnselected(w,xstr,0);
    XmStringFree(xstr);
    
    part_list = (Part_List *) fs_get(sizeof(Part_List));
    part_list->next = NULL;
    part_list->part = curr;
    part_list->partstr = NULL;

    if(compose->current->part_list == NULL) {
      compose->current->part_list = part_list;
      part_list->partnumber = 1;
      part_list->prev = NULL;
    }
    else {
      for(curr_part_list = compose->current->part_list; curr_part_list->next;
	curr_part_list = curr_part_list->next);

      curr_part_list->next = part_list;
      part_list->prev = curr_part_list;
      part_list->partnumber = curr_part_list->partnumber + 1;
    }

    if(curr->body.type == TYPEMULTIPART)
      add_attach_strings(w,compose,curr->body.contents.part,level+1);

  }
  return;
}

/*
 * Generate and display the compose window.
 */


#ifdef __STDC__
void create_compose_window(Compose *compose,int behaviour, int ccbehaviour)
#else
void create_compose_window(compose,behaviour, ccbehaviour)
     Compose *compose;
     int behaviour;
     int ccbehaviour;
#endif
{

  Arg args[ARGLISTSIZE];
  int n = 0;

  /* These widgets we don't need to keep. */

  Widget menubar, label2, label3, label4;

  XtTranslations translations;

  compose->shell = XtAppCreateShell("MLcompose", "MLcompose",
				  topLevelShellWidgetClass,
				  display, args, n ); 
  n = 0;

  setup_editres(compose->shell);

  if(compose_icon != (Pixmap) None)
    XtVaSetValues(compose->shell,
		  XmNiconPixmap,compose_icon,
		  NULL);

  compose->form = XmCreateForm(compose->shell, "form", args, n); n = 0;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  menubar = XmCreateMenuBar(compose->form,"menubar", args, n); n = 0;
  XtManageChild(menubar);
  create_buttons(NULL, menubar,compose_menu, XtNumber(compose_menu), 
		      BTN_ON, (XtPointer) compose, ROOTMENULEVEL);


  XtSetArg(args[n], XmNtopAttachment,   XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, menubar);  n ++;
  XtSetArg(args[n], XmNleftAttachment,  XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n ++;
  XtSetArg(args[n], XmNpacking, XmPACK_TIGHT); n ++;
  compose->rowcol = XmCreateRowColumn(compose->form, "rowcol", args, n); n = 0;
  XtManageChild(compose->rowcol);


  compose_default_buttons();

  make_pbuttons(compose->rowcol, session.buttons[COMPOSE_BTN_MENU], 
		BTN_ON, (XtPointer) compose);
		

  XtSetArg(args[n], XmNtraversalOn, FALSE); n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, compose->rowcol); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNborderWidth, 0); n ++;
  compose->to_label = XmCreatePushButton(compose->form,"to_lbl", args, n); 
  n = 0;


  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, compose->rowcol); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNleftWidget,compose->to_label); n ++;
  compose->to_text = XmCreateTextField(compose->form,
				       "to_textfld", args, n); n = 0;

  XtSetArg(args[n], XmNtraversalOn, FALSE); n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, compose->rowcol); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNborderWidth, 0); n ++;
  compose->ng_label = XmCreatePushButton(compose->form,"ng_lbl", 
				    args, n); 
  n = 0;

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, compose->rowcol); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNleftWidget,compose->ng_label); n ++;
  compose->ng_text = XmCreateTextField(compose->form,"ng_textfld", 
				       args, n); n = 0;

  translations = XtParseTranslationTable(GLOBAL_text_field_translations);
  XtOverrideTranslations(compose->to_text,translations);
  translations = 
    XtParseTranslationTable(GLOBAL_nonterminal_text_field_translations);
  XtOverrideTranslations(compose->to_text,translations);
  translations =
    XtParseTranslationTable(compose_address_translations);
  XtOverrideTranslations(compose->to_text,translations);


  XtAddCallback(compose->to_text, XmNmodifyVerifyCallback, 
		(XtCallbackProc) text_field_edit, NULL);

  translations = XtParseTranslationTable(GLOBAL_text_field_translations);
  XtOverrideTranslations(compose->ng_text,translations);
  translations = 
    XtParseTranslationTable(GLOBAL_nonterminal_text_field_translations);
  XtOverrideTranslations(compose->ng_text,translations);
  translations =
    XtParseTranslationTable(compose_address_translations);
  XtOverrideTranslations(compose->ng_text,translations);


  XtAddCallback(compose->ng_text, XmNmodifyVerifyCallback, 
		(XtCallbackProc) text_field_edit, NULL);

  XtAddCallback(compose->ng_label, XmNactivateCallback,
		(XtCallbackProc) compose_toggle_news, compose );

  XtAddCallback(compose->to_label, XmNactivateCallback,
		(XtCallbackProc) compose_toggle_news, compose );

  switch(behaviour) {
  case NEWS_BEHAVIOUR:
    XtManageChild(compose->ng_label);
    XtManageChild(compose->ng_text);
    break;
  case MAIL_BEHAVIOUR:
  default:
    XtManageChild(compose->to_label);
    XtManageChild(compose->to_text);
    break;
  }

  XtSetArg(args[n], XmNtraversalOn, FALSE); n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, compose->to_text); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNborderWidth, 0); n ++;

  label2 = XmCreatePushButton(compose->form,"subject_lbl", args, n); n = 0;
  XtManageChild(label2);

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, compose->to_text); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNleftWidget,label2); n ++;
  compose->subject_text = XmCreateTextField(compose->form,
					    "subject_textfld", 
					    args, n);
                                              n = 0;
  XtManageChild(compose->subject_text);

  translations = XtParseTranslationTable(GLOBAL_text_field_translations);
  XtOverrideTranslations(compose->subject_text,translations);
  translations = 
    XtParseTranslationTable(GLOBAL_nonterminal_text_field_translations);
  XtOverrideTranslations(compose->subject_text,translations);

  XtAddCallback(compose->subject_text, XmNmodifyVerifyCallback, 
		(XtCallbackProc) text_field_edit, NULL);

  XtAddCallback(label2, XmNactivateCallback,
		(XtCallbackProc) generate_subject, compose );

  XtSetArg(args[n], XmNtraversalOn, FALSE); n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, compose->subject_text); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNborderWidth, 0); n ++;

  compose->cc_label = XmCreatePushButton(compose->form,"cc_lbl", args, n); 
  n = 0;

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, compose->subject_text); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNleftWidget,compose->cc_label); n ++;
  compose->cc_text = XmCreateTextField(compose->form,
				       "cc_textfld", args, n); n = 0;

  translations = XtParseTranslationTable(GLOBAL_text_field_translations);
  XtOverrideTranslations(compose->cc_text,translations);
  translations = 
    XtParseTranslationTable(GLOBAL_nonterminal_text_field_translations);
  XtOverrideTranslations(compose->cc_text,translations);
  translations =
    XtParseTranslationTable(compose_address_translations);
  XtOverrideTranslations(compose->cc_text,translations);

  XtAddCallback(compose->cc_text, XmNmodifyVerifyCallback, 
		(XtCallbackProc) text_field_edit, NULL);

  XtSetArg(args[n], XmNtraversalOn, FALSE); n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);   n ++;
  XtSetArg(args[n], XmNtopWidget, compose->subject_text); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);    n ++;
  XtSetArg(args[n], XmNborderWidth, 0); n ++;

  compose->bcc_label = XmCreatePushButton(compose->form,"bcc_lbl", args, n); 
  n = 0;

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, compose->subject_text); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNleftWidget,compose->bcc_label); n ++;
  compose->bcc_text = XmCreateTextField(compose->form,
					"bcc_textfld", args, n); n = 0;

  translations = XtParseTranslationTable(GLOBAL_text_field_translations);
  XtOverrideTranslations(compose->bcc_text,translations);
  translations = 
    XtParseTranslationTable(GLOBAL_nonterminal_text_field_translations);
  XtOverrideTranslations(compose->bcc_text,translations);
  translations =
    XtParseTranslationTable(compose_address_translations);
  XtOverrideTranslations(compose->bcc_text,translations);

  XtAddCallback(compose->bcc_text, XmNmodifyVerifyCallback, 
		(XtCallbackProc) text_field_edit, NULL);

  XtAddCallback(compose->cc_label, XmNactivateCallback,
		(XtCallbackProc) compose_toggle_cc, compose );

  XtAddCallback(compose->bcc_label, XmNactivateCallback,
		(XtCallbackProc) compose_toggle_cc, compose );

  XtManageChild(compose->cc_label);
  XtManageChild(compose->cc_text);

  XtSetArg(args[n], XmNnavigationType,XmNONE);                  n ++;
  XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmSTATIC);       n ++;
  XtSetArg(args[n], XmNlistSizePolicy,XmVARIABLE);              n ++;
  XtSetArg(args[n], XmNselectionPolicy,XmSINGLE_SELECT);        n ++;
  compose->compose_attach = 
    XmCreateScrolledList(compose->form,"partlist",args,n);      n = 0;
  XtAddCallback(compose->compose_attach,
		XmNsingleSelectionCallback, 
		(XtCallbackProc) select_attach, compose);
  XtAddCallback(compose->compose_attach,
		XmNdefaultActionCallback, 
		(XtCallbackProc) double_click_attach, compose);

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);         n ++;
  XtSetArg(args[n], XmNtopWidget, compose->cc_text);           n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);          n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);         n ++;

  XtSetValues(XtParent(compose->compose_attach), args, n); n = 0;
  XtManageChild(compose->compose_attach); 

  XtSetArg(args[n], XmNeditable, TRUE);                         n ++;
  XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT);            n ++;
  XtSetArg(args[n], XmNwordWrap, TRUE);                         n ++;
  if(preferences.compose_height) {
    XtSetArg(args[n], XmNrows,     preferences.compose_height); n ++;
  }
  XtSetArg(args[n], XmNcolumns,  COMPOSEWIDTH - 1);             n ++;
  XtSetArg(args[n], XmNscrollVertical, TRUE);                   n ++; 
  XtSetArg(args[n], XmNscrollHorizontal, FALSE );               n ++;

  compose->compose_text =
    XmCreateScrolledText(compose->form, "text", args, n);    n = 0;
  
  translations = XtParseTranslationTable(GLOBAL_text_translations);
  XtOverrideTranslations(compose->compose_text, translations);

  XtAddCallback(compose->compose_text, XmNmodifyVerifyCallback, 
		(XtCallbackProc) text_hex_edit, NULL);


  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);         n ++;
  XtSetArg(args[n], XmNtopWidget, compose->compose_attach);     n ++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM);        n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);          n ++;

  XtSetValues(XtParent(compose->compose_text), args, n);        n = 0;
  XtManageChild(compose->compose_text);

  XtAddCallback(compose->shell, XmNdestroyCallback, 
		(XtCallbackProc) compose_destroy, compose);

  XtManageChild(compose->form);
  XtRealizeWidget(compose->shell);
  compose->is_realized = TRUE;
  return;
}

#ifdef __STDC__
void compose_insert_file(Widget w, Compose *compose, XtPointer xp)
#else
void compose_insert_file(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  char *filename;
  Binary_Buffer *binary_buffer;

  filename = file_select(compose->shell, NULL, NULL, NULL, FALSE, NULL);
  if(filename == NULL)
     return;
  
  push_cursor(WATCH_CURSOR);

  binary_buffer = load_binary_file(filename);
  if(binary_buffer) {
    text_blast(compose->compose_text,(char *)binary_buffer->data);
    free_binary_buffer(binary_buffer);
  }

  fs_give((void **) &filename);
  pop_cursor();
  return;
}



#ifdef __STDC__
void compose_wrap_off(Widget w, Compose *compose, XtPointer xp)
#else
void compose_wrap_off(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  XtTranslations translations;
  char *str = NULL;

  if(compose->current)
    compose->current->wrap = FALSE;

  str  = XmTextGetString(compose->compose_text);

  XtDestroyWidget(compose->compose_text);


  XtSetArg(args[n], XmNeditable, TRUE);                         n ++;
  XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT);            n ++;
  XtSetArg(args[n], XmNwordWrap, FALSE);                        n ++;
  XtSetArg(args[n], XmNrows,     preferences.compose_height);   n ++;
  XtSetArg(args[n], XmNcolumns,  COMPOSEWIDTH - 1);             n ++;
  XtSetArg(args[n], XmNscrollVertical, TRUE);                   n ++; 
  XtSetArg(args[n], XmNscrollHorizontal, TRUE );                n ++;

  compose->compose_text =
    XmCreateScrolledText(compose->form, "compose_text", args, n);        n = 0;
  
  translations = XtParseTranslationTable(GLOBAL_text_translations);
  XtOverrideTranslations(compose->compose_text, translations);

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);         n ++;
  XtSetArg(args[n], XmNtopWidget, compose->compose_attach);     n ++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM);        n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);          n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);         n ++;
  XtSetValues(XtParent(compose->compose_text), args, n);        n = 0;
  XtManageChild(compose->compose_text);

  XmTextSetString(compose->compose_text, str);
  fs_give((void **) &str);

  XFlush(display);
  return;
}

#ifdef __STDC__
void compose_wrap_on(Widget w, Compose *compose, XtPointer xp)
#else
void compose_wrap_on(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  char *str = NULL;
  XtTranslations translations;

  if(compose->current)
    compose->current->wrap = FALSE;

  str  = XmTextGetString(compose->compose_text);

  XtDestroyWidget(compose->compose_text);


  XtSetArg(args[n], XmNeditable, TRUE);                         n ++;
  XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT);            n ++;
  XtSetArg(args[n], XmNwordWrap, TRUE);                         n ++;
  XtSetArg(args[n], XmNrows,     preferences.compose_height);   n ++;
  XtSetArg(args[n], XmNcolumns,  COMPOSEWIDTH - 1);             n ++;
  XtSetArg(args[n], XmNscrollVertical, TRUE);                   n ++; 
  XtSetArg(args[n], XmNscrollHorizontal, FALSE );               n ++;

  compose->compose_text =
    XmCreateScrolledText(compose->form, "compose_text", args, n);   n = 0;
  
  translations = XtParseTranslationTable(GLOBAL_text_translations);
  XtOverrideTranslations(compose->compose_text, translations);

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET);         n ++;
  XtSetArg(args[n], XmNtopWidget, compose->compose_attach);     n ++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM);        n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);          n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_NONE);         n ++;
  XtSetValues(XtParent(compose->compose_text), args, n);        n = 0;
  XtManageChild(compose->compose_text);

  XmTextSetString(compose->compose_text, str);
  fs_give((void **) &str);

  XFlush(display);

  if(compose->current)
    compose->current->wrap = TRUE;

  XtSetArg(args[n], XmNwordWrap, TRUE);                        n ++;
  XtSetArg(args[n], XmNscrollHorizontal, FALSE );                n ++;

  XtSetValues(compose->compose_text, args, n); n = 0;


  XtSetArg(args[n], XmNrightAttachment, XmATTACH_NONE);         n ++;
  XtSetValues(XtParent(compose->compose_text), args, n);        n = 0;
  XFlush(display);
  return;
}


/* 
 * Append signature file into current text window and call 
 * send_message(). We throw in an extra linefeed between the two
 * just in case the last line of the message doesn't have one.
 */


#ifdef __STDC__
void compose_send_autograph(Widget w, Compose *compose, XtPointer xp)
#else
void compose_send_autograph(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  FILE *fp;
  char *filename;
  char buffer[FILEBUFFLEN];

  filename = cpystr(preferences.signature_file);
  
  if((*filename != NUL_TERM) && (fp = fopen(filename,"r")) != NULL) {
    AppendText(compose->compose_text,LFSTR);
    while((fgets(buffer,sizeof(buffer),fp)) != NULL)
      AppendText(compose->compose_text,buffer);
    fclose(fp);
  }
  fs_give((void **) &filename);
  send_message(w,compose,xp);
  return;
}



#ifdef __STDC__
void compose_attach_file(Widget w, Compose *compose, XtPointer xp)
#else
void compose_attach_file(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  char *filename = NULL;
  Binary_Buffer *binary_buffer;
  PART *part;
  BODY *body;
  Boolean auto_attach;
  Boolean keep_going;

  filename = file_select(compose->shell, NULL, NULL, NULL, FALSE, NULL);
  if(filename == NULL)
     return;

  binary_buffer = load_binary_file(filename);

  if(binary_buffer) {

    part = mail_newbody_part();
    body = &part->body;

    set_default_attach_type(body,filename);

    if((auto_attach = get_type_from_suffix(body,filename)) == FALSE)
      keep_going = create_mime_attach_window(compose->shell,body,FALSE);
  
    if(auto_attach || keep_going)
      link_attachment(compose,part,body,binary_buffer); 
    else 
      mail_free_body_part(&part);

    free_binary_buffer(binary_buffer);

  }

  fs_give((void **) &filename);
  return;
}

#ifdef __STDC__
void compose_attach_multi(Widget w, Compose *compose, XtPointer xp)
#else
void compose_attach_multi(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  PART *part;
  BODY *body;


  part = mail_newbody_part();
  body = &part->body;
  
  body->type = TYPEMULTIPART;
  body->subtype = cpystr("mixed");

  if(create_mime_attach_window(compose->shell,body,TRUE))
    link_attachment(compose,part,body,NULL);
  else
    mail_free_body_part(&part);
  return;
}


#ifdef __STDC__
void compose_createattach(Widget w, Compose *compose, XtPointer xp)
#else
void compose_createattach(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  PART *part;
  BODY *body;
  Binary_Buffer *binary_buffer; 

  part = mail_newbody_part();
  body = &part->body;
  
  binary_buffer = create_mime_compose_window(compose->shell,body);

  if(binary_buffer) {
    link_attachment(compose,part,body,binary_buffer);
    free_binary_buffer(binary_buffer);
  }
  else
    mail_free_body_part(&part);
  return;
}




#ifdef __STDC__
void compose_window_list(Widget w, Compose *compose, XtPointer xp)
#else
void compose_window_list(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;

  XtTranslations translations;
  Widget form, menubar, dummy;

  if(compose->list_is_realized) {
    de_iconify(compose->list_shell);
    return;
  }

  compose->list_shell = XtAppCreateShell("MLcomposelist", "MLcomposelist",
				       topLevelShellWidgetClass,
				       display, args, n ); 
  n = 0;

  setup_editres(compose->list_shell);

  if(list_icon != (Pixmap) None)
    XtVaSetValues(compose->list_shell,
		  XmNiconPixmap,list_icon,
		  NULL);

  form = XmCreateForm(compose->list_shell, "form", args, n); 
  n = 0;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  menubar = XmCreateMenuBar(form,"menubar", args, n); n = 0;
  XtManageChild(menubar);
  create_buttons(NULL, menubar,compose_list_menu, 
		 XtNumber(compose_list_menu), 
		 BTN_ON, (XtPointer) compose, ROOTMENULEVEL);

  /* An invisible text field. This is used only to set the width. */

  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  dummy = XmCreateTextField(form,"dummy", args, n); n = 0;
  XtManageChild(dummy);

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, menubar); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n ++;
  
  XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmSTATIC); n ++;
  XtSetArg(args[n], XmNlistSizePolicy,XmCONSTANT); n ++;
  XtSetArg(args[n], XmNselectionPolicy,XmSINGLE_SELECT); n ++;
  compose->list_list = 
    XmCreateScrolledList(form,"list",args,n); n = 0;
  XtAddCallback(compose->list_list,
		XmNsingleSelectionCallback, 
		(XtCallbackProc) compose_list_select, compose);
  XtAddCallback(compose->list_list,
		XmNdefaultActionCallback, 
		(XtCallbackProc) compose_list_double, compose);

  XtAddCallback(compose->list_shell,
		XmNdestroyCallback, 
		(XtCallbackProc) compose_list_destroy, compose);
 
  translations = 
    XtParseTranslationTable(GLOBAL_modal_list_translations);
  XtOverrideTranslations(compose->list_list,translations);
  stuff_compose_window_list(compose, FALSE);

  XtManageChild(compose->list_list); 
  XtManageChild(form);
  XtRealizeWidget(compose->list_shell);
  compose->list_is_realized = TRUE;
  return;
}


#ifdef __STDC__
void compose_list_select(Widget w, Compose *compose, XmListCallbackStruct *xp)
#else
void compose_list_select(w,compose,xp)
     Widget w;
     Compose *compose;
     XmListCallbackStruct *xp;
#endif
{
  Compose_Info *compose_info;

  if(compose->is_realized == FALSE)
    create_compose_window(compose, MAIL_BEHAVIOUR, CC_BEHAVIOUR);
  de_iconify(compose->shell);
  for(compose_info = compose->compose_info; 
      compose_info; compose_info = compose_info->prev) {
    if(compose_info->number == xp->item_position) {
      if(compose_info->selected == TRUE) {
	compose_info->selected = FALSE;
	XmListDeselectPos(compose->list_list,compose_info->number);
      }
      else {
	compose_info->selected = TRUE;
	compose_context_switch(compose, compose->current, compose_info);
      }
    }
    else
      compose_info->selected = FALSE;
  }
  return;
}


#ifdef __STDC__
void compose_list_double(Widget w, Compose *compose, XmListCallbackStruct *xp)
#else
void compose_list_double(w,compose,xp)
     Widget w;
     Compose *compose;
     XmListCallbackStruct *xp;
#endif
{
  return;
}


#ifdef __STDC__
void compose_list_cancel(Widget w, Compose *compose, XtPointer xp)
#else
void compose_list_cancel(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  XtRemoveCallback(compose->list_shell,
		   XmNdestroyCallback, 
		   (XtCallbackProc) compose_list_destroy, compose);
  XtDestroyWidget(compose->list_shell);
  compose->list_is_realized = FALSE;
  return;
}


#ifdef __STDC__
void compose_list_destroy(Widget w, Compose *compose, XtPointer xp)
#else
void compose_list_destroy(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  compose->list_is_realized = FALSE;
  return;
}

#ifdef __STDC__
void compose_list_help(Widget w, Compose *compose, XtPointer xp)
#else
void compose_list_help(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  help(compose->list_shell,COMPOSELISTHELPTITLE,
       COMPOSELISTHELPFILE, DOCTYPE_ENRICHED);
  return;
}


#ifdef __STDC__
void stuff_compose_window_list(Compose *compose, Boolean update)
#else
void stuff_compose_window_list(compose,update)
     Compose *compose;
     Boolean update;
#endif
{
  Compose_Info *compose_info;
  int n = 1;
  char buffer[FILEBUFFLEN];
  XmString xstr;

  /* Update the structure contents in case they've changed. */

  if(update) {
    if((compose == NULL) || (compose->list_is_realized == FALSE))
      return;
    XmListDeselectAllItems(compose->list_list);
    XmListDeleteAllItems(compose->list_list);
  }

  compose_context_switch(compose,compose->current,NULL);

  for(compose_info = compose->compose_info;
      compose_info; compose_info = compose_info->prev) {

    compose_info->number = n;
    if(compose_info->selected == TRUE)
      XmListSelectPos(compose->list_list, n, FALSE);

    sprintf(buffer,"[%s] %-32.32s [%s] %-32.32s [%s] %-32.32s",
	    SUBJECT_TEXT,
	    (*compose_info->subject) ? compose_info->subject : UNSET_STR,
	    TO_TEXT,
	    (*compose_info->to) ? compose_info->to : UNSET_STR,
	    "Title:",
	    compose_info->title);
    
    xstr = XmStringCreateSimple(buffer);
    XmListAddItemUnselected(compose->list_list,xstr,0);
    XmStringFree(xstr);
    n ++;

  }
  return;
}

/* 
 * We've been called by an address text field widget. At least that's the
 * assumption, so don't try and change it. All we have is the widget.
 * It contains something presumably that we will have to complete from
 * the address book. But it might contain other addresses, and the one to be
 * completed could be anywhere. We presume that it is under the cursor.
 * We then split up the string into three parts. The part before the current
 * word (comma delimited), and anything afterward (delimited by comma or a 
 * space). Any of these parts might be empty. After we extract our pattern,
 * we look it up, and replace it with the address book address. More on 
 * that later. We then combine it with any or all of the other parts, and 
 * make sure we have comma delimiters (plus a gratuitous space) between 
 * all the fields. On failure we leave it alone, and advance to the next
 * tab group, since the most likely key binding for this will be a tab key.
 * Therefore, the tab completes, if possible, and in all other cases moves to 
 * the next tab group.
 */

#ifdef __STDC__
void complete_address(Widget w, XtPointer xp)
#else
void complete_address(w,xp)
     Widget w;
     XtPointer xp;
#endif
{
  char *text = GetTextField(w);
  XmTextPosition pos = XmTextGetInsertionPosition(w);
  char *begin = NULL;
  char *end = NULL;
  char *pattern = NULL;
  char *lookup = NULL;
  XmTextPosition newpos = 0;

  if(*text == NUL_TERM) {
    fs_give((void **) &text);
    XmProcessTraversal(w,XmTRAVERSE_NEXT_TAB_GROUP);
    return;
  }

  /* point to current position. */

  pattern = text + ((pos > 0) ? (pos - 1) : 0 );

  /* find the beginning of this address */

  while((pattern > text) && (*pattern != ','))
	pattern --;

  /* We're at the beginning */

  if(pattern == text) {
    begin = NULL;
  }

  /* 
   * Not the beginning, so set the begin pointer to it,
   * tie it off, and point pattern just beyond it.
   */

  else {
    *pattern = NUL_TERM;
    pattern = first_nonwhite(pattern + 1);
    begin = text;
  }

  /* 
   * find any  subsequent addresses. If we find one, tie off
   * our pattern string, and point end at the next address.
   */

  end = strpbrk(pattern,", ");
  if(end) {
    *end = NUL_TERM;
    end = first_nonwhite(end + 1);
  }

  /* 
   * Try and match it. If we do, rebuild the visible text. Set the
   * cursor at the end of the address we just completed. 
   */

  if((lookup = lookup_address(pattern)) != NULL) {
    XmTextSetString(w,(begin) ? begin : EMPTYSTR);
    AppendText(w,(begin) ? ", " : EMPTYSTR );
    AppendText(w,lookup);
    newpos = XmTextGetInsertionPosition(w);
    if(end) {
      AppendText(w,", ");
      AppendText(w,end);
    }
    XmTextSetInsertionPosition(w,newpos);
  }

  if(lookup)
    fs_give((void **) &lookup);
  else
    XmProcessTraversal(w,XmTRAVERSE_NEXT_TAB_GROUP);

  fs_give((void **) &text);
  return;
}


#ifdef __STDC__
char *lookup_address(char *str)
#else
char *lookup_address(str) 
  char *str;
#endif
{
  int cnt = 0;
  
  Address_Book_Info *address_book_info;
  Address_Book_Info *saved = NULL;

  fflush(stdout);

  if(session.address_book == NULL) 
    return(NULL);

  for(address_book_info = session.address_book->address_book_info;
      address_book_info ; address_book_info = address_book_info->prev) {
    if(strncasecmp((char *) address_book_info->name,
		   str,strlen(str)) == STRMATCH) {
      cnt ++;
      saved = address_book_info;
    }
  }

  if(cnt == 1)
    return(cpystr((char *) saved->address));

  if(cnt > 1)
    return(address_popup(str));

  return(NULL);
}


#ifdef __STDC__
char *address_popup(char *str)
#else
char *address_popup(str)
     char *str;
#endif
{
  XBell(XtDisplay(top), 500);
  return(NULL);
}


#ifdef __STDC__
void generate_subject(Widget w, Compose *compose, XtPointer xp)
#else
void generate_subject(w, compose, xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  Binary_Buffer *binary_buffer;
  unsigned char *ptr;

  silent_pipe = TRUE;

  if((access(PATH_FORTUNE, X_OK)) == SYSCALL_SUCCESS) {
    binary_buffer = read_from_pipe(FORTUNE_CMD);
    if(binary_buffer) {
      if(binary_buffer->data) {
	for(ptr = binary_buffer->data; *ptr != NUL_TERM; ptr ++)
	  if((*ptr == LFCHAR) || (*ptr == TABCHAR))
	    *ptr = SPACECHAR;
	XmTextSetString(compose->subject_text, binary_buffer->data);
      }
      free_binary_buffer(binary_buffer);
    }
  }
  silent_pipe = FALSE;
  return;
}

#ifdef __STDC__
void compose_pgp_sign(Widget w, Compose *compose, XtPointer xp)
#else
void compose_pgp_sign(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  pgp_encode(w,compose,PGP_SIGN);
  return;
}


#ifdef __STDC__
void compose_pgp_cryp(Widget w, Compose *compose, XtPointer xp)
#else
void compose_pgp_cryp(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  pgp_encode(w,compose,PGP_CRYP);
  return;
}

#ifdef __STDC__
void compose_pgp_both(Widget w, Compose *compose, XtPointer xp)
#else
void compose_pgp_both(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  pgp_encode(w,compose,PGP_BOTH);
  return;
}


#ifdef __STDC__
void pgp_encode(Widget w, Compose *compose, int method)
#else
void pgp_encode(w,compose,method)
     Widget w;
     Compose *compose;
     int method;
#endif
{
  FILE *fp;
  char *pw;
  Remote_Auth *remote_auth;
  char *text;
  char *wrapped_text;
  char *filename;
  char *users = NULL;
  char filenamebuff[MAXPATHLEN];
  char buffer[MAXPATHLEN];
  PART *part;
  BODY *body;
  Binary_Buffer *binary_buffer;

  remote_auth = login(compose->shell, "PGP", "PGP",
		      preferences.pgp_username, NULL);

  if(remote_auth == NULL)
    return;


  if(remote_auth->username == NULL || remote_auth->password == NULL) {
    free_remote_auth(remote_auth);
    return;
  }

  filename = (char *) tmpnam(filenamebuff);

  if(method != PGP_SIGN) {
    users = make_kv_window(compose->shell);
    if((! users) || (*users == NUL_TERM)) {
      if(users)
	fs_give((void **) &users);
      free_remote_auth(remote_auth);
      return;
    }
  }

  switch(method) {
  case PGP_SIGN:
    sprintf(buffer,PGP_SIGN_CMD,remote_auth->username,filename);
    break;
  case PGP_CRYP:
    sprintf(buffer,PGP_CRYP_CMD,remote_auth->username,users,filename);
    break;
  case PGP_BOTH:
  default:
    sprintf(buffer,PGP_BOTH_CMD,remote_auth->username,users,filename);
    break;

  }
      
  text = XmTextGetString(compose->compose_text);

  wrapped_text = wrap_text(text, COMPOSEWIDTH - 1);
  fs_give((void **) &text);

  if((fp = fopen(filename,"w")) != NULL) {
    (void) chmod(filename,S_IRWXU);
    (void) fclose(fp);

    push_cursor(WATCH_CURSOR);

    pw = scramble(remote_auth->password);
    if((write_to_pipe(buffer,pw,wrapped_text,strlen(wrapped_text))) 
       == SYSCALL_SUCCESS) {
      wipeout(pw);
      binary_buffer = load_binary_file(filename);
      
      part = mail_newbody_part();
      body = &part->body;
      
      body->type = TYPEAPPLICATION;
      body->subtype = cpystr("pgp");
      body->description = GetTextField(compose->subject_text);
      
      link_attachment(compose,part,body,binary_buffer);
      free_binary_buffer(binary_buffer);
      XmTextSetString(compose->compose_text,EMPTYSTR);
    }
    else
      mm_log(PGP_FAILED,ERROR);
    
    wipeout(pw);
    fs_give((void **) &pw);
    unlink(filename);

  }

  if(users)
    fs_give((void **) &users);
  fs_give((void **) &wrapped_text);
  free_remote_auth(remote_auth);
  pop_cursor();
  return;
}


#ifdef __STDC__
void compose_spell(Widget w, Compose *compose, XtPointer xp)
#else
void compose_spell(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  FILE *fp = NULL;
  char *text = NULL;
  String_List *string_list = NULL;
  String_List *prev        = NULL;
  String_List *base        = NULL;
  char *tmp_file           = NULL;
  char *otext              = NULL;
  char filename[MAXPATHLEN];
  char buffer[FILEBUFFLEN];
  char command[FILEBUFFLEN];
  int count = 0;
  Boolean has_stop = FALSE;

  if(access(SPELLSTOPFILE,R_OK) == SYSCALL_SUCCESS)
    has_stop = TRUE;

  if((compose->search_win != NULL) 
     && (compose->search_win->is_realized == TRUE)) {
    de_iconify(compose->search_win->shell);
    return;
  }


  otext = XmTextGetString(compose->compose_text);
  if(otext == NULL) 
    return;
  if(*otext == NUL_TERM) {
    fs_give((void **) &otext);
    return;
  }

  /* Just in case they didn't end the message properly.... */

  text = (char *) fs_get(strlen(otext) + 8);
  strcpy(text,otext);
  strcat(text,LFSTR);
  fs_give((void **) &otext);


  tmp_file = (char *) tmpnam(filename);

  sprintf(command, SPELL_COMMAND,
	  (has_stop == TRUE) ? '+' : SPACECHAR,
	  (has_stop == TRUE) ? SPELLSTOPFILE : EMPTYSTR,
	  tmp_file); 

  push_cursor(WATCH_CURSOR);

  sprintf(buffer,EXECUTING_SPELL, command);
  mm_log(buffer, NIL);

  if((fp = popen(command,"w")) != NULL) {
    (void) chmod(tmp_file,S_IRWXU);
    fwrite(text,strlen(text),1,fp);
    pclose(fp);
  }
  else {
    fs_give((void **) &text);
    fs_give((void **) &tmp_file);
    pop_cursor();
    return;
  }

  if((fp = fopen(tmp_file,"r")) != NULL) {
    while((fgets(buffer,sizeof(buffer),fp)) != NULL) {
      buffer[strlen(buffer) - 1] = NUL_TERM;
      if(*buffer == NUL_TERM)
	continue;
      count ++;
      string_list = new_string_list();
      string_list->string = cpystr(buffer);
      if(prev == NULL)
	base = string_list;
      else
	prev->next = string_list;
      prev = string_list;
    }
    fclose(fp);
  }
  else
    mm_log(SPELL_OUT_FAILED, NIL);

  fs_give((void **) &text);
  unlink(tmp_file); 
  pop_cursor();
  sprintf(buffer,N_CORRECTIONS_FOUND,count);
  mm_log(buffer, NIL);
  if(base)
    make_text_spell_window(compose->compose_text, base);
  return;
}

#ifdef __STDC__
void link_attachment(Compose *compose, PART *part, BODY *body,
		     Binary_Buffer *binary_buffer)
#else
void link_attachment(compose,part,body,binary_buffer)
     Compose *compose;
     PART *part;
     BODY *body;
     Binary_Buffer *binary_buffer;
#endif
{
  Part_List *part_list;
  PART *current;
  BODY *subbody;
  Boolean attached = FALSE;
  
  add_attachment_contents_to_body(body,binary_buffer);

  /* 
   * See if there is a selected attachment. Then check to see if
   * it is a multipart. If so, then we add to that multipart.
   */

  if(compose->current->selection && compose->current->part_list) {
    for(part_list = compose->current->part_list;
	part_list->partnumber != compose->current->selection;
	part_list = part_list->next);
    subbody = &(part_list->part->body);
    if(subbody && subbody->type == TYPEMULTIPART) {
      current = subbody->contents.part;
      if(! current)
	subbody->contents.part = part;
      else {
	while(current->next)
	  current = current->next;
	current->next = part;
      }
      attached = TRUE;
    }
  }

  /* 
   * Wasn't a subpart, or we couldn't attach it as one. Attach to the
   * root part.
   */

  if(! attached) {
    if(compose->current->attachments == NULL) {
      compose->current->attachments = part;
    }
    else {
      current = compose->current->attachments;
      while(current->next)
	current = current->next;
      current->next = part;
    }
  }
  
  make_attachment_list(compose);
  return;
}


#ifdef __STDC__
void compose_parameters(Widget w, Compose *compose, XtPointer xp)
#else
void compose_parameters(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  Part_List *part_list;
  PARAMETER **old = NULL;
  PARAMETER *new = NULL;
  char *oldstr = NULL;
  char *newstr = NULL;

  /* See if there is a selected attachment. */

  if(compose->current->selection && compose->current->part_list) {
    for(part_list = compose->current->part_list;
	part_list->partnumber != compose->current->selection;
	part_list = part_list->next)
      ;
    old = &part_list->part->body.parameter;
  }
  if(old == NULL)
    old = &compose->current->parameters;

  oldstr = param_to_str(*old);

  newstr = input_string(compose->shell,PROMPT_PARAMS,oldstr, PARAMSHELPFILE);
  if(newstr == NULL)
    return;
  if(*newstr == NUL_TERM) {
    fs_give((void **) &newstr);
    fs_give((void **) &oldstr);
    mail_free_body_parameter(old);
  }
  else {
    new = str_to_param(newstr);
    if(new != NULL) {
      mail_free_body_parameter(old);
      *old = new;
    }
  }
  fs_give((void **) &oldstr);
  fs_give((void **) &newstr);
  compose_context_switch(compose,compose->current,compose->current);
  return;

}

/*
 * This is just to calculate how much space to allocate for storing
 * a text field. (Used in the print function). We over-allocate by
 * a little bit to make up for psuedo-tabs and line breaks.
 */

#ifdef __STDC__
unsigned long compose_field_approx_size(char *prefix, char *str, 
					unsigned long len)
#else
unsigned long compose_field_approx_size(prefix, str, len)
     char *prefix;
     char *str;
     unsigned long len;
#endif
{
  unsigned long retval = 0L;

  if(!str)
    return(0L);

  if(len == 0L)
    return((unsigned long) strlen(str));

  if(prefix) 
    retval = strlen(prefix);
  retval += (unsigned long) strlen(str) + 
    ((unsigned long) strlen(str) / len ) + (unsigned long) 16L;

  return(retval);
}


#ifdef __STDC__
void compose_print(Widget w, Compose *compose, XtPointer xp)
#else
void compose_print(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  char *s;
  char *wrapped_text;
  unsigned long size = 0L;

  if(!preferences.print_command || *preferences.print_command == NUL_TERM)
    return;

  push_cursor(WATCH_CURSOR);
  compose_context_switch(compose,compose->current,compose->current);

  /* Allow enough room for our header text and a tab stop. */

#define HEADER_MARGIN (COMPOSEWIDTH - 20) 

  size +=  compose_field_approx_size(TO_TEXT,
				     compose->current->to,
				     HEADER_MARGIN);
  size +=  compose_field_approx_size(NG_TEXT,
				     compose->current->newsgroups,
				     HEADER_MARGIN);

  size +=  compose_field_approx_size(SUBJECT_TEXT,
				     compose->current->subject,
				     HEADER_MARGIN);

  size +=  compose_field_approx_size(CC_TEXT,
				     compose->current->cc,
				     HEADER_MARGIN);

  size +=  compose_field_approx_size(BCC_TEXT,
				     compose->current->bcc,
				     HEADER_MARGIN);

  size +=  compose_field_approx_size(NULL, 
				     compose->current->text,
				     COMPOSEWIDTH - 1);

  s = (char *) fs_get(size);

  *s = NUL_TERM;

  if(*compose->current->to) {
    strcat(s,TO_TEXT);
    strcat(s,TABSTR);
    wrapped_text = wrap_text(compose->current->to, HEADER_MARGIN);
    strcat(s,wrapped_text);
    strcat(s,LFSTR);
    fs_give((void **) &wrapped_text);
  }
  if(*compose->current->newsgroups) {
    strcat(s,NG_TEXT);
    strcat(s,TABSTR);
    wrapped_text = wrap_text(compose->current->newsgroups, HEADER_MARGIN);
    strcat(s,wrapped_text);
    strcat(s,LFSTR);
    fs_give((void **) &wrapped_text);
  }
  if(*compose->current->subject) {
    strcat(s,SUBJECT_TEXT);
    strcat(s,TABSTR);
    wrapped_text = wrap_text(compose->current->subject, HEADER_MARGIN);
    strcat(s,wrapped_text);
    strcat(s,LFSTR);
    fs_give((void **) &wrapped_text);

  }
  if(*compose->current->cc) {
    strcat(s,CC_TEXT);
    strcat(s,TABSTR);
    wrapped_text = wrap_text(compose->current->cc, HEADER_MARGIN);
    strcat(s,wrapped_text);
    strcat(s,LFSTR);
    fs_give((void **) &wrapped_text);
  }
  if(*compose->current->bcc) {
    strcat(s,BCC_TEXT);
    strcat(s,TABSTR);
    wrapped_text = wrap_text(compose->current->bcc, HEADER_MARGIN);
    strcat(s,wrapped_text);
    strcat(s,LFSTR);
    fs_give((void **) &wrapped_text);
  }

  strcat(s,LFSTR);

  if(*compose->current->text) {
    wrapped_text = wrap_text(compose->current->text, COMPOSEWIDTH - 1);
    strcat(s,wrapped_text);
    strcat(s,LFSTR);
    fs_give((void **) &wrapped_text);
  }

  if((write_to_pipe(preferences.print_command, NULL,s,strlen(s))) 
     != SYSCALL_SUCCESS)
    mm_log(PRINT_FAILED, WARN);
  else
    mm_log(PRINT_OK, NIL);

  fs_give((void **) &s);
  pop_cursor();
  return;
}


#ifdef __STDC__
void compose_save_draft(Widget w, Compose *compose, XtPointer xp)
#else
void compose_save_draft(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  FILE *fp;
  char *filename;
  Boolean append_it;

  filename = file_select(compose->shell, NULL, DRAFT_FILEPAT, DRAFT_TEXT,
			 TRUE, &append_it);
  if(filename == NULL)
     return;

  push_cursor(WATCH_CURSOR);
  compose_context_switch(compose,compose->current,compose->current);

  if((fp = fopen(filename,(append_it == TRUE) ? "a" : "w")) != NULL) {
    (void) chmod(filename,S_IRWXU);
    fprintf(fp,"%s\n",ML_DRAFT_HEADER);
    if(*compose->current->title)
      fprintf(fp,"%s\t%s\n",TITLE_TEXT,compose->current->title);
    if(*compose->current->from) 
      fprintf(fp,"%s\t%s\n",FROM_TEXT,compose->current->from);
    if(*compose->current->to) 
      fprintf(fp,"%s\t%s\n",TO_TEXT,compose->current->to);
    if(*compose->current->newsgroups) 
      fprintf(fp,"%s\t%s\n",NG_TEXT,compose->current->newsgroups);
    if(*compose->current->subject) 
      fprintf(fp,"%s\t%s\n",SUBJECT_TEXT,compose->current->subject);
    if(*compose->current->cc) 
      fprintf(fp,"%s\t%s\n",CC_TEXT,compose->current->cc);
    if(*compose->current->bcc) 
      fprintf(fp,"%s\t%s\n",BCC_TEXT,compose->current->bcc);
    fprintf(fp,"\n");
    fprintf(fp,"%s",compose->current->text);
    fclose(fp);
  }

  fs_give((void **) &filename);
  pop_cursor();
}



#ifdef __STDC__
void compose_load_draft(Widget w, Compose *compose, XtPointer xp)
#else
void compose_load_draft(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  FILE *fp;
  char *filename;
  char buffer[2 * FILEBUFFLEN];
  struct stat st;
  int c;
  char *str;
  char *dst;

  filename = file_select(compose->shell, NULL, DRAFT_FILEPAT, 
			 DRAFT_TEXT, FALSE, NULL);
  if(filename == NULL)
     return;

  if(stat(filename,&st) != SYSCALL_SUCCESS) {
    fs_give((void **) &filename);
    return;
  }
  if((fp = fopen(filename,"r")) != NULL) {
    fgets(buffer,sizeof(buffer),fp);
    buffer[strlen(buffer) - 1] = NUL_TERM;
    if(strcmp(buffer,ML_DRAFT_HEADER) != STRMATCH) {
      fs_give((void **) &filename);
      mm_log(NOT_A_DRAFT,ERROR);
      return;
    }
    push_cursor(WATCH_CURSOR);
    while(fgets(buffer,sizeof(buffer),fp) != NULL) {
      buffer[strlen(buffer) - 1] = NUL_TERM;
      if(! strlen(buffer))
	break;
      if(strncmp(buffer,TITLE_TEXT,strlen(TITLE_TEXT)) == STRMATCH) {
	if(compose->current) {
	  if(compose->current->title)
	    fs_give((void **) &compose->current->title);
	  compose->current->title = cpystr(buffer + strlen(TITLE_TEXT) + 1);
	  XtVaSetValues(compose->shell, 
			XmNtitle, compose->current->title,
			NULL);
	}
      }
      if(strncmp(buffer,FROM_TEXT,strlen(FROM_TEXT)) == STRMATCH) {
	fs_give((void **) &compose->current->from);
	compose->current->from = cpystr(buffer + strlen(FROM_TEXT) + 1);
      }
      if(strncmp(buffer,TO_TEXT,strlen(TO_TEXT)) == STRMATCH) 
	AppendText(compose->to_text,buffer + strlen(TO_TEXT) + 1);

      if(strncmp(buffer,NG_TEXT,strlen(NG_TEXT)) == STRMATCH) {
	AppendText(compose->ng_text,buffer + strlen(NG_TEXT) + 1);
	compose->current->has_ng = TRUE;
      }
      else
	compose->current->has_ng = FALSE;

      if(strncmp(buffer,SUBJECT_TEXT,strlen(SUBJECT_TEXT)) == STRMATCH) 
	AppendText(compose->subject_text,
			buffer + strlen(SUBJECT_TEXT) + 1);
      if(strncmp(buffer,CC_TEXT,strlen(CC_TEXT)) == STRMATCH) 
	AppendText(compose->cc_text,buffer + strlen(CC_TEXT) + 1);
      if(strncmp(buffer,BCC_TEXT,strlen(BCC_TEXT)) == STRMATCH) 
	AppendText(compose->bcc_text,buffer + strlen(BCC_TEXT) + 1);
    }

    str = (char *) fs_get(st.st_size + 1);
    dst = str;

    while((c = fgetc(fp)) != EOF) { 
      *dst = c;
      dst ++;
    }
    *dst = NUL_TERM;
    fclose(fp);
    AppendText(compose->compose_text,str);
    fs_give((void **) &str);
  }

  stuff_compose_window_list(compose, TRUE);

  fs_give((void **) &filename);
  pop_cursor();
  return;
}

#ifdef __STDC__
void compose_unwrap(Widget w, Compose *compose, XtPointer xp)
#else
void compose_unwrap(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  text_unwrap(compose->compose_text,NULL);
  set_edit_buttons(w,compose,xp);
  return;
}


#ifdef __STDC__
void compose_strip_prefix(Widget w, Compose *compose, XtPointer xp)
#else
void compose_strip_prefix(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  char *prefix;

  prefix = GetTextField(compose->edit->strip_text);
  if(prefix == NULL)
    return;
  if(*prefix == NUL_TERM) {
    fs_give((void **) &prefix);
    return;
  }
  text_strip_prefix(compose->compose_text,prefix);
  fs_give((void **) &prefix);
  set_edit_buttons(w,compose,xp);
  return;
}

#ifdef __STDC__
void compose_rewrap(Widget w, Compose *compose, XtPointer xp)
#else
void compose_rewrap(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  char *value;
  int len;

  value = GetTextField(compose->edit->wrap_text);
  if(value == NULL)
    return;
  len = atoi(value);
  if(len <= 0 || len > COMPOSEWIDTH) {
    mm_log(ILLEGAL_WRAP_LEN,WARN);
    fs_give((void **) &value);
    return;
  }

  text_rewrap(compose->compose_text,len);
  fs_give((void **) &value);
  set_edit_buttons(w,compose,xp);
  return;
}


#ifdef __STDC__
void compose_add_prefix(Widget w, Compose *compose, XtPointer xp)
#else
void compose_add_prefix(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  char *prefix;

  prefix = GetTextField(compose->edit->insert_text);
  if(prefix == NULL)
    return;
  if(*prefix == NUL_TERM) {
    fs_give((void **) &prefix);
    return;
  }
  text_prefix(compose->compose_text,prefix);
  fs_give((void **) &prefix);
  set_edit_buttons(w,compose,xp);
  return;
}


#ifdef __STDC__
void compose_reply_insert(Widget w, Compose *compose, XtPointer xp)
#else
void compose_reply_insert(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  XmTextPosition left, right;
  char *the_text = NULL;
  Time timestamp;
  Boolean found = FALSE;

  push_cursor(WATCH_CURSOR);
  if(session.read && session.read->is_realized) {
    XmTextGetSelectionPosition(session.read->read_text,&left,&right);
    if(left != right) {
      the_text = XmTextGetSelection(session.read->read_text);
      found = TRUE;
    }
  }
  if(! found) {
    if(compose->current->reply_text) {
      the_text = cpystr(compose->current->reply_text);
      found ++;
    }
  }
  if((found)  && (*the_text != NUL_TERM)) {

    left = XmTextGetInsertionPosition(compose->compose_text);
    right = left + strlen(the_text);
    text_blast(compose->compose_text,the_text);

    timestamp = XtLastTimestampProcessed(XtDisplay(compose->compose_text));
    XmTextSetSelection(compose->compose_text,left,right,timestamp);
  }
  if(the_text)
    fs_give((void **) &the_text);

  text_prefix(compose->compose_text,preferences.reply_prefix);

  timestamp = XtLastTimestampProcessed(XtDisplay(compose->compose_text));
  XmTextSetSelection(compose->compose_text, 0, 0, timestamp);
  pop_cursor();
  return;
}


#ifdef __STDC__
void compose_custom_insert(Widget w, Compose *compose, XtPointer xp)
#else
void compose_custom_insert(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  XmTextPosition left, right;
  char *the_text = NULL;
  Time timestamp;
  Boolean found = FALSE;

  push_cursor(WATCH_CURSOR);
  if(session.read && session.read->is_realized) {
    XmTextGetSelectionPosition(session.read->read_text,&left,&right);
    if(left != right) {
      the_text = XmTextGetSelection(session.read->read_text);
      found = TRUE;
    }
  }
  if(! found) {
    if(compose->current->reply_text) {
      the_text = cpystr(compose->current->reply_text);
      found ++;
    }
  }
  if((found)  && (*the_text != NUL_TERM)) {

    left = XmTextGetInsertionPosition(compose->compose_text);
    right = left + strlen(the_text);
    text_blast(compose->compose_text,the_text);

    timestamp = XtLastTimestampProcessed(XtDisplay(compose->compose_text));
    XmTextSetSelection(compose->compose_text,left,right,timestamp);
  }
  if(the_text)
    fs_give((void **) &the_text);

  compose_edit_tool(w,compose,xp);

  pop_cursor();
  return;
}




#ifdef __STDC__
void compose_edit_copy(Widget w, Compose *compose, XtPointer xp)
#else
void compose_edit_copy(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  XmTextPosition left, right;
  char *the_text;

  XmTextGetSelectionPosition(compose->compose_text,&left,&right);

  if(left == right)
    return;

  the_text = XmTextGetSelection(compose->compose_text);

  if(compose->edit->buffer)
    fs_give((void **) &compose->edit->buffer);

  compose->edit->buffer = the_text;
  compose->edit->begin = left;
  compose->edit->end   = right;

  set_edit_buttons(w,compose,xp);
  return;
}

#ifdef __STDC__
void compose_edit_paste(Widget w, Compose *compose, XtPointer xp)
#else
void compose_edit_paste(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  if(compose->edit->buffer) 
    text_blast(compose->compose_text,compose->edit->buffer);
  return;
}


#ifdef __STDC__
void compose_edit_undo(Widget w, Compose *compose, XtPointer xp)
#else
void compose_edit_undo(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  Time timestamp;

  if(compose->edit->buffer) {
    XmTextReplace(compose->compose_text,
		  compose->edit->begin,
		  compose->edit->end,compose->edit->buffer);
    timestamp = XtLastTimestampProcessed(XtDisplay(compose->compose_text));
    XmTextSetSelection(compose->compose_text,
		       compose->edit->begin,compose->edit->end,timestamp);

    fs_give((void **) &compose->edit->buffer);
    compose->edit->buffer = NULL;
  }

  set_edit_buttons(w,compose,xp);
  return;
}


#ifdef __STDC__
void compose_edit_destroy(Widget w, Compose *compose, XtPointer xp)
#else
void compose_edit_destroy(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  compose->edit->is_realized = FALSE;
  return;
}

#ifdef __STDC__
void compose_edit_dismiss(Widget w, Compose *compose, XtPointer xp)
#else
void compose_edit_dismiss(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  XtRemoveCallback(compose->edit->shell, XmNdestroyCallback, 
		   (XtCallbackProc) compose_edit_destroy, compose);
  XtDestroyWidget(compose->edit->shell);
  compose->edit->is_realized = FALSE;
  return;
}


#ifdef __STDC__
void compose_edit_help(Widget w, Compose *compose, XtPointer xp)
#else
void compose_edit_help(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  help(compose->edit->shell,COMPOSEEDITHELPTITLE, 
       COMPOSEEDITHELPFILE, DOCTYPE_ENRICHED);
  return;
}

#ifdef __STDC__
void set_edit_buttons(Widget w, Compose *compose, XtPointer xp)
#else
void set_edit_buttons(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  Arg args[1];

  if(compose->edit->buffer) 
    XtSetArg(args[0], XmNsensitive,TRUE);
  else
    XtSetArg(args[0], XmNsensitive, FALSE);

  XtSetValues(compose->edit->undo,args,1);
  XtSetValues(compose->edit->paste,args,1);
  return;
}

#ifdef __STDC__
void compose_edit_tool(Widget w, Compose *compose, XtPointer xp)
#else
void compose_edit_tool(w,compose,xp)
     Widget w;
     Compose *compose;
     XtPointer xp;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  XtTranslations translations;
  Widget form, menubar, button1, button2, button3, button4, button5;

  if(compose->edit->is_realized == TRUE) {
    de_iconify(compose->edit->shell);
    return;
  }

  XtSetArg(args[n], XtNx, -1000); n ++;
  XtSetArg(args[n], XtNy, -1000); n ++;

  XtSetArg(args[n], XmNtraversalOn, FALSE); n ++;

  compose->edit->shell = XtCreateWidget("edit_shell",
					topLevelShellWidgetClass,
					compose->shell, args, n ); 
  n = 0;

  setup_editres(compose->edit->shell);

  if(edit_icon != (Pixmap) None)
    XtVaSetValues(compose->edit->shell,
		  XmNiconPixmap,edit_icon,
		  NULL);
	

  form = XmCreateForm(compose->edit->shell, "edit_form", args, n); 
  n = 0;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  menubar = XmCreateMenuBar(form,"edit_menubar", args, n); 
  n = 0;
  
  XtManageChild(menubar);
  create_buttons(NULL, menubar,compose_format_menu, 
		      XtNumber(compose_format_menu), BTN_ON, 
		      (XtPointer) compose, ROOTMENULEVEL);

  XtSetArg(args[n], XmNtraversalOn, FALSE);   n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);  n ++;
  XtSetArg(args[n], XmNtopWidget, menubar);             n ++;

  compose->edit->undo = XmCreatePushButton(form,"edit_undo_button", 
					   args, n);
  n = 0;
  XtAddCallback(compose->edit->undo,XmNactivateCallback,
		(XtCallbackProc) compose_edit_undo,compose);
  XtManageChild(compose->edit->undo);

  XtSetArg(args[n], XmNtraversalOn, FALSE);   n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET);  n ++;
  XtSetArg(args[n], XmNtopWidget, menubar);             n ++;
  XtSetArg(args[n], XmNleftWidget, compose->edit->undo); n ++;
  button1 = XmCreatePushButton(form,"edit_copy_button", args, n); 
  n = 0;
  XtAddCallback(button1,XmNactivateCallback,
		(XtCallbackProc) compose_edit_copy,compose);
  XtManageChild(button1);

  XtSetArg(args[n], XmNtraversalOn, FALSE);   n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET);  n ++;
  XtSetArg(args[n], XmNtopWidget, menubar);             n ++;
  XtSetArg(args[n], XmNleftWidget, button1);            n ++;
  compose->edit->paste = XmCreatePushButton(form,"edit_paste_button", 
					    args, n); n = 0;
  XtAddCallback(compose->edit->paste,XmNactivateCallback,
		(XtCallbackProc) compose_edit_paste,compose);
  XtManageChild(compose->edit->paste);

  XtSetArg(args[n], XmNtraversalOn, FALSE);   n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);  n ++;
  XtSetArg(args[n], XmNtopWidget, compose->edit->paste); n ++;
  button2 = XmCreatePushButton(form,"edit_striplf_button", args, n); 
  n = 0;
  XtAddCallback(button2,XmNactivateCallback,
		(XtCallbackProc) compose_unwrap,compose);
  XtManageChild(button2);

  XtSetArg(args[n], XmNtraversalOn, FALSE);   n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);  n ++;
  XtSetArg(args[n], XmNtopWidget, button2);             n ++;
  button3 = XmCreatePushButton(form,"edit_rewrap_button", args, n); 
  n = 0;
  XtAddCallback(button3,XmNactivateCallback,
		(XtCallbackProc) compose_rewrap,compose);
  XtManageChild(button3);

  XtSetArg(args[n], XmNtraversalOn, FALSE); n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, button2);             n ++;
  XtSetArg(args[n], XmNleftWidget,button3);             n ++; 

  compose->edit->wrap_text = 
    XmCreateTextField(form,"edit_rewrap_textfld", args, n); n = 0;
  AppendText(compose->edit->wrap_text, DEFAULTEDITWRAPCOL_STR);
  translations = 
    XtParseTranslationTable(GLOBAL_nonterminal_text_field_translations);
  XtOverrideTranslations(compose->edit->wrap_text,translations);
  translations = 
    XtParseTranslationTable(GLOBAL_terminal_text_field_translations);
  XtOverrideTranslations(compose->edit->wrap_text,translations);
  XtAddCallback(compose->edit->wrap_text,XmNactivateCallback,
		(XtCallbackProc) compose_rewrap,compose);

  XtManageChild(compose->edit->wrap_text);

  XtSetArg(args[n], XmNtraversalOn, FALSE);   n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);  n ++;
  XtSetArg(args[n], XmNtopWidget, button3);             n ++;
  button4 = XmCreatePushButton(form,"edit_strip_button", args, n); 
  n = 0;
  XtAddCallback(button4,XmNactivateCallback,
		(XtCallbackProc) compose_strip_prefix,compose);
  XtManageChild(button4);

  XtSetArg(args[n], XmNtraversalOn, FALSE); n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, button3);             n ++;
  XtSetArg(args[n], XmNleftWidget,button4);             n ++; 
  compose->edit->strip_text = 
    XmCreateTextField(form,"edit_strip_textfld", args, n); 
  n = 0;

  translations = 
    XtParseTranslationTable(GLOBAL_nonterminal_text_field_translations);
  XtOverrideTranslations(compose->edit->strip_text,translations);
  translations = 
    XtParseTranslationTable(GLOBAL_terminal_text_field_translations);
  XtOverrideTranslations(compose->edit->strip_text,translations);
  XtAddCallback(compose->edit->strip_text,XmNactivateCallback,
		(XtCallbackProc) compose_strip_prefix,compose);

  AppendText(compose->edit->strip_text, DEFAULTSTRIP_STR);

  XtManageChild(compose->edit->strip_text);


  XtSetArg(args[n], XmNtraversalOn, FALSE);   n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);  n ++;
  XtSetArg(args[n], XmNtopWidget, button4);             n ++;
  button5 = XmCreatePushButton(form,"edit_add_button", args, n); 
  n = 0;
  XtAddCallback(button5,XmNactivateCallback,
		(XtCallbackProc) compose_add_prefix,compose);
  XtManageChild(button5);

  XtSetArg(args[n], XmNtraversalOn, FALSE); n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, button4);             n ++;
  XtSetArg(args[n], XmNleftWidget,button5);             n ++; 
  XtSetArg(args[n], XmNcolumns, 3);                     n ++; 
  compose->edit->insert_text = 
    XmCreateTextField(form,"edit_add_textfld", args, n); n = 0;

  translations = 
    XtParseTranslationTable(GLOBAL_nonterminal_text_field_translations);
  XtOverrideTranslations(compose->edit->insert_text,translations);
  translations = 
    XtParseTranslationTable(GLOBAL_terminal_text_field_translations);
  XtOverrideTranslations(compose->edit->insert_text,translations);
  XtAddCallback(compose->edit->insert_text,XmNactivateCallback,
		(XtCallbackProc) compose_add_prefix,compose);
  AppendText(compose->edit->insert_text, preferences.reply_prefix);

  XtManageChild(compose->edit->insert_text);

  XtAddCallback(compose->edit->shell, XmNdestroyCallback, 
		(XtCallbackProc) compose_edit_destroy, compose);


  XtManageChild(form);
  XtManageChild(compose->edit->shell);
  XtRealizeWidget(compose->edit->shell);
  position_popup_widget(compose->edit->shell);
  compose->edit->is_realized = TRUE;
  set_edit_buttons(NULL, compose, NULL);
  return;
}


/*
 * Called from mm_expunge() on an expunge event. We will be passed the 
 * mailstream initiating the event, and the message number in question.
 * That message will no longer exist. Since "Reply" messages reference
 * the mailstream to set the Answered flag upon send, we have to update
 * any of these references. All message numbers higher than the one in
 * question will also need to be decreased by one (we only handle a single
 * message at a time, even though the function might get called repeatedly.)
 */


#ifdef __STDC__
void compose_expunge(MAILSTREAM *mailstream, unsigned long msgno)
#else
void compose_expunge(mailstream,msgno)
     MAILSTREAM *mailstream;
     unsigned long msgno;
#endif
{
  Compose_Info *compose_info;

  /*
   * Act I. See if we even need to do anything. Lack of a 
   * compose structure or any compose_info structures means
   * there's no compose sessions to worry about.
   */

  if(session.compose == NULL)
    return;
  if(session.compose->compose_info == NULL)
    return;

  /* 
   * We weren't so lucky. run through the list of compose_info's
   * Searching for our mailstream. Then check the msgno. If it's ours,
   * zero it, so it won't be referenced again. (The message can still
   * be composed -- we just won't set any flags at the end). If it's
   * a higher message number than ours, decrement it. 
   */

  for(compose_info = session.compose->compose_info;
      compose_info; compose_info = compose_info->prev) {
    if(compose_info->mailstream == mailstream) {
      if(compose_info->msgno == msgno) {
	compose_info->msgno = 0L;
	compose_info->mailstream = NULL;
      }
      if(compose_info->msgno > msgno)
	compose_info->msgno-- ;
    }
  }
}


#ifdef __STDC__
void compose_mailbox_close(MAILSTREAM *mailstream)
#else
void compose_mailbox_close(mailstream)
     MAILSTREAM *mailstream;
#endif
{
  Compose_Info *compose_info;

  /*
   * Act I. See if we even need to do anything. Lack of a 
   * compose structure or any compose_info structures means
   * there's no compose sessions to worry about.
   */

  if(session.compose == NULL)
    return;
  if(session.compose->compose_info == NULL)
    return;

  /* 
   * We weren't so lucky. run through the list of compose_info's
   * Searching for our mailstream. If it's ours, zero it, so it 
   * won't be referenced again. (The message can still
   * be composed -- we just won't set any flags at the end).
   */

  for(compose_info = session.compose->compose_info;
      compose_info; compose_info = compose_info->prev) {
    if(compose_info->mailstream == mailstream) {
      compose_info->msgno = 0L;
      compose_info->mailstream = NULL;
    }
  }
}


