/* mailboxes.c
 *
 *
 * $Author: mtm $
 * $Date: 1995/05/09 01:27:15 $
 * $Id: mailboxes.c,v 1.1 1995/05/09 01:27:15 mtm Exp mtm $
 *
 * Mike Macgirvin <Mike_Macgirvin@CAMIS.Stanford.EDU>
 *
 * Copyright 1994 by The Leland Stanford Junior University.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notices appear in all copies and that both the
 * above copyright notices and this permission notice appear in supporting
 * documentation, and that the name of The Leland Stanford Junior University 
 * not be used in advertising or publicity pertaining to distribution of the 
 * software without specific, written prior permission.  This software is made 
 * available "as is", and THE LELAND STANFORD JUNIOR UNIVERSITY DISCLAIMS ALL 
 * WARRANTIES, EXPRESS OR IMPLIED, WITH REGARD TO THIS SOFTWARE, INCLUDING 
 * WITHOUT LIMITATION ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE, AND IN NO EVENT SHALL THE LELAND STANFORD JUNIOR 
 * UNIVERSITY BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR 
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER 
 * IN AN ACTION OF CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, 
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
 * SOFTWARE.
 *
 */

/*
 * $Log: mailboxes.c,v $
 * Revision 1.1  1995/05/09  01:27:15  mtm
 * Initial revision
 *
 * 
 */

#include "ml.h"

Mailbox_Win *mailbox_win;


Menu mailboxlist_subscribe_menu[] = {
  { NULL, "mailboxlist_create", NUL_TERM, 
      mblist_create, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_delete", NUL_TERM, 
      mblist_delete, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_rename", NUL_TERM, 
      mblist_rename, NULL, 0, NULL, NULL, BTN_MAILBOX_DONEWS },
  { NULL, "mailboxlist_subscribe_only", NUL_TERM, 
      mblist_subscribe_only, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_create_only", NUL_TERM, 
      mblist_create_only, NULL, 0, NULL, NULL, BTN_MAILBOX_DONEWS },
  { NULL, "mailboxlist_unsubscribe_only", NUL_TERM, 
      mblist_unsubscribe_only, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_delete_only", NUL_TERM, 
      mblist_delete_only, NULL, 0, NULL, NULL, BTN_MAILBOX_DONEWS },
};

Menu mailboxlist_option_menu[] = {
  { NULL, "mailboxlist_everything", NUL_TERM, 
      mblist_everything, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_subscribed", NUL_TERM, 
      mblist_subscribed, NULL, 0, NULL, NULL, BTN_ON },
};

Menu mailboxlist_menu[] = {
  { NULL, "mailboxlist_accept", NUL_TERM, 
      mblist_accept, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_cancel", NUL_TERM, 
      mblist_cancel, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_subscribe_menu", NUL_TERM, 
      NULL, mailboxlist_subscribe_menu, XtNumber(mailboxlist_subscribe_menu),
      NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_option_menu", NUL_TERM,
      NULL, mailboxlist_option_menu, XtNumber(mailboxlist_option_menu), 
      NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_HELP", NUL_TERM, 
      mblist_help, NULL, 0, NULL, NULL, BTN_ON },
};


Menu mailopen_file_menu[] = {
  { NULL, "open", NUL_TERM,
      mailboxes_open, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "scan", NUL_TERM,
      mailboxes_scan, NULL, 0, NULL, NULL, BTN_NOSELECTION },
  { NULL, "mailboxlist_create", NUL_TERM, 
      mailboxes_create, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_delete", NUL_TERM, 
      mailboxes_delete, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_rename", NUL_TERM, 
      mailboxes_rename, NULL, 0, NULL, NULL, BTN_MAILBOX_DONEWS },
  { NULL, "mailboxlist_subscribe_only", NUL_TERM, 
      mailboxes_subscribe_only, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_create_only", NUL_TERM, 
      mailboxes_create_only, NULL, 0, NULL, NULL, BTN_MAILBOX_DONEWS },
  { NULL, "mailboxlist_unsubscribe_only", NUL_TERM, 
      mailboxes_unsubscribe_only, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_delete_only", NUL_TERM, 
      mailboxes_delete_only, NULL, 0, NULL, NULL, BTN_MAILBOX_DONEWS },
  { NULL, "close_window", NUL_TERM,
      mailboxes_cancel, NULL, 0, NULL, NULL, BTN_ON },
};


Menu mailopen_edit_menu[] = {
  { NULL, "mailboxlist_mail", NUL_TERM,
      mailboxes_setmail, NULL, 0, 
      NULL, NULL, BTN_MAILBOX_DOMAIL },
  { NULL, "mailboxlist_news", NUL_TERM, 
      mailboxes_setnews, NULL, 0, 
      NULL, NULL, BTN_MAILBOX_DONEWS },
  { NULL, "mailboxlist_everything", NUL_TERM, 
      mailboxes_everything, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_subscribed", NUL_TERM, 
      mailboxes_subscribed, NULL, 0, NULL, NULL, BTN_ON },
};


Menu mailboxopen_menu[] = {
  { NULL, "file_menu", NUL_TERM, 
      NULL, mailopen_file_menu, XtNumber(mailopen_file_menu), 
      NULL, NULL, BTN_ON },
  { NULL, "edit_menu", NUL_TERM,
      NULL, mailopen_edit_menu, XtNumber(mailopen_edit_menu), 
      NULL, NULL, BTN_ON },
  { NULL, "mailboxlist_HELP", NUL_TERM, 
      mailboxes_help, NULL, 0, NULL, NULL, BTN_ON },
};

Button_Table MLmailopen_button_table[] = {
  { "Open",        "mailbox-open",    
      mailboxes_open,       BTN_ON              },
  { "Scan",        "mailbox-scan",    
      mailboxes_scan,       BTN_NOSELECTION     },
  { "Create",      "mailbox-create-subscribe",  
      mailboxes_create,   BTN_ON                },
  { "Delete",      "mailbox-delete-unsubscribe",  
      mailboxes_delete,   BTN_ON                },
  { "Rename",      "mailbox-rename",  
      mailboxes_rename,   BTN_MAILBOX_DONEWS    },
  { "Subscribe",   "mailbox-subscribe", 
      mailboxes_subscribe_only, BTN_ON          },
  { "CreateOnly",  "mailbox-create-only", 
      mailboxes_create_only, BTN_MAILBOX_DONEWS },
  { "Unsubscribe", "mailbox-unsubscribe",
      mailboxes_unsubscribe_only, BTN_ON        },
  { "DeleteOnly",  "mailbox-delete-only",
      mailboxes_delete_only, BTN_MAILBOX_DONEWS },
  { "CloseWindow", "mailbox-close-window", 
      mailboxes_cancel,      BTN_ON             },
  { "Mail",        "mailbox-show-mailboxes",
      mailboxes_setmail,     BTN_MAILBOX_DOMAIL },
  { "News",        "mailbox-show-newsgroups",
      mailboxes_setnews,     BTN_MAILBOX_DONEWS },
  { "All",         "mailbox-show-all",
      mailboxes_everything,  BTN_ON             },
  { "Subscribed",  "mailbox-show-subscribed",
      mailboxes_subscribed,  BTN_ON             },

};

Button_Menu MLmailopen_default_buttons[] = {
  { "Open",    mailboxes_open,    NULL, BTN_ON,             NULL },
  { "Scan",    mailboxes_scan,    NULL, BTN_NOSELECTION,    NULL },
  { "News",    mailboxes_setnews, NULL, BTN_MAILBOX_DONEWS, NULL },
  { "Mail",    mailboxes_setmail, NULL, BTN_MAILBOX_DOMAIL, NULL },
  { "Dismiss", mailboxes_cancel,  NULL, BTN_ON,             NULL },
};

#ifdef __STDC__
int mailboxes_number_buttons(void)
#else
int mailboxes_number_buttons()
#endif
{
  return(XtNumber(MLmailopen_button_table));
}

#ifdef __STDC__
Button_Table *mailboxes_get_table(void)
#else
Button_Table *mailboxes_get_table()
#endif
{
  return(MLmailopen_button_table);
}


#ifdef __STDC__
void mailboxes_default_buttons(void)
#else
void mailboxes_default_buttons()
#endif
{
  if(session.buttons[MAILBOX_BTN_MENU] == NULL)
    setup_default_buttons(&session.buttons[MAILBOX_BTN_MENU],
			  MLmailopen_default_buttons,
			  XtNumber(MLmailopen_default_buttons));
  return;
}

#ifdef __STDC__
void mailboxes_reset_buttons(void)
#else
void mailboxes_reset_buttons()
#endif
{
  Button_Menu *button_menu;

  if((session.mailboxlist == NULL) 
     || (session.mailboxlist->is_realized == FALSE))
    return;
  for(button_menu = session.buttons[MAILBOX_BTN_MENU];
      button_menu; button_menu = button_menu->next)
    if(button_menu->widget != NULL)
      XtDestroyWidget(button_menu->widget);

  mailboxes_default_buttons();

  make_pbuttons(session.mailboxlist->rowcol, 
		session.buttons[MAILBOX_BTN_MENU], 
		session.mailboxlist->button_state,
		(XtPointer) session.mailboxlist);
  return;
}





#ifdef __STDC__
void mailboxes_check_buttons(Mailbox_Win *mailbox_win)
#else
void mailboxes_check_buttons(mailbox_win)
     Mailbox_Win *mailbox_win;
#endif
{
  if(mailbox_win && mailbox_win->is_realized)
    check_buttons(mailboxopen_menu,XtNumber(mailboxopen_menu),
		  session.buttons[MAILBOX_BTN_MENU], 
		  mailbox_win->button_state);
  return;
}

#ifdef __STDC__
void mailboxes_everything(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_everything(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;

  push_cursor(WATCH_CURSOR);

  server = GetTextField(mailbox_win->server);

  mailbox_win->everything = TRUE;
  stuff_mailbox_list(mailbox_win,server, TRUE, mailbox_win->everything);
  XtVaSetValues(mailbox_win->shell,
		XmNtitle, ALLMAILBOXES,
		NULL);

  fs_give((void **) &server);
  pop_cursor();
  return;
}


#ifdef __STDC__
void mailboxes_subscribed(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_subscribed(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;

  push_cursor(WATCH_CURSOR);

  server = GetTextField(mailbox_win->server);

  mailbox_win->everything = FALSE;

  stuff_mailbox_list(mailbox_win,server, TRUE, mailbox_win->everything);

  XtVaSetValues(mailbox_win->shell,
		XmNtitle, SUBMAILBOXES,
		NULL);


  fs_give((void **) &server);
  pop_cursor();
  return;
}




#ifdef __STDC__
void mailboxes_create(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_create(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;
  char *server_str;
  char *mailbox_str;
  MAILSTREAM *mailstream = NULL;

  mailbox_str = get_mailbox_string_from_window(mailbox_win);
  if(mailbox_str == NULL)
    return;

  push_cursor(WATCH_CURSOR);

  server_str = get_server_string_from_window(mailbox_win);
  server = GetTextField(mailbox_win->server);

  if(mailbox_win->type == MAILBOX_TYPE_MAIL) {
    if(*server_str != NUL_TERM) {
      mailstream = mail_open(NIL, server_str , OP_HALFOPEN);
      mail_create(mailstream,mailbox_str);
      mail_subscribe(mailstream,mailbox_str);
      mail_close(mailstream);
    }
    else {
      mail_create(NIL,mailbox_str);
      mail_subscribe(NIL,mailbox_str);
    }
  }
  else
    mail_subscribe_bboard(mailstream,mailbox_str + 1);

  stuff_mailbox_list(mailbox_win,server, TRUE, mailbox_win->everything);

  fs_give((void **) &server);
  fs_give((void **) &server_str);
  fs_give((void **) &mailbox_str);

  pop_cursor();
  return;
}

#ifdef __STDC__
void mailboxes_create_only(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_create_only(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server_str;
  char *mailbox_str;
  MAILSTREAM *mailstream = NULL;

  mailbox_str = get_mailbox_string_from_window(mailbox_win);
  if(mailbox_str == NULL)
    return;

  push_cursor(WATCH_CURSOR);

  server_str = get_server_string_from_window(mailbox_win);

  if(mailbox_win->type == MAILBOX_TYPE_MAIL) {
    if(*server_str != NUL_TERM) {
      mailstream = mail_open(NIL, server_str , OP_HALFOPEN);
      mail_create(mailstream,mailbox_str);
      mail_close(mailstream);
    }
    else 
      mail_create(NIL,mailbox_str);
  }

  fs_give((void **) &server_str);
  fs_give((void **) &mailbox_str);

  pop_cursor();
  return;

}

#ifdef __STDC__
void mailboxes_subscribe_only(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_subscribe_only(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;
  char *server_str;
  char *mailbox_str;
  MAILSTREAM *mailstream = NULL;

  mailbox_str = get_mailbox_string_from_window(mailbox_win);
  if(mailbox_str == NULL)
    return;

  push_cursor(WATCH_CURSOR);

  server_str = get_server_string_from_window(mailbox_win);
  server = GetTextField(mailbox_win->server);

#ifdef IMAP4
  if((mailbox_win->type == MAILBOX_TYPE_MAIL)
     || (mailbox_win->type == MAILBOX_TYPE_NEWS)) {
#else /* IMAP4 */
  if(mailbox_win->type == MAILBOX_TYPE_MAIL) {
#endif /* IMAP4 */

    if(*server_str != NUL_TERM) {
      mailstream = mail_open(NIL, server_str , OP_HALFOPEN);
      mail_subscribe(mailstream,mailbox_str);
      mail_close(mailstream);
    }
    else {
      mail_subscribe(NIL,mailbox_str);
    }
  }
  else
    mail_subscribe_bboard(mailstream,mailbox_str + 1);

  stuff_mailbox_list(mailbox_win,server, TRUE, mailbox_win->everything);

  fs_give((void **) &server);
  fs_give((void **) &server_str);
  fs_give((void **) &mailbox_str);

  pop_cursor();
  return;
}


#ifdef __STDC__
void mailboxes_delete(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_delete(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;
  char *server_str;
  char *mailbox_str;
  MAILSTREAM *mailstream = NULL;

  mailbox_str = get_mailbox_string_from_window(mailbox_win);
  if(mailbox_str == NULL)
    return;

  close_invalid_mailbox(mailbox_str);

  push_cursor(WATCH_CURSOR);

  server_str = get_server_string_from_window(mailbox_win);
  server = GetTextField(mailbox_win->server);

#ifdef IMAP4
  if((mailbox_win->type == MAILBOX_TYPE_MAIL)
     || (mailbox_win->type == MAILBOX_TYPE_NEWS)) {
#else /* IMAP4 */
  if(mailbox_win->type == MAILBOX_TYPE_MAIL) {
#endif /* IMAP4 */

    if(*server_str != NUL_TERM) {
	mailstream = mail_open(NIL, server_str, OP_HALFOPEN);
	mail_unsubscribe(mailstream,mailbox_str);
	if((ml_confirm(mailbox_win->shell,DESTROY_MAILBOX)) == TRUE)
	  mail_delete(mailstream,mailbox_str);
	mail_close(mailstream);
    }
    else {
      mail_unsubscribe(NIL,mailbox_str);
      mail_delete(NIL,mailbox_str);
    }
  }
  else
    mail_unsubscribe_bboard(mailstream,mailbox_str + 1);

  stuff_mailbox_list(mailbox_win,server, TRUE, mailbox_win->everything);
  XmTextSetString(mailbox_win->mailbox,EMPTYSTR);

  fs_give((void **) &server);
  fs_give((void **) &server_str);
  fs_give((void **) &mailbox_str);

  pop_cursor();
  return;
}


#ifdef __STDC__
void mailboxes_delete_only(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_delete_only(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server_str;
  char *mailbox_str;
  MAILSTREAM *mailstream = NULL;

  mailbox_str = get_mailbox_string_from_window(mailbox_win);
  if(mailbox_str == NULL)
    return;

  close_invalid_mailbox(mailbox_str);

  push_cursor(WATCH_CURSOR);

  server_str = get_server_string_from_window(mailbox_win);

  if(mailbox_win->type == MAILBOX_TYPE_MAIL) {
    if(*server_str != NUL_TERM) {
      mailstream = mail_open(NIL, server_str, OP_HALFOPEN);
      if((ml_confirm(mailbox_win->shell,DESTROY_MAILBOX)) == TRUE)
	mail_delete(mailstream,mailbox_str);
      mail_close(mailstream);
    }
    else {
      mail_delete(NIL,mailbox_str);
    }
  }

  XmTextSetString(mailbox_win->mailbox,EMPTYSTR);

  fs_give((void **) &server_str);
  fs_give((void **) &mailbox_str);

  pop_cursor();
  return;
}



#ifdef __STDC__
void mailboxes_unsubscribe_only(Widget w, Mailbox_Win *mailbox_win, 
				XtPointer xp)
#else
void mailboxes_unsubscribe_only(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;
  char *server_str;
  char *mailbox_str;
  MAILSTREAM *mailstream = NULL;

  mailbox_str = get_mailbox_string_from_window(mailbox_win);
  if(mailbox_str == NULL)
    return;

  close_invalid_mailbox(mailbox_str);

  push_cursor(WATCH_CURSOR);

  server_str = get_server_string_from_window(mailbox_win);
  server = GetTextField(mailbox_win->server);


#ifdef IMAP4
  if((mailbox_win->type == MAILBOX_TYPE_MAIL)
     || (mailbox_win->type == MAILBOX_TYPE_NEWS)) {
#else /* IMAP4 */
  if(mailbox_win->type == MAILBOX_TYPE_MAIL) {
#endif /* IMAP4 */

    if(*server_str != NUL_TERM) {
      mailstream = mail_open(NIL, server_str, OP_HALFOPEN);
      mail_unsubscribe(mailstream,mailbox_str);
      mail_close(mailstream);
    }
    else {
      mail_unsubscribe(NIL,mailbox_str);
    }
  }
  else
    mail_unsubscribe_bboard(mailstream,mailbox_str + 1);

  stuff_mailbox_list(mailbox_win,server, TRUE, mailbox_win->everything);
  XmTextSetString(mailbox_win->mailbox,EMPTYSTR);

  fs_give((void **) &server);
  fs_give((void **) &server_str);
  fs_give((void **) &mailbox_str);

  pop_cursor();
  return;
}



#ifdef __STDC__
void mailboxes_rename(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_rename(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;
  char *server_str;
  char *mailbox_str;
  char *newname;
  char *fixednewname;
  char *formattednewname;

  MAILSTREAM *mailstream = NULL;
  
  if(mailbox_win->type == MAILBOX_TYPE_NEWS)
    return;

  push_cursor(WATCH_CURSOR);

  newname = input_string(mailbox_win->shell,NEWMAILBOXNAME, 
			 NULL, RENAMEMAILBOXHELPFILE);
  
  if(newname == NULL) 
    return;

  if(*newname == NUL_TERM) {
    fs_give((void **) &newname);
    return;
  }

  mailbox_str = get_mailbox_string_from_window(mailbox_win);
  if(mailbox_str == NULL) {
    fs_give((void **) &newname);
    return;
  }

  close_invalid_mailbox(mailbox_str);

  server_str = get_server_string_from_window(mailbox_win);
  server = GetTextField(mailbox_win->server);

  fixednewname = fix_mailboxpath(newname);
  fs_give((void **) &newname);
  formattednewname = 
    format_mailbox_name(server,fixednewname,mailbox_win->type);
  fs_give((void **) &fixednewname);

  if(strcmp(mailbox_str,formattednewname) != STRMATCH) {
    if(*server_str != NUL_TERM) {
      mailstream = mail_open(NIL, server_str, OP_HALFOPEN);
      mail_unsubscribe(mailstream,mailbox_str);
      mail_rename(mailstream,mailbox_str,formattednewname);
      mail_subscribe(mailstream,formattednewname);
      mail_close(mailstream);
    }
    else {
      mail_unsubscribe(NIL,mailbox_str);
      mail_rename(NIL,mailbox_str,formattednewname);
      mail_subscribe(NIL,formattednewname);
    }
    stuff_mailbox_list(mailbox_win,server, TRUE, mailbox_win->everything);
  }

  XmTextSetString(mailbox_win->mailbox,EMPTYSTR);

  fs_give((void **) &server);
  fs_give((void **) &server_str);
  fs_give((void **) &mailbox_str);
  fs_give((void **) &formattednewname);

  pop_cursor();
  return;
}

#ifdef __STDC__
void mailboxes_setmail(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_setmail(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *fixedserver = get_qualified_host_name(preferences.imap_server);

  push_cursor(WATCH_CURSOR);

  if(fixedserver) {
    XmTextSetString(mailbox_win->server,fixedserver);
    XmTextSetString(mailbox_win->mailbox, EMPTYSTR);

    mailbox_win->button_state |= BTN_MAILBOX_DOMAIL;
    mailbox_win->button_state &= ~(BTN_MAILBOX_DONEWS);
    
    mailbox_win->type = MAILBOX_TYPE_MAIL;
    stuff_mailbox_list(mailbox_win, fixedserver, 
		       FALSE, mailbox_win->everything);
    fs_give((void **) &fixedserver);
    check_buttons(mailboxopen_menu,XtNumber(mailboxopen_menu),
		  session.buttons[MAILBOX_BTN_MENU], 
		  mailbox_win->button_state);

  }
  pop_cursor();
  return;
}


#ifdef __STDC__
void mailboxes_setnews(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_setnews(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *fixedserver = get_qualified_host_name(preferences.nntp_server);

  push_cursor(WATCH_CURSOR);

  if(fixedserver) {
    XmTextSetString(mailbox_win->server,fixedserver);
    XmTextSetString(mailbox_win->mailbox, EMPTYSTR);

    mailbox_win->button_state |= BTN_MAILBOX_DONEWS;
    mailbox_win->button_state &= ~(BTN_MAILBOX_DOMAIL);

    mailbox_win->type = MAILBOX_TYPE_NEWS;
    stuff_mailbox_list(mailbox_win, fixedserver, 
		       FALSE, mailbox_win->everything);
    fs_give((void **) &fixedserver);

    check_buttons(mailboxopen_menu,XtNumber(mailboxopen_menu),
		  session.buttons[MAILBOX_BTN_MENU], 
		  mailbox_win->button_state);
  }

  pop_cursor();
  return;
}


#ifdef __STDC__
void mailboxes_server(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_server(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server = GetTextField(mailbox_win->server);
  char *fixedserver = get_qualified_host_name(server);

  push_cursor(WATCH_CURSOR);

  if(fixedserver) {
    XmTextSetString(mailbox_win->server,fixedserver);
    XmTextSetString(mailbox_win->mailbox, EMPTYSTR);
    mailbox_win->type = MAILBOX_TYPE_MAIL;
    stuff_mailbox_list(mailbox_win, fixedserver, 
		       FALSE, mailbox_win->everything);
    fs_give((void **) &fixedserver);
  }
  XmProcessTraversal(mailbox_win->shell, XmTRAVERSE_NEXT_TAB_GROUP);
  fs_give((void **) &server);
  pop_cursor();
  return;
}

#ifdef __STDC__
void mailboxes_pattern(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_pattern(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server = GetTextField(mailbox_win->server);
  char *fixedserver = get_qualified_host_name(server);

  push_cursor(WATCH_CURSOR);

  if(fixedserver) {
    XmTextSetString(mailbox_win->server,fixedserver);
    XmTextSetString(mailbox_win->mailbox, EMPTYSTR);
    stuff_mailbox_list(mailbox_win, fixedserver, 
		       FALSE, mailbox_win->everything);
    fs_give((void **) &fixedserver);
  }
  XmProcessTraversal(mailbox_win->shell, XmTRAVERSE_NEXT_TAB_GROUP);
  fs_give((void **) &server);

  pop_cursor();
  return;
}

#ifdef __STDC__
void mailboxes_select(Widget w, Mailbox_Win *mailbox_win, 
		   XmListCallbackStruct *xp)
#else
void mailboxes_select(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XmListCallbackStruct *xp;
#endif
{
  char *str;

  XmStringGetLtoR(xp->item, XmSTRING_DEFAULT_CHARSET, &str);
  XmTextSetString(mailbox_win->mailbox,str);
  fs_give((void **) &str);

  /* In case they turned it off, keep it enabled. */
  XmListSelectPos(mailbox_win->list,xp->item_position,FALSE);
  mailbox_win->item_no = (unsigned long) xp->item_position;
  mailbox_win->button_state &= ~(BTN_NOSELECTION);
  check_buttons(mailboxopen_menu,XtNumber(mailboxopen_menu),
		session.buttons[MAILBOX_BTN_MENU], mailbox_win->button_state);
  
  return;
}

#ifdef __STDC__
void mailboxes_open(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_open(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;
  char *fixedserver;
  char *mailboxname;
  char *fixedname;

  Mailbox *mailbox = new_mailbox();

  push_cursor(WATCH_CURSOR);

  mailbox->has_new_mail = FALSE;
  mailbox->auto_scan = FALSE;
  server = GetTextField(mailbox_win->server);
  fixedserver = get_qualified_host_name(server);

  mailboxname = GetTextField(mailbox_win->mailbox);
  fixedname = fix_mailboxpath(mailboxname);

  mailbox->host = cpystr(fixedserver);
  mailbox->mailboxname = cpystr(fixedname);
  mailbox->type = mailbox_win->type;

  if(*fixedname != NUL_TERM)
    mailbox->imapname = format_mailbox_name(fixedserver, 
					    fixedname, 
					    mailbox_win->type);

  fs_give((void **) &server);
  fs_give((void **) &fixedserver);
  fs_give((void **) &mailboxname);
  fs_give((void **) &fixedname);

  if((mailbox->imapname != NULL) && (*mailbox->imapname != NUL_TERM))
    open_mailbox(mailbox, FALSE);
  else
    free_mailbox(mailbox);

  pop_cursor();
  return;
}

#ifdef __STDC__
void mailboxes_scan(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_scan(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;
  char *fixedserver;
  char *mailboxname;
  char *fixedname;
  int current_count;
  Mailbox *mailbox;

  if(mailbox_win->item_no == 0L) {
    mm_log(NOSELECTEDMAILBOX, WARN);
    return;
  }

  mailbox = new_mailbox();

  push_cursor(WATCH_CURSOR);

  close_autoscan_mailbox();

  mailbox->has_new_mail = FALSE;
  mailbox->auto_scan = TRUE;
  server = GetTextField(mailbox_win->server);
  fixedserver = get_qualified_host_name(server);

  mailboxname = GetTextField(mailbox_win->mailbox);
  fixedname = fix_mailboxpath(mailboxname);

  mailbox->host = cpystr(fixedserver);
  mailbox->mailboxname = cpystr(fixedname);
  mailbox->type = mailbox_win->type;

  if(*fixedname != NUL_TERM)
    mailbox->imapname = format_mailbox_name(fixedserver, 
					    fixedname, 
					    mailbox_win->type);

  fs_give((void **) &server);
  fs_give((void **) &fixedserver);
  fs_give((void **) &mailboxname);
  fs_give((void **) &fixedname);

  if((mailbox->imapname != NULL) && (*mailbox->imapname != NUL_TERM))
    open_mailbox(mailbox, FALSE);
  else
    free_mailbox(mailbox);

  XmListDeselectAllItems(mailbox_win->list);
  XtVaGetValues(mailbox_win->list, XmNitemCount, &current_count, NULL);
  if(mailbox_win->item_no < current_count) 
    XmListSelectPos(mailbox_win->list,mailbox_win->item_no + 1, TRUE);
  else {
    mailbox_win->item_no = 0L;
    mailbox_win->button_state |= BTN_NOSELECTION;
    check_buttons(mailboxopen_menu,XtNumber(mailboxopen_menu),
		  session.buttons[MAILBOX_BTN_MENU], mailbox_win->button_state);
  }
  pop_cursor();
  return;
}

#ifdef __STDC__
void mailboxes_cancel(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_cancel(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  XtRemoveCallback(mailbox_win->shell, XmNdestroyCallback, 
		   (XtCallbackProc) mailboxes_destroy, mailbox_win);
  XtDestroyWidget(mailbox_win->shell);
  mailbox_win->is_realized = FALSE;
  return;
}

#ifdef __STDC__
void mailboxes_destroy(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_destroy(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  mailbox_win->is_realized = FALSE;
  return;
}


#ifdef __STDC__
void mailboxes_help(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mailboxes_help(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  help(mailbox_win->shell,MAILBOXESHELPTITLE, 
       OMAILBOXESHELPFILE, DOCTYPE_ENRICHED);
  return;
}

/* "news" parameter currently unused. */

#ifdef __STDC__
void mailboxes(Boolean news)
#else
void mailboxes(news)
     Boolean news;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  int i = 0;
  Widget form, menubar;
  Mailbox_Win *mailbox_win;
  XtTranslations translations;
  char *ret = NULL;
  char *server;
  char *mailboxname;
  char *fixedname;
  char *fixedserver;

  if(session.mailboxlist == NULL) {
    mailbox_win = (Mailbox_Win *) fs_get(sizeof(Mailbox_Win));
    session.mailboxlist = mailbox_win;
  }
  else 
    mailbox_win = session.mailboxlist;

  if(session.mailboxlist->is_realized == TRUE) {
    de_iconify(mailbox_win->shell);
    return;
  }

  mailbox_win->button_state = BTN_NOSELECTION;
  if(news) 
    mailbox_win->button_state |= BTN_MAILBOX_DONEWS;
  else
    mailbox_win->button_state |= BTN_MAILBOX_DOMAIL;
  
  mailbox_win->type = (news) ? MAILBOX_TYPE_NEWS : MAILBOX_TYPE_MAIL;
  mailbox_win->everything = FALSE;
  mailbox_win->is_realized = FALSE;
  mailbox_win->item_no = 0;
  mailbox_win->top_level = TRUE;

  push_cursor(WATCH_CURSOR);

  mailbox_win->shell = XtAppCreateShell("MLmailopen","MLmailopen",
				       topLevelShellWidgetClass, display,
				       args, n); 
  n = 0;

  setup_editres(mailbox_win->shell);

  if(mbox_icon != (Pixmap) None)
    XtVaSetValues(mailbox_win->shell,
		  XmNiconPixmap,mbox_icon,
		  NULL);

  form = XmCreateForm(mailbox_win->shell, "form", args, n ); n = 0;

  XtSetArg(args[n], XmNtopAttachment,   XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment,  XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  menubar = XmCreateMenuBar(form, "menubar", args, n); n = 0;
  XtManageChild(menubar);

  create_buttons(NULL, menubar, mailboxopen_menu, 
		 XtNumber(mailboxopen_menu),
		 mailbox_win->button_state, 
		 (XtPointer) mailbox_win, ROOTMENULEVEL);

  XtSetArg(args[n], XmNtopAttachment,   XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, menubar);  n ++;
  XtSetArg(args[n], XmNleftAttachment,  XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNorientation, XmHORIZONTAL); n ++;
  XtSetArg(args[n], XmNpacking, XmPACK_TIGHT); n ++;

  mailbox_win->rowcol = XmCreateRowColumn(form, "rowcol", args, n); n = 0;

  mailboxes_default_buttons();

  make_pbuttons(mailbox_win->rowcol, session.buttons[MAILBOX_BTN_MENU], 
		mailbox_win->button_state, (XtPointer) mailbox_win);
		
  XtManageChild(mailbox_win->rowcol);

  fixedserver = get_qualified_host_name(preferences.imap_server);
  mailbox_win->server =
    create_text_field(form, mailbox_win->rowcol, 
		      "server", fixedserver,0, 
		      (XtPointer) mailboxes_server, (XtPointer) mailbox_win);


  mailbox_win->pattern = 
    create_text_field(form,mailbox_win->server,
		      "pattern",
		      (mailbox_win->type == MAILBOX_TYPE_MAIL) ?
		      preferences.default_mailbox_pattern : MAILBOXALLPATTERN,
		      0, (XtPointer) mailboxes_pattern, 
		      (XtPointer) mailbox_win);

  fixedname = unfix_mailboxpath(preferences.default_mailbox);

  mailbox_win->mailbox =
    create_text_field(form, mailbox_win->pattern, 
		      "mailbox", fixedname,
		      0, (XtPointer) mailboxes_open,(XtPointer) mailbox_win);

  fs_give((void **) &fixedname);

  XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmSTATIC); n ++;
  XtSetArg(args[n], XmNlistSizePolicy,XmCONSTANT);        n ++;
  XtSetArg(args[n], XmNselectionPolicy,XmSINGLE_SELECT);  n ++;
  mailbox_win->list = XmCreateScrolledList(form,"list",args,n); 
  n = 0;

  XtAddCallback(mailbox_win->list, XmNsingleSelectionCallback, 
		(XtCallbackProc) mailboxes_select, mailbox_win);
  XtAddCallback(mailbox_win->list, XmNdefaultActionCallback, 
		(XtCallbackProc) mailboxes_open, mailbox_win);

  XtAddCallback(mailbox_win->shell, XmNdestroyCallback, 
		(XtCallbackProc) mailboxes_destroy, mailbox_win);

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, mailbox_win->mailbox); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n ++;

  XtSetValues(XtParent(mailbox_win->list), args, n); n = 0;
  XtManageChild(mailbox_win->list);

  XtManageChild(form);

  stuff_mailbox_list(mailbox_win, fixedserver, FALSE, mailbox_win->everything);
  fs_give((void **) &fixedserver);

  XtRealizeWidget(mailbox_win->shell);

  XmProcessTraversal(mailbox_win->shell, XmTRAVERSE_NEXT_TAB_GROUP);
  XmProcessTraversal(mailbox_win->shell, XmTRAVERSE_NEXT_TAB_GROUP);

  pop_cursor();
  mailbox_win->is_realized = TRUE;
  return;
}


#ifdef __STDC__
void close_invalid_mailbox(char *str)
#else
void close_invalid_mailbox(str)
     char *str;
#endif
{
  Mailbox *mailbox;
  Boolean found;
  do {
    found = FALSE;
    for(mailbox = session.mailboxes; mailbox; mailbox = mailbox->next) {
      if(strcmp(str,mailbox->imapname) == STRMATCH) {
	found = TRUE;
	close_mailbox(mailbox);
	break;
      }
    }
  } while(found == TRUE);
  return;
}


#ifdef __STDC__
void close_autoscan_mailbox(void)
#else
void close_autoscan_mailbox()
#endif
{
  Mailbox *mailbox;
  Boolean found;
  do {
    found = FALSE;
    for(mailbox = session.mailboxes; mailbox; mailbox = mailbox->next) {
      if(mailbox->auto_scan == TRUE) {
	found = TRUE;
	close_mailbox(mailbox);
	break;
      }
    }
  } while(found == TRUE);
  return;
}


#ifdef __STDC__
void mblist_everything(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mblist_everything(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;

  XDefineCursor(display, XtWindow(mailbox_win->shell), clock_cursor);

  server = GetTextField(mailbox_win->server);

  mailbox_win->everything = TRUE;

  stuff_mailbox_list(mailbox_win,server, TRUE, mailbox_win->everything);
  XtVaSetValues(mailbox_win->shell,
		XmNtitle, ALLMAILBOXES,
		NULL);


  fs_give((void **) &server);

  XUndefineCursor(display, XtWindow(mailbox_win->shell));
}


#ifdef __STDC__
void mblist_subscribed(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mblist_subscribed(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;

  XDefineCursor(display, XtWindow(mailbox_win->shell), clock_cursor);

  server = GetTextField(mailbox_win->server);

  mailbox_win->everything = FALSE;

  stuff_mailbox_list(mailbox_win,server, TRUE, mailbox_win->everything);

  XtVaSetValues(mailbox_win->shell,
		XmNtitle, SUBMAILBOXES,
		NULL);

  fs_give((void **) &server);

  XUndefineCursor(display, XtWindow(mailbox_win->shell));
}

#ifdef __STDC__
void mblist_create(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mblist_create(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;
  char *server_str;
  char *mailbox_str;
  MAILSTREAM *mailstream = NULL;

  mailbox_str = get_mailbox_string_from_window(mailbox_win);
  if(mailbox_str == NULL)
    return;

  XDefineCursor(display, XtWindow(mailbox_win->shell), clock_cursor);

  server_str = get_server_string_from_window(mailbox_win);
  server = GetTextField(mailbox_win->server);

#ifdef IMAP4
  if((mailbox_win->type == MAILBOX_TYPE_MAIL)
     || (mailbox_win->type == MAILBOX_TYPE_NEWS)) {
#else /* IMAP4 */
  if(mailbox_win->type == MAILBOX_TYPE_MAIL) {
#endif /* IMAP4 */

    if(*server_str != NUL_TERM) {
      mailstream = mail_open(NIL, server_str , OP_HALFOPEN);
      mail_create(mailstream,mailbox_str);
      mail_subscribe(mailstream,mailbox_str);
      mail_close(mailstream);
    }
    else {
      mail_create(NIL,mailbox_str);
      mail_subscribe(NIL,mailbox_str);
    }
  }
  else
    mail_subscribe_bboard(mailstream,mailbox_str + 1);

  stuff_mailbox_list(mailbox_win,server, TRUE, mailbox_win->everything);

  fs_give((void **) &server);
  fs_give((void **) &server_str);
  fs_give((void **) &mailbox_str);

  XUndefineCursor(display, XtWindow(mailbox_win->shell));
}

#ifdef __STDC__
void mblist_create_only(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mblist_create_only(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server_str;
  char *mailbox_str;
  MAILSTREAM *mailstream = NULL;

  mailbox_str = get_mailbox_string_from_window(mailbox_win);
  if(mailbox_str == NULL)
    return;

  XDefineCursor(display, XtWindow(mailbox_win->shell), clock_cursor);

  server_str = get_server_string_from_window(mailbox_win);

  if(mailbox_win->type == MAILBOX_TYPE_MAIL) {
    if(*server_str != NUL_TERM) {
      mailstream = mail_open(NIL, server_str , OP_HALFOPEN);
      mail_create(mailstream,mailbox_str);
      mail_close(mailstream);
    }
    else 
      mail_create(NIL,mailbox_str);
  }

  fs_give((void **) &server_str);
  fs_give((void **) &mailbox_str);

  XUndefineCursor(display, XtWindow(mailbox_win->shell));
}

#ifdef __STDC__
void mblist_subscribe_only(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mblist_subscribe_only(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;
  char *server_str;
  char *mailbox_str;
  MAILSTREAM *mailstream = NULL;

  mailbox_str = get_mailbox_string_from_window(mailbox_win);
  if(mailbox_str == NULL)
    return;

  XDefineCursor(display, XtWindow(mailbox_win->shell), clock_cursor);

  server_str = get_server_string_from_window(mailbox_win);
  server = GetTextField(mailbox_win->server);


#ifdef IMAP4
  if((mailbox_win->type == MAILBOX_TYPE_MAIL)
     || (mailbox_win->type == MAILBOX_TYPE_NEWS)) {
#else /* IMAP4 */
  if(mailbox_win->type == MAILBOX_TYPE_MAIL) {
#endif /* IMAP4 */

    if(*server_str != NUL_TERM) {
      mailstream = mail_open(NIL, server_str , OP_HALFOPEN);
      mail_subscribe(mailstream,mailbox_str);
      mail_close(mailstream);
    }
    else {
      mail_subscribe(NIL,mailbox_str);
    }
  }
  else
    mail_subscribe_bboard(mailstream,mailbox_str + 1);

  stuff_mailbox_list(mailbox_win,server, TRUE, mailbox_win->everything);

  fs_give((void **) &server);
  fs_give((void **) &server_str);
  fs_give((void **) &mailbox_str);

  XUndefineCursor(display, XtWindow(mailbox_win->shell));
}


#ifdef __STDC__
void mblist_delete(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mblist_delete(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;
  char *server_str;
  char *mailbox_str;
  MAILSTREAM *mailstream = NULL;

  mailbox_str = get_mailbox_string_from_window(mailbox_win);
  if(mailbox_str == NULL)
    return;

  close_invalid_mailbox(mailbox_str);

  XDefineCursor(display, XtWindow(mailbox_win->shell), clock_cursor);

  server_str = get_server_string_from_window(mailbox_win);
  server = GetTextField(mailbox_win->server);

#ifdef IMAP4
  if((mailbox_win->type == MAILBOX_TYPE_MAIL)
     || (mailbox_win->type == MAILBOX_TYPE_NEWS)) {
#else /* IMAP4 */
  if(mailbox_win->type == MAILBOX_TYPE_MAIL) {
#endif /* IMAP4 */

    if(*server_str != NUL_TERM) {
	mailstream = mail_open(NIL, server_str, OP_HALFOPEN);
	mail_unsubscribe(mailstream,mailbox_str);
	XDefineCursor(display, XtWindow(mailbox_win->shell), pirate_cursor);
	if((ml_confirm(mailbox_win->shell,DESTROY_MAILBOX)) == TRUE)
	  mail_delete(mailstream,mailbox_str);
	XDefineCursor(display, XtWindow(mailbox_win->shell), clock_cursor);
	set_pirate_cursors();
	mail_close(mailstream);
    }
    else {
      mail_unsubscribe(NIL,mailbox_str);
      mail_delete(NIL,mailbox_str);
    }
  }
  else
    mail_unsubscribe_bboard(mailstream,mailbox_str + 1);

  stuff_mailbox_list(mailbox_win,server, TRUE, mailbox_win->everything);
  XmTextSetString(mailbox_win->mailbox,EMPTYSTR);

  fs_give((void **) &server);
  fs_give((void **) &server_str);
  fs_give((void **) &mailbox_str);

  XUndefineCursor(display, XtWindow(mailbox_win->shell));
  return;
}


#ifdef __STDC__
void mblist_delete_only(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mblist_delete_only(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server_str;
  char *mailbox_str;
  MAILSTREAM *mailstream = NULL;

  mailbox_str = get_mailbox_string_from_window(mailbox_win);
  if(mailbox_str == NULL)
    return;

  close_invalid_mailbox(mailbox_str);

  XDefineCursor(display, XtWindow(mailbox_win->shell), clock_cursor);

  server_str = get_server_string_from_window(mailbox_win);

  if(mailbox_win->type == MAILBOX_TYPE_MAIL) {
    if(*server_str != NUL_TERM) {
      mailstream = mail_open(NIL, server_str, OP_HALFOPEN);
      XDefineCursor(display, XtWindow(mailbox_win->shell), pirate_cursor);
      if((ml_confirm(mailbox_win->shell,DESTROY_MAILBOX)) == TRUE)
	mail_delete(mailstream,mailbox_str);
      XDefineCursor(display, XtWindow(mailbox_win->shell), clock_cursor);
      set_pirate_cursors();
      mail_close(mailstream);
    }
    else {
      mail_delete(NIL,mailbox_str);
    }
  }

  XmTextSetString(mailbox_win->mailbox,EMPTYSTR);

  fs_give((void **) &server_str);
  fs_give((void **) &mailbox_str);

  XUndefineCursor(display, XtWindow(mailbox_win->shell));
  return;
}



#ifdef __STDC__
void mblist_unsubscribe_only(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mblist_unsubscribe_only(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;
  char *server_str;
  char *mailbox_str;
  MAILSTREAM *mailstream = NULL;

  mailbox_str = get_mailbox_string_from_window(mailbox_win);
  if(mailbox_str == NULL)
    return;

  close_invalid_mailbox(mailbox_str);

  XDefineCursor(display, XtWindow(mailbox_win->shell), clock_cursor);

  server_str = get_server_string_from_window(mailbox_win);
  server = GetTextField(mailbox_win->server);

#ifdef IMAP4
  if((mailbox_win->type == MAILBOX_TYPE_MAIL)
     || (mailbox_win->type == MAILBOX_TYPE_NEWS)) {
#else /* IMAP4 */
  if(mailbox_win->type == MAILBOX_TYPE_MAIL) {
#endif /* IMAP4 */

    if(*server_str != NUL_TERM) {
      mailstream = mail_open(NIL, server_str, OP_HALFOPEN);
      mail_unsubscribe(mailstream,mailbox_str);
      mail_close(mailstream);
    }
    else {
      mail_unsubscribe(NIL,mailbox_str);
    }
  }
  else
    mail_unsubscribe_bboard(mailstream,mailbox_str + 1);

  stuff_mailbox_list(mailbox_win,server, TRUE, mailbox_win->everything);
  XmTextSetString(mailbox_win->mailbox,EMPTYSTR);

  fs_give((void **) &server);
  fs_give((void **) &server_str);
  fs_give((void **) &mailbox_str);

  XUndefineCursor(display, XtWindow(mailbox_win->shell));
  return;
}



#ifdef __STDC__
void mblist_rename(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mblist_rename(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server;
  char *server_str;
  char *mailbox_str;
  char *newname;
  char *fixednewname;
  char *formattednewname;

  MAILSTREAM *mailstream = NULL;
  
  if(mailbox_win->type == MAILBOX_TYPE_NEWS)
    return;

  XDefineCursor(display, XtWindow(mailbox_win->shell), pirate_cursor);

  newname = input_string(mailbox_win->shell,NEWMAILBOXNAME, 
			 NULL, RENAMEMAILBOXHELPFILE);
  
  XUndefineCursor(display, XtWindow(mailbox_win->shell));
  
  if(newname == NULL) 
    return;

  if(*newname == NUL_TERM) {
    fs_give((void **) &newname);
    return;
  }

  mailbox_str = get_mailbox_string_from_window(mailbox_win);
  if(mailbox_str == NULL) {
    fs_give((void **) &newname);
    return;
  }

  close_invalid_mailbox(mailbox_str);

  XDefineCursor(display, XtWindow(mailbox_win->shell), clock_cursor);

  server_str = get_server_string_from_window(mailbox_win);
  server = GetTextField(mailbox_win->server);

  fixednewname = fix_mailboxpath(newname);
  fs_give((void **) &newname);
  formattednewname = 
    format_mailbox_name(server,fixednewname,mailbox_win->type);
  fs_give((void **) &fixednewname);

  if(strcmp(mailbox_str,formattednewname) != STRMATCH) {
    if(*server_str != NUL_TERM) {
      mailstream = mail_open(NIL, server_str, OP_HALFOPEN);
      mail_unsubscribe(mailstream,mailbox_str);
      mail_rename(mailstream,mailbox_str,formattednewname);
      mail_subscribe(mailstream,formattednewname);
      mail_close(mailstream);
    }
    else {
      mail_unsubscribe(NIL,mailbox_str);
      mail_rename(NIL,mailbox_str,formattednewname);
      mail_subscribe(NIL,formattednewname);
    }
    stuff_mailbox_list(mailbox_win,server, TRUE, mailbox_win->everything);
  }

  XmTextSetString(mailbox_win->mailbox,EMPTYSTR);

  fs_give((void **) &server);
  fs_give((void **) &server_str);
  fs_give((void **) &mailbox_str);
  fs_give((void **) &formattednewname);

  XUndefineCursor(display, XtWindow(mailbox_win->shell));
  return;
}

#ifdef __STDC__
void mblist_server(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mblist_server(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server = GetTextField(mailbox_win->server);
  char *fixedserver = get_qualified_host_name(server);

  XDefineCursor(display, XtWindow(mailbox_win->shell), clock_cursor);

  if(fixedserver) {
    XmTextSetString(mailbox_win->server,fixedserver);
    XmTextSetString(mailbox_win->mailbox, EMPTYSTR);
    mailbox_win->type = MAILBOX_TYPE_MAIL;
    stuff_mailbox_list(mailbox_win, fixedserver, 
		       FALSE, mailbox_win->everything);
    fs_give((void **) &fixedserver);
  }
  XmProcessTraversal(mailbox_win->shell, XmTRAVERSE_NEXT_TAB_GROUP);
  fs_give((void **) &server);
  XUndefineCursor(display, XtWindow(mailbox_win->shell));
  return;
}

#ifdef __STDC__
void mblist_pattern(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mblist_pattern(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  char *server = GetTextField(mailbox_win->server);
  char *fixedserver = get_qualified_host_name(server);

  XDefineCursor(display, XtWindow(mailbox_win->shell), clock_cursor);

  if(fixedserver) {
    XmTextSetString(mailbox_win->server,fixedserver);
    XmTextSetString(mailbox_win->mailbox, EMPTYSTR);
    stuff_mailbox_list(mailbox_win, fixedserver, 
		       FALSE, mailbox_win->everything);
    fs_give((void **) &fixedserver);
  }
  XmProcessTraversal(mailbox_win->shell, XmTRAVERSE_NEXT_TAB_GROUP);
  fs_give((void **) &server);
  XUndefineCursor(display, XtWindow(mailbox_win->shell));
  return;
}


#ifdef __STDC__
void mblist_accept(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mblist_accept(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  mailbox_win->done = MODAL_LOOP_DONE;
  return;
}

#ifdef __STDC__
void mblist_cancel(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mblist_cancel(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  XmTextSetString(mailbox_win->mailbox,EMPTYSTR);
  mailbox_win->done = MODAL_LOOP_DONE;
  return;
}


#ifdef __STDC__
void mblist_help(Widget w, Mailbox_Win *mailbox_win, XtPointer xp)
#else
void mblist_help(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XtPointer xp;
#endif
{
  help(mailbox_win->shell,MAILBOXESHELPTITLE, 
       MAILBOXESHELPFILE, DOCTYPE_ENRICHED);
  return;
}



#ifdef __STDC__
void mblist_select(Widget w, Mailbox_Win *mailbox_win, 
		   XmListCallbackStruct *xp)
#else
void mblist_select(w,mailbox_win,xp)
     Widget w;
     Mailbox_Win *mailbox_win;
     XmListCallbackStruct *xp;
#endif
{
  char *str;

  XmStringGetLtoR(xp->item, XmSTRING_DEFAULT_CHARSET, &str);
  XmTextSetString(mailbox_win->mailbox,str);
  fs_give((void **) &str);
  return;
}


#ifdef __STDC__
char *fix_mailboxpath(char *str)
#else
char *fix_mailboxpath(str)
     char * str;
#endif
{
  char *ret = NULL;
  char *ptr = NULL;

  if(str == NULL || *str == NUL_TERM)
    return(cpystr(EMPTYSTR));

  if((strcasecmp(str,INBOX)) == 0)
    ucase(str);

  if(*str == '{' && ((ptr = strchr(str,'}')) != NULL))
    ptr ++;
  else
    ptr = str;

  if(*ptr != PLUSCHAR)
    return(cpystr(ptr));

  ptr ++;
  if(*ptr == PLUSCHAR)
    return(cpystr(ptr));

  if((preferences.folder_path == NULL) 
     || (*preferences.folder_path == NUL_TERM))
    return(cpystr(ptr));

  ret = (char *) fs_get(strlen(ptr) + strlen(preferences.folder_path) + 2);

  strcpy(ret,preferences.folder_path);

  if(ret[strlen(ret) - 1] != PATH_SEPARATOR_CHAR)
    strcat(ret,PATH_SEPARATOR_STR);
  strcat(ret,ptr);
  return(ret);
}

#ifdef __STDC__
char *unfix_mailboxpath(char *str)
#else
char *unfix_mailboxpath(str)
     char *str;
#endif
{
  char *buf = NULL;
  char *ret = NULL;
  char *ptr = NULL;

  if((str == NULL) || (*str == NUL_TERM))
    return(cpystr(EMPTYSTR));

  if(*str == '{' && ((ptr = strchr(str,'}')) != NULL))
    ptr ++;
  else
    ptr = str;

  if((preferences.folder_path == NULL) 
     || (*preferences.folder_path == NUL_TERM))
    return(cpystr(ptr));

  buf = (char *) fs_get(strlen(ptr) + strlen(preferences.folder_path) + 2);
  ret = (char *) fs_get(strlen(ptr) + strlen(preferences.folder_path) + 2);

  strcpy(buf,preferences.folder_path);

  if(buf[strlen(buf) - 1] != PATH_SEPARATOR_CHAR)
    strcat(buf,PATH_SEPARATOR_STR);

  if(strncmp(ptr,buf,strlen(buf)) == STRMATCH) {
    strcpy(ret,PLUSSTR);
    strcat(ret,ptr + strlen(buf));
    fs_give((void **) &buf);
  }
  else {
    fs_give((void **) &buf);
    strcpy(ret,ptr);
  }
  return(ret);
}

#ifdef __STDC__
Server_List *get_active_server_list(void)
#else
Server_List *get_active_server_list()
#endif
{
  Server_List *server_list = NULL;
  for(server_list = session.server_list;
      server_list; server_list = server_list->prev) 
    if(server_list->active == TRUE)
	return(server_list);
  return(NULL);
}


#ifdef __STDC__
Server_List *find_server_list(char *server,int type)
#else
Server_List *find_server_list(server,type)
     char *server;
     int type;
#endif
{
  Server_List *server_list = NULL;
  for(server_list = session.server_list;
      server_list; server_list = server_list->prev) {
    if((*server_list->name == NUL_TERM) && (*server == NUL_TERM)
       && (server_list->type == type))
      return(server_list);
    if((strcasecmp(server_list->name,server) == STRMATCH) &&
       (server_list->type == type))
      return(server_list);
  }
  return(NULL);
}


#ifdef __STDC__
char *get_mailbox_name(Widget w, char *current_server,
		       char *default_server,char *default_mailbox,
		       Boolean *changed)
#else
char *get_mailbox_name(w,current_server,default_server,
		       default_mailbox, changed)
     Widget w;
     char *current_server;
     char *default_server;
     char *default_mailbox;
     Boolean *changed;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  Widget form, menubar;
  XtTranslations translations;
  char *ret = NULL;
  char *server;
  char *mailboxname;
  char *fixedname;
  char *fixedserver;

  push_cursor(PIRATE_CURSOR);

  mailbox_win = (Mailbox_Win *) fs_get(sizeof(Mailbox_Win));

  mailbox_win->done = 0;
  mailbox_win->button_state = BTN_ON | BTN_MAILBOX_DOMAIL;
  mailbox_win->type = MAILBOX_TYPE_MAIL;
  mailbox_win->everything = FALSE;
  mailbox_win->top_level = FALSE;

  XtSetArg(args[n], XtNx, -1000); n ++;
  XtSetArg(args[n], XtNy, -1000); n ++;

  mailbox_win->shell = XtCreatePopupShell("mailboxlist_shell",
					  topLevelShellWidgetClass, w,
					  args, n); 
  n = 0;

  setup_editres(mailbox_win->shell);

  if(pirate_icon != (Pixmap) None)
    XtVaSetValues(mailbox_win->shell,
		  XmNiconPixmap,pirate_icon,
		  NULL);
  
  form = XmCreateForm(mailbox_win->shell, "mailboxlist_form", args, n ); n = 0;
  
  XtSetArg(args[n], XmNtopAttachment,   XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment,  XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  menubar = XmCreateMenuBar(form, "mailboxlist_menubar", args, n); n = 0;
  XtManageChild(menubar);

  create_buttons(NULL, menubar, mailboxlist_menu, 
		 XtNumber(mailboxlist_menu),
		 mailbox_win->button_state, 
		 (XtPointer) mailbox_win, ROOTMENULEVEL);

  fixedserver = get_qualified_host_name(default_server);

  mailbox_win->server =
    create_text_field(form, menubar, 
		      "mailboxlist_server", fixedserver,0, 
		      (XtPointer) mblist_server, 
		      (XtPointer) mailbox_win);

  mailbox_win->pattern = 
    create_text_field(form,mailbox_win->server,
		      "mailboxlist_pattern",
		      preferences.default_mailbox_pattern,
		      0, (XtPointer) mblist_pattern, 
		      (XtPointer) mailbox_win);

  fixedname = unfix_mailboxpath(default_mailbox);

  mailbox_win->mailbox =
    create_text_field(form, mailbox_win->pattern, 
		      "mailboxlist_mailbox", fixedname,
		      0, (XtPointer) mblist_accept, 
		      (XtPointer) mailbox_win);

  fs_give((void **) &fixedname);

  XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmSTATIC); n ++;
  XtSetArg(args[n], XmNlistSizePolicy,XmCONSTANT);        n ++;
  XtSetArg(args[n], XmNselectionPolicy,XmSINGLE_SELECT);  n ++;
  mailbox_win->list = XmCreateScrolledList(form,"mailboxlist_list",args,n); 
  n = 0;

  XtAddCallback(mailbox_win->list, XmNsingleSelectionCallback, 
		(XtCallbackProc) mblist_select, mailbox_win);
  XtAddCallback(mailbox_win->list, XmNdefaultActionCallback, 
		(XtCallbackProc) mblist_accept, mailbox_win);

  translations = 
    XtParseTranslationTable(GLOBAL_modal_list_translations);
  XtOverrideTranslations(mailbox_win->list,translations);

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, mailbox_win->mailbox); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n ++;

  XtSetValues(XtParent(mailbox_win->list), args, n); n = 0;
  XtManageChild(mailbox_win->list);

  XtManageChild(form);
  XtManageChild(mailbox_win->shell);

  XtPopup(mailbox_win->shell,XtGrabExclusive);
  XmProcessTraversal(mailbox_win->mailbox, XmTRAVERSE_CURRENT);
  XmProcessTraversal(mailbox_win->mailbox, XmTRAVERSE_CURRENT);

  position_popup_widget(mailbox_win->shell);

  if(fixedserver == NULL)
    fixedserver = cpystr(EMPTYSTR);


  stuff_mailbox_list(mailbox_win, fixedserver, FALSE, mailbox_win->everything);
  fs_give((void **) &fixedserver);

  modal_main_loop(&mailbox_win->done);

  XtPopdown(mailbox_win->shell);

  server = GetTextField(mailbox_win->server);

  fixedserver = get_qualified_host_name(server);

  mailboxname = GetTextField(mailbox_win->mailbox);
  fixedname = fix_mailboxpath(mailboxname);

  if((strcasecmp(current_server,fixedserver)) == STRMATCH) {
    *changed = FALSE;
    ret = cpystr(fixedname);
  }
  else {
    *changed = TRUE;
    ret = format_mailbox_name(fixedserver, fixedname, mailbox_win->type);
  }

  XtDestroyWidget(mailbox_win->shell);

  fs_give((void **) &server);
  fs_give((void **) &fixedserver);
  fs_give((void **) &mailboxname);
  fs_give((void **) &fixedname);
  fs_give((void **) &mailbox_win);

  pop_cursor();
  return(ret);
}

#ifdef __STDC__
void free_mailbox_list(Mailbox_List *mailbox_list)
#else
void free_mailbox_list(mailbox_list)
     Mailbox_List *mailbox_list;
#endif
{
  if(mailbox_list == NULL)
    return;

  free_mailbox_list(mailbox_list->prev);
  if(mailbox_list->name != NULL)
    fs_give((void **) &mailbox_list->name);
  fs_give((void **) &mailbox_list);

  mailbox_list = NULL;
  return;
}


#ifdef __STDC__
void stuff_mailbox_list(Mailbox_Win *mailbox_win,char *server, 
		   Boolean force, Boolean everything)
#else
void stuff_mailbox_list(mailbox_win,server, force, everything)
     Mailbox_Win *mailbox_win;
     char *server;
     Boolean force;
     Boolean everything;
#endif
{
  MAILSTREAM *mailstream;
  Server_List *server_list;
  Mailbox_List *mailbox_list;
  XmString xstr;
  char *fixedname;
  char *imap_server_str;
  char *pattern = NULL;
  Boolean new_server = FALSE;

  XmListDeselectAllItems(mailbox_win->list);
  mailbox_win->item_no = 0L;
  mailbox_win->button_state |= BTN_NOSELECTION;

  if(mailbox_win->top_level == TRUE) {
    if(mailbox_win->is_realized == TRUE)
      check_buttons(mailboxopen_menu,XtNumber(mailboxopen_menu),
		    session.buttons[MAILBOX_BTN_MENU],
		    mailbox_win->button_state);
  }
  else
    check_buttons(mailboxlist_menu,XtNumber(mailboxlist_menu),
		  NULL, mailbox_win->button_state);

  XmListDeleteAllItems(mailbox_win->list);

  if(add_server_to_session(server,mailbox_win->type))
    new_server = TRUE;

  server_list = find_server_list(server,mailbox_win->type);

  pattern = get_mailboxlist_pattern(mailbox_win);
  if(*pattern == NUL_TERM) {
    fs_give((void**) &pattern);
    pattern = cpystr(preferences.default_mailbox_pattern);
  }

  if((server_list->last_pattern == NULL) 
     || strcmp(pattern,server_list->last_pattern) != STRMATCH)
    force = TRUE;
  if(server_list->last_pattern)
    fs_give((void **) &server_list->last_pattern);
  server_list->last_pattern = cpystr(pattern);
  
  if(everything)
    server_list->everything = TRUE;
  else
    server_list->everything = FALSE;

  if(force) {
    if(everything) {
      free_mailbox_list(server_list->mailbox_all_list);
      server_list->mailbox_all_list = NULL;
    }
    else {
      free_mailbox_list(server_list->mailbox_list);
      server_list->mailbox_list = NULL;
    }
  }
  
  if(new_server == TRUE || force) {
    server_list->active = TRUE;
    if(mailbox_win->type == MAILBOX_TYPE_MAIL) {
      imap_server_str = format_server_name(server, MAILBOX_TYPE_MAIL);
      if(*imap_server_str != NUL_TERM) {
	mailstream = mail_open(NIL,imap_server_str,OP_HALFOPEN);
	if(mailstream != NIL) {

#ifdef IMAP4
	  if(everything)	    
	    mail_list(mailstream,NIL,pattern);
	  else 
	    mail_lsub(mailstream,NIL,pattern);
#else /* IMAP4 */
	  if(everything)	    
	    mail_find_all(mailstream,pattern);
	  else 
	    mail_find(mailstream,pattern);
#endif /* IMAP4 */

	  mail_close(mailstream);
	}
      }
      else {

#ifdef IMAP4
	  if(everything)	    
	    mail_list(NIL,NIL,pattern);
	  else 
	    mail_lsub(NIL,NIL,pattern);
#else /* IMAP4 */
	  if(everything)	    
	    mail_find_all(NIL,pattern);
	  else 
	    mail_find(NIL,pattern);
#endif /* IMAP4 */

      }
      fs_give((void **) &imap_server_str);
    }
    else {
      imap_server_str = format_server_name(server, MAILBOX_TYPE_NEWS);
      if(*imap_server_str != NUL_TERM) {
	mailstream = mail_open(NIL,imap_server_str,OP_HALFOPEN);
	if(mailstream != NIL) {


#ifdef IMAP4
	  if(everything)	    
	    mail_list(mailstream,NEWSNAMESTART,pattern);
	  else 
	    mail_lsub(mailstream,NEWSNAMESTART,pattern);
#else /* IMAP4 */
	  if(everything)	    
	    mail_find_all_bboard(mailstream,pattern);
	  else 
	    mail_find_bboards(mailstream,pattern);
#endif /* IMAP4 */

	  mail_close(mailstream);
	}
      }
      else {

#ifdef IMAP4
	if(everything)	    
	  mail_list(NIL,NEWSNAMESTART,pattern);
	else 
	  mail_lsub(NIL,NEWSNAMESTART,pattern);
#else /* IMAP4 */
	if(everything)
	  mail_find_all_bboard(NIL,pattern);
	else
	  mail_find_bboards(NIL, pattern);
#endif /* IMAP4 */

      }
      fs_give((void **) &imap_server_str);
    }
    server_list->active = FALSE;
  }
  
  if((server_list) 
     && ((server_list->everything && server_list->mailbox_all_list != NULL) 
	 || (server_list->mailbox_list != NULL))) {
    sort_mailbox_list(server_list);
    for(mailbox_list = 
	(server_list->everything) 
	? server_list->mailbox_all_list
	: server_list->mailbox_list ; 
	mailbox_list; mailbox_list = mailbox_list->prev) {
      fixedname = unfix_mailboxpath(mailbox_list->name);
      xstr = XmStringCreateSimple(fixedname);
      fs_give((void **) &fixedname);
      XmListAddItemUnselected(mailbox_win->list,xstr,0);
      XmStringFree(xstr);
    }
  }

  fs_give((void **) &pattern);
  return;
}

#ifdef __STDC__
int mailbox_compare(const void *n1, const void *n2)
#else
int mailbox_compare(n1,n2)
     const void *n1;
     const void *n2;
#endif
{
  Mailbox_List **name1 = (Mailbox_List **) n1;
  Mailbox_List **name2 = (Mailbox_List **) n2;

  char *fixedname1;
  char *fixedname2;
  int result;

  fixedname1 = unfix_mailboxpath((*(name1))->name);
  fixedname2 = unfix_mailboxpath((*(name2))->name);

  result = strcmp(fixedname1, fixedname2);

  /* ensure INBOX is first in the list */
  
  if(strcasecmp(fixedname1,INBOX) == STRMATCH)
    result = (-1);

  if(strcasecmp(fixedname2,INBOX) == STRMATCH)
    result = 1;

  fs_give((void **) &fixedname1);
  fs_give((void **) &fixedname2);

  return(result);
}


#ifdef __STDC__
char *get_mailboxlist_pattern(Mailbox_Win *mailbox_win)
#else
char *get_mailboxlist_pattern(mailbox_win)
     Mailbox_Win *mailbox_win;
#endif
{
  char *text;
  char *result;
  char *server = NULL;
  char buf[FILEBUFFLEN];

  text = XmTextGetString(mailbox_win->pattern);
  result = fix_mailboxpath(text);
  if(! result)
    result = cpystr(EMPTYSTR);
  fs_give((void **) &text);

#ifdef IMAP4
  server = get_server_string_from_window(mailbox_win);
  if(server) {
    sprintf(buf,"%s%s",server,result);
    fs_give((void **) &server);
    fs_give((void **) &result);
    result = cpystr(buf);
  }
#endif

  return(result);
}



#ifdef __STDC__
void sort_mailbox_list(Server_List *server_list)
#else
void sort_mailbox_list(server_list)
     Server_List *server_list;
#endif
{
  Mailbox_List **sort;
  Mailbox_List *mailbox_list;
  Mailbox_List *the_list;
  int n = 0;
  int total = 0;

  if(server_list->everything)
    the_list = server_list->mailbox_all_list;
  else
    the_list = server_list->mailbox_list;

  for(mailbox_list = the_list ; 
      mailbox_list; mailbox_list = mailbox_list->prev)
    total ++;

  if(total < 2)
    return;

  sort = (Mailbox_List **) fs_get(total * sizeof(Mailbox_List *));
  
  for(mailbox_list = the_list ; 
      mailbox_list; mailbox_list = mailbox_list->prev) {
    sort[n] = mailbox_list;
    n ++;
  }

  qsort((char *) sort, total, sizeof(Mailbox_List **), mailbox_compare);

  for(n = 0; n < total; n ++) {
    mailbox_list = sort[n];
    if(n == 0) {
      if(server_list->everything) 
	server_list->mailbox_all_list = mailbox_list;
      else
	server_list->mailbox_list = mailbox_list;
    }
    if(n < (total - 1))
      mailbox_list->prev = sort[n + 1];
    else
      mailbox_list->prev = NULL;
  }
  
  fs_give((void **) &sort);
  return;
}



#ifdef __STDC__
char *format_server_name(char *server,int type)
#else
char *format_server_name(server,type)
     char *server;
     int type;
#endif
{
  char buff[FILEBUFFLEN];
  char *ret;
  
  /* fallback position */
  strcpy(buff,server);

  if(type == MAILBOX_TYPE_MAIL) { 
    if((server != NULL) 
       && (*server != NUL_TERM) 
       && (preferences.imap_port != DEFAULT_IMAPPORT))
      sprintf(buff,"{%s:%d}", server, preferences.imap_port);
    else {
      if((server != NULL) && (*server != NUL_TERM))
	sprintf(buff,"{%s}", server);
    }
  }
  else {
    if((server != NULL) && (*server != NUL_TERM)) 

#ifdef IMAP4
      sprintf(buff,"{%s/nntp}", server);
#else /* IMAP4 */
      sprintf(buff,"*{%s/nntp}",server);
#endif /* IMAP4 */

  }
  ret = cpystr(buff);
  return(ret);
}

#ifdef __STDC__
char *format_mailbox_name(char *server,char *mailbox,int type)
#else
char *format_mailbox_name(server,mailbox,type)
     char *server;
     char *mailbox;
     int type;
#endif
{
  char buff[FILEBUFFLEN];
  char *ret;
  *buff = NUL_TERM;

  if(type == MAILBOX_TYPE_MAIL) {   /* regular mailbox */
    if((server != NULL) 
       && (*server != NUL_TERM)
       && (preferences.imap_port != DEFAULT_IMAPPORT)) {
      sprintf(buff,"{%s:%d}%s", server, preferences.imap_port, mailbox);
    }
    else {
      if((server != NULL) && (*server != NUL_TERM))
	sprintf(buff,"{%s}%s",
		server, mailbox);
      else
	sprintf(buff,"%s",mailbox);
    }
  }
  else {
    if((server != NULL) && (*server != NUL_TERM)) 

#ifdef IMAP4
      sprintf(buff,"{%s/nntp}%s%s",server,NEWSNAMESTART, mailbox);
#else /* IMAP4 */
      sprintf(buff,"*{%s/nntp}%s",server,mailbox);
#endif

    else
#ifdef IMAP4 
      sprintf(buff,"%s%s", NEWSNAMESTART, mailbox );
#else /* IMAP4 */
      sprintf(buff,"*%s",mailbox);
#endif /* IMAP4 */
  }

  ret = cpystr(buff);
  return(ret);
}

#ifdef __STDC__
char *get_mailbox_string_from_window(Mailbox_Win *mailbox_win)
#else
char *get_mailbox_string_from_window(mailbox_win)
     Mailbox_Win *mailbox_win;
#endif
{
  char *server;
  char *mailbox;
  char *fixedmailbox;
  char *ret = NULL;

  mblist_set_server(mailbox_win);
  server = GetTextField(mailbox_win->server);
  if(*server == NUL_TERM) {
    fs_give((void **) &server);
    server = NULL;
  }

  mailbox = GetTextField(mailbox_win->mailbox);
  if(*mailbox != NUL_TERM) {
    fixedmailbox = fix_mailboxpath(mailbox);
    ret = format_mailbox_name(server,fixedmailbox,mailbox_win->type);
    fs_give((void **) &fixedmailbox);
  }

  if(server)
    fs_give((void **) &server);
  fs_give((void **) &mailbox);

  return(ret);
}

#ifdef __STDC__
char *get_server_string_from_window(Mailbox_Win *mailbox_win)
#else
char *get_server_string_from_window(mailbox_win)
     Mailbox_Win *mailbox_win;
#endif
{
  char *rawname;
  char *fullname;

  mblist_set_server(mailbox_win);

  rawname = GetTextField(mailbox_win->server);
  if(*rawname == NUL_TERM)
    return(rawname);

  fullname = format_server_name(rawname,mailbox_win->type);
  fs_give((void **) &rawname);
  return(fullname);

}

#ifdef __STDC__
void mblist_set_server(Mailbox_Win *mailbox_win)
#else
void mblist_set_server(mailbox_win)
     Mailbox_Win *mailbox_win;
#endif
{
  char *rawname;
  char *fullname;

  rawname = GetTextField(mailbox_win->server);
  if(*rawname != NUL_TERM) {
    fullname = get_qualified_host_name(rawname);
    XmTextSetString(mailbox_win->server,fullname);
    fs_give((void **) &fullname);
  }

  fs_give((void **) &rawname);
  return;
}


