/* pgp.c
 *
 *
 * $Author: mtm $
 * $Date: 1995/05/09 01:27:15 $
 * $Id: pgp.c,v 1.1 1995/05/09 01:27:15 mtm Exp mtm $
 *
 * Mike Macgirvin <Mike_Macgirvin@CAMIS.Stanford.EDU>
 *
 * Copyright 1995 by The Leland Stanford Junior University.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notices appear in all copies and that both the
 * above copyright notices and this permission notice appear in supporting
 * documentation, and that the name of The Leland Stanford Junior University 
 * not be used in advertising or publicity pertaining to distribution of the 
 * software without specific, written prior permission.  This software is made 
 * available "as is", and THE LELAND STANFORD JUNIOR UNIVERSITY DISCLAIMS ALL 
 * WARRANTIES, EXPRESS OR IMPLIED, WITH REGARD TO THIS SOFTWARE, INCLUDING 
 * WITHOUT LIMITATION ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE, AND IN NO EVENT SHALL THE LELAND STANFORD JUNIOR 
 * UNIVERSITY BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR 
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER 
 * IN AN ACTION OF CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, 
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
 * SOFTWARE.
 *
 */

/*
 * $Log: pgp.c,v $
 * Revision 1.1  1995/05/09  01:27:15  mtm
 * Initial revision
 *
 * 
 */

#include "ml.h"

Pgpkv *pgpkv = NULL;


/* May need to be modified if "pgp -kv" output format changes... */

#define KEY_START_COL 30
#define KEY_TRAIL_TEXT "matching key"  /* i.e. "n matching keys found" */


Menu pgp_address_menu[] = {
  { NULL, "pgp_accept", NUL_TERM,
      pgp_accept, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "pgp_cancel", NUL_TERM,
      pgp_cancel, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "pgp_reset", NUL_TERM,
      pgp_reset, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "pgp_HELP", NUL_TERM,
      pgp_help, NULL, 0, NULL, NULL, BTN_ON },
};


#ifdef __STDC__
char *make_kv_window(Widget w)
#else
char *make_kv_window(w)
     Widget w;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  Widget form, menubar;
  XtTranslations translations;
  char *ret = NULL;

  push_cursor(PIRATE_CURSOR);

  pgpkv = (Pgpkv *) fs_get(sizeof(Pgpkv));

  pgpkv->result = NULL;
  pgpkv->done = 0;

  XtSetArg(args[n], XtNx, -1000); n ++;
  XtSetArg(args[n], XtNy, -1000); n ++;

  pgpkv->shell = XtCreatePopupShell("pgp_shell",
			 topLevelShellWidgetClass, w,
			 args, n); 
  n = 0;

  setup_editres(pgpkv->shell);

  if(pirate_icon != (Pixmap) None)
    XtVaSetValues(pgpkv->shell,
		  XmNiconPixmap,pirate_icon,
		  NULL);

  form = XmCreateForm(pgpkv->shell, "pgp_form", args, n ); n = 0;

  XtSetArg(args[n], XmNtopAttachment,   XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment,  XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  menubar = XmCreateMenuBar(form, "pgp_menubar", args, n); n = 0;
  XtManageChild(menubar);

  create_buttons(NULL, menubar, pgp_address_menu, 
		 XtNumber(pgp_address_menu),
		 BTN_ON, (XtPointer) pgpkv, 
		 ROOTMENULEVEL);

  pgpkv->text =
    create_text_field(form, menubar, 
		      "pgp_name", NULL,0, NULL, NULL);

  XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmSTATIC); n ++;
  XtSetArg(args[n], XmNlistSizePolicy,XmCONSTANT); n ++;

  XtSetArg(args[n], XmNselectionPolicy,XmSINGLE_SELECT); n ++;
  pgpkv->list = XmCreateScrolledList(form,"pgp_list",args,n); n = 0;
  XtAddCallback(pgpkv->list,	XmNsingleSelectionCallback, 
		(XtCallbackProc) pgp_select, pgpkv);
  XtAddCallback(pgpkv->list,	XmNdefaultActionCallback, 
		(XtCallbackProc) pgp_select, pgpkv);

  translations = 
    XtParseTranslationTable(GLOBAL_modal_list_translations);
  XtOverrideTranslations(pgpkv->list,translations);

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, pgpkv->text); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n ++;

  XtSetValues(XtParent(pgpkv->list), args, n); n = 0;
  XtManageChild(pgpkv->list);

  XtManageChild(form);
  XtManageChild(pgpkv->shell);

  XtPopup(pgpkv->shell,XtGrabExclusive);
  position_popup_widget(pgpkv->shell);

  stuff_pgp_list(pgpkv);

  modal_main_loop(&pgpkv->done);

  XtPopdown(pgpkv->shell);
  XtDestroyWidget(pgpkv->shell);

  pop_cursor();

  ret = pgpkv->result;
  fs_give((void **) &pgpkv);
  return(ret);
}


#ifdef __STDC__
void stuff_pgp_list(Pgpkv *pgpkv)
#else
void stuff_pgp_list(pgpkv)
     Pgpkv *pgpkv;
#endif
{
  FILE *pp;
  char buffer[FILEBUFFLEN];
  
  XmString xstr;

  XDefineCursor(display,XtWindow(pgpkv->shell), clock_cursor);
  XFlush(display);

  pp = popen(PGP_KV_CMD,"r");

  if(pp == NULL) {
    XUndefineCursor(display,XtWindow(pgpkv->shell));
    XFlush(display);
    return;
  }

  /* skip two lines */

  /* First one is blank, next contains the column labels */

  fgets(buffer,sizeof(buffer),pp);
  fgets(buffer,sizeof(buffer),pp);

  while((fgets(buffer,sizeof(buffer),pp)) != NULL) {
    if(ML_Strstr(buffer,KEY_TRAIL_TEXT) != NULL) 
      break;
    if((int) strlen(buffer) <= KEY_START_COL)
      continue;
    buffer[strlen(buffer) - 1] = NUL_TERM; 
    xstr = XmStringCreateSimple(buffer + KEY_START_COL);
    XmListAddItemUnselected(pgpkv->list,xstr,0);
    XmStringFree(xstr);
  }
  pclose(pp);
  XUndefineCursor(display,XtWindow(pgpkv->shell));
  XFlush(display);
  return;
}

#ifdef __STDC__
void pgp_accept(Widget w,Pgpkv *pgpkv,XtPointer xp)
#else
void pgp_accept(w,pgpkv,xp)
     Widget w;
     Pgpkv *pgpkv;
     XtPointer xp;
#endif
{
  pgpkv->done = MODAL_LOOP_DONE;
  return;
}


#ifdef __STDC__
void pgp_select(Widget w, Pgpkv *pgpkv, XmListCallbackStruct *xp)
#else
void pgp_select(w,pgpkv,xp)
     Widget w;
     Pgpkv *pgpkv;
     XmListCallbackStruct *xp;
#endif
{
  int newsize = 0;
  char *ret;
  char *str;

  XmStringGetLtoR(xp->item,XmSTRING_DEFAULT_CHARSET,&str);

  newsize = (pgpkv->result) ? strlen(pgpkv->result) : 0;
  newsize += (strlen(str) + 8);

  ret = (char *) fs_get(newsize);

  *ret = NUL_TERM;

  if(pgpkv->result)
    strcpy(ret,pgpkv->result);

  if(strlen(ret))
    strcat(ret,SPACESTR);
  strcat(ret,"'");
  strcat(ret,str);
  strcat(ret,"'");
  if(pgpkv->result)
    fs_give((void **) &pgpkv->result);
  pgpkv->result = ret;
  fs_give((void **) &str);

  XmTextSetString(pgpkv->text,EMPTYSTR);
  AppendText(pgpkv->text,pgpkv->result);
  XmListDeselectAllItems(pgpkv->list);
  return;
}


#ifdef __STDC__
void pgp_cancel(Widget w,Pgpkv *pgpkv,XtPointer xp)
#else
void pgp_cancel(w,pgpkv,xp)
     Widget w;
     Pgpkv *pgpkv;
     XtPointer xp;
#endif
{
  pgp_reset(w,pgpkv,xp);
  pgpkv->done = MODAL_LOOP_DONE;
  return;
}


#ifdef __STDC__
void pgp_help(Widget w,Pgpkv *pgpkv,XtPointer xp)
#else
void pgp_help(w,pgpkv,xp)
     Widget w;
     Pgpkv *pgpkv;
     XtPointer xp;
#endif
{
  help(pgpkv->shell,PGPUSERHELPTITLE,PGPUSERHELPFILE, DOCTYPE_ENRICHED);
  return;
}


#ifdef __STDC__
void pgp_reset(Widget w,Pgpkv *pgpkv,XtPointer xp)
#else
void pgp_reset(w,pgpkv,xp)
     Widget w;
     Pgpkv *pgpkv;
     XtPointer xp;
#endif
{
  if(pgpkv->result)
    fs_give((void **) &pgpkv->result);
  XmTextSetString(pgpkv->text,EMPTYSTR);
  return;
}
