/* read.c
 *
 *
 * $Author: mtm $
 * $Date: 1995/05/09 01:27:15 $
 * $Id: read.c,v 1.1 1995/05/09 01:27:15 mtm Exp mtm $
 *
 * Mike Macgirvin <Mike_Macgirvin@CAMIS.Stanford.EDU>
 *
 * Copyright 1995 by The Leland Stanford Junior University.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notices appear in all copies and that both the
 * above copyright notices and this permission notice appear in supporting
 * documentation, and that the name of The Leland Stanford Junior University 
 * not be used in advertising or publicity pertaining to distribution of the 
 * software without specific, written prior permission.  This software is made 
 * available "as is", and THE LELAND STANFORD JUNIOR UNIVERSITY DISCLAIMS ALL 
 * WARRANTIES, EXPRESS OR IMPLIED, WITH REGARD TO THIS SOFTWARE, INCLUDING 
 * WITHOUT LIMITATION ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE, AND IN NO EVENT SHALL THE LELAND STANFORD JUNIOR 
 * UNIVERSITY BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR 
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER 
 * IN AN ACTION OF CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, 
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
 * SOFTWARE.
 *
 */

/*
 * $Log: read.c,v $
 * Revision 1.1  1995/05/09  01:27:15  mtm
 * Initial revision
 *
 * 
 */

#include "ml.h"

Menu read_list_menu[] = {
  { NULL, "cancel", NUL_TERM,
      read_list_cancel, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "HELP", NUL_TERM,
      read_list_help, NULL, 0, NULL, NULL, BTN_ON },
};

Menu read_save_menu[] = {
  { NULL, "fullhead", NUL_TERM,
      read_savefull, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "parthead", NUL_TERM,
      read_savepart, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "nonehead", NUL_TERM,
      read_savenone, NULL, 0, NULL, NULL, BTN_ON },
};

Menu read_pipe_menu[] = {
  { NULL, "fullhead", NUL_TERM,
      read_execfull, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "parthead", NUL_TERM,
      read_execpart, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "nonehead", NUL_TERM,
      read_execnone, NULL, 0, NULL, NULL, BTN_ON },
};

Menu read_print_menu[] = {
  { NULL, "fullhead", NUL_TERM,
      read_printfull, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "parthead", NUL_TERM,
      read_printpart, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "nonehead", NUL_TERM,
      read_printnone, NULL, 0, NULL, NULL, BTN_ON },
};

Menu read_file_menu[] = {
  { NULL, "view_attachment", NUL_TERM,
      read_view_attach, NULL, 0, NULL, NULL, BTN_NOATTACHSELECT },
  { NULL, "copy", NUL_TERM,
      read_copy, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "move", NUL_TERM,
      read_move, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "print_menu", NUL_TERM, 
      NULL, read_print_menu, XtNumber(read_print_menu), NULL, NULL, BTN_ON },
  { NULL, "save_menu", NUL_TERM,
      NULL, read_save_menu, XtNumber(read_save_menu), NULL, NULL, BTN_ON },
  { NULL, "pipe_menu", NUL_TERM,
      NULL, read_pipe_menu, XtNumber(read_pipe_menu), NULL, NULL, BTN_ON },
  { NULL, "browse_url", NUL_TERM,
      read_browse_url, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "address_book", NUL_TERM,
      main_address_book, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "note_book", NUL_TERM,
      main_note_book, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "close_window", NUL_TERM,
      read_close_window,   NULL, 0, NULL, NULL, BTN_ON },
};

Menu read_setflags_menu[] = {
  { NULL, "set_deleted", NUL_TERM,
      read_set_deleted, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "set_seen", NUL_TERM,
      read_set_seen, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "set_flagged", NUL_TERM,
      read_set_flagged, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "set_answered", NUL_TERM,
      read_set_answered, NULL, 0, NULL, NULL, BTN_ON },
};

Menu read_clearflags_menu[] = {
  { NULL, "clear_deleted", NUL_TERM,
      read_clear_deleted, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "clear_seen", NUL_TERM,
      read_clear_seen, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "clear_flagged", NUL_TERM,
      read_clear_flagged, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "clear_answered", NUL_TERM,
      read_clear_answered, NULL, 0, NULL, NULL, BTN_ON },
};

Menu read_edit_menu[] = {
  { NULL, "kill_current", NUL_TERM,
      read_kill_current, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "trash_current", NUL_TERM,
      read_trash_current, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "dismiss_all", NUL_TERM,
      read_kill_all, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "setflags_menu", NUL_TERM,
      NULL, read_setflags_menu, XtNumber(read_setflags_menu), 
      NULL, NULL, BTN_ON },
  { NULL, "clearflags_menu", NUL_TERM,
      NULL, read_clearflags_menu, XtNumber(read_clearflags_menu),
      NULL, NULL, BTN_ON },
  { NULL, "set_keyword", NUL_TERM,
      read_set_keyword, NULL, 0, NULL, NULL, BTN_NOKEYWORDS },
  { NULL, "unset_keyword", NUL_TERM,
      read_unset_keyword, NULL, 0, NULL, NULL, BTN_NOKEYWORDS },
};

Menu read_key_menu[] = {
  { NULL, "pgp_addkey", NUL_TERM,
      pgp_addkey, NULL, 0, NULL, NULL, BTN_NOPGP },
  { NULL, "pgp_verify", NUL_TERM,
      pgp_verify, NULL, 0, NULL, NULL, BTN_NOPGP },
  { NULL, "pgp_decode", NUL_TERM,
      pgp_decode, NULL, 0, NULL, NULL, BTN_NOPGP },
};

Menu read_option_menu[] = {
  { NULL, "full_header", NUL_TERM,
      read_full_header, NULL, 0, NULL, NULL, BTN_SHORT_HEADER },
  { NULL, "short_header", NUL_TERM,
      read_short_header, NULL, 0, NULL, NULL, BTN_LONG_HEADER },
  { NULL, "takeaddr", NUL_TERM,
      read_address, NULL, 0, NULL, NULL, BTN_ON },

#ifdef PGP
  { NULL, "key_menu", NUL_TERM,
      NULL, read_key_menu, XtNumber(read_key_menu), 
      NULL, NULL, BTN_NOPGP },
#endif /* PGP */
};

Menu read_reply_submenu[] = {
  { NULL, "reply_sender", NUL_TERM,
      read_reply_sender, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "reply_all", NUL_TERM,
      read_reply_all, NULL, 0, NULL, NULL, BTN_ON },
};

Menu read_forward_submenu[] = {
  { NULL, "forward", NUL_TERM,
      read_forward, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "forward_attach", NUL_TERM,
      read_forward_attach, NULL, 0, NULL, NULL, BTN_ON },
};

Menu read_send_menu[] = {
  { NULL, "compose_new", NUL_TERM,
      main_compose, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "reply_menu", NUL_TERM,
      NULL, read_reply_submenu, XtNumber(read_reply_submenu), 
      NULL, NULL, BTN_ON },
  { NULL, "forward_menu", NUL_TERM,
      NULL, read_forward_submenu, XtNumber(read_forward_submenu),
      NULL, NULL, BTN_ON },
  { NULL, "remail", NUL_TERM,
      read_remail, NULL, 0, NULL, NULL, BTN_ON },
};

Menu read_menu[] = {
  { NULL, "file_menu", NUL_TERM,
      NULL, read_file_menu, XtNumber(read_file_menu), 
      NULL, NULL, BTN_ON },
  { NULL, "edit_menu", NUL_TERM,
      NULL, read_edit_menu, XtNumber(read_edit_menu), 
      NULL, NULL, BTN_ON },
  { NULL, "option_menu", NUL_TERM,
      NULL, read_option_menu, XtNumber(read_option_menu), 
      NULL, NULL, BTN_ON },
  { NULL, "send_menu", NUL_TERM,
      NULL, read_send_menu, XtNumber(read_send_menu), 
      NULL, NULL, BTN_ON },
  { NULL, "prevwin", NUL_TERM,
      read_prev, NULL, 0, NULL, NULL, BTN_NOPREV },
  { NULL, "listwin", NUL_TERM,
      read_choosewin, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "nextwin", NUL_TERM,
      read_next, NULL, 0, NULL, NULL, BTN_NONEXT },
  { NULL, "HELP", NUL_TERM,
      read_help, NULL, 0,
      NULL, NULL, BTN_ON },
};


Button_Table MLread_button_table[] = {
  { "Save", "read-save-fullheader",
      read_savefull, BTN_ON },
  { "Save", "read-save-partheader",
      read_savepart, BTN_ON },
  { "Save", "read-save-noheader",
      read_savenone, BTN_ON },
  { "Shell", "read-pipe-fullheader",
      read_execfull, BTN_ON },
  { "Shell", "read-pipe-partheader",
      read_execpart, BTN_ON },
  { "Shell", "read-pipe-noheader",
      read_execnone, BTN_ON },
  { "Print", "read-print-fullheader",
      read_printfull, BTN_ON },
  { "Print", "read-print-partheader",
      read_printpart, BTN_ON },
  { "Print", "read-print-noheader",
      read_printnone, BTN_ON },
  { "View", "read-view-attachment",
      read_view_attach, BTN_NOATTACHSELECT },
  { "Copy", "read-copy-message",
      read_copy, BTN_ON },
  { "Move", "read-move-message",
      read_move, BTN_ON },
  { "Web", "read-show-url",
      read_browse_url, BTN_ON },
  { "Address", "read-addressbook",
      main_address_book, BTN_ON },
  { "Notebook", "read-notebook",
      main_note_book, BTN_ON },
  { "Dismiss", "read-close-window",
      read_close_window,  BTN_ON },
  { "Delete", "read-set-deleted",
      read_set_deleted, BTN_ON },
  { "See", "read-set-seen",
      read_set_seen, BTN_ON },
  { "Flag", "read-set-flagged",
      read_set_flagged, BTN_ON },
  { "Answered", "read-set-answered",
      read_set_answered, BTN_ON },
  { "Undelete", "read-clear-deleted",
      read_clear_deleted, BTN_ON },
  { "Unsee", "read-clear-seen",
      read_clear_seen, BTN_ON },
  { "Unflag", "read-clear-flagged",
      read_clear_flagged, BTN_ON },
  { "Unanswer", "read-clear-answered",
      read_clear_answered, BTN_ON },
  { "Next", "read-dismiss-goto-next",
      read_kill_current, BTN_ON },
  { "Kill", "read-delete-goto-next",
      read_trash_current, BTN_ON },
  { "Cancel", "read-dismiss-all",
      read_kill_all, BTN_ON },
  { "Keyword", "read-set-keyword",
      read_set_keyword, BTN_NOKEYWORDS },
  { "Unkeyword", "read-unset-keyword",
      read_unset_keyword, BTN_NOKEYWORDS },
  { "ToAddrBook", "read-take-address",
      read_address, BTN_ON },
  { "AddKey", "read-pgp-add-key",
      pgp_addkey, BTN_NOPGP },
  { "Verify", "read-pgp-verify",
      pgp_verify, BTN_NOPGP },
  { "Decode", "read-pgp-decode",
      pgp_decode, BTN_NOPGP },
  { "FullHeader", "read-show-full-header",
      read_full_header, BTN_SHORT_HEADER },
  { "Header",  "read-show-short-header",
      read_short_header, BTN_LONG_HEADER },
  { "Reply", "read-reply-sender",
      read_reply_sender, BTN_ON },
  { "ReplyAll", "read-reply-all",
      read_reply_all, BTN_ON },
  { "Forward", "read-forward-insert",
      read_forward, BTN_ON },
  { "Forward", "read-forward-attach",
      read_forward_attach, BTN_ON },
  { "Compose", "read-compose-new",
      main_compose, BTN_ON },
  { "Remail", "read-remail",
      read_remail, BTN_ON },

};


Button_Menu MLread_default_buttons[] = {
  { "Next",        read_kill_current,  NULL, BTN_ON,          NULL },
  { "Trash",       read_trash_current, NULL, BTN_ON,          NULL },
  { "Flag",        read_set_flagged,   NULL, BTN_ON,          NULL },
  { "Copy",        read_copy,          NULL, BTN_ON,          NULL },
  { "Move",        read_move,          NULL, BTN_ON,          NULL },
  { "Save",        read_savepart,      NULL, BTN_ON,          NULL },
  { "Reply",       read_reply_sender,  NULL, BTN_ON,          NULL },
  { "ReplyAll",    read_reply_all,     NULL, BTN_ON,          NULL },
  { "Dismiss",     read_close_window,  NULL, BTN_ON,          NULL },
};


#ifdef __STDC__
int read_number_buttons(void)
#else
int read_number_buttons()
#endif
{
  return(XtNumber(MLread_button_table));
}

#ifdef __STDC__
Button_Table *read_get_table(void)
#else
Button_Table *read_get_table()
#endif
{
  return(MLread_button_table);
}

#ifdef __STDC__
void read_default_buttons(void)
#else
void read_default_buttons()
#endif
{
  if(session.buttons[READ_BTN_MENU] == NULL)
    setup_default_buttons(&session.buttons[READ_BTN_MENU],
			  MLread_default_buttons,
			  XtNumber(MLread_default_buttons));
  return;
}

#ifdef __STDC__
void read_reset_buttons(void)
#else
void read_reset_buttons()
#endif
{
  Button_Menu *button_menu;

  if((session.read == NULL) 
     || (session.read->current == NULL)
     || (session.read->is_realized == FALSE))
    return;
  for(button_menu = session.buttons[READ_BTN_MENU];
      button_menu; button_menu = button_menu->next)
    if(button_menu->widget != NULL)
      XtDestroyWidget(button_menu->widget);

  read_default_buttons();

  make_pbuttons(session.read->rowcol, session.buttons[READ_BTN_MENU], 
		session.read->current->button_state, 
		(XtPointer) session.read);

  return;
}

#ifdef __STDC__
void create_read_window(void)
#else
void create_read_window()
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  Widget form, menubar, pane;
  XtTranslations translations;
  Read *read;

  if(session.read == NULL) {
    read = new_read();
    session.read = read;
  }
  else
    read = session.read;

  if(read->is_realized == TRUE) {
    de_iconify(read->shell);
    XmProcessTraversal(read->read_text, XmTRAVERSE_CURRENT);
    return;
  }

  read->shell = XtAppCreateShell("MLread", "MLread",
			       topLevelShellWidgetClass,
			       display, args, n ); 
  n = 0;

  setup_editres(read->shell);

  if(read_icon != (Pixmap) None)
    XtVaSetValues(read->shell,
		  XmNiconPixmap,read_icon,
		  NULL);

  form = XmCreateForm(read->shell, "form", args, n);            n = 0;

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM);           n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);          n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);         n ++;
  menubar = XmCreateMenuBar(form,"menubar", args, n);           n = 0;
  XtManageChild(menubar);

  create_buttons(NULL, menubar,read_menu, XtNumber(read_menu), 
		      BTN_ON, (XtPointer) read, ROOTMENULEVEL);


  XtSetArg(args[n], XmNtopAttachment,   XmATTACH_WIDGET);       n ++;
  XtSetArg(args[n], XmNtopWidget, menubar);                     n ++;
  XtSetArg(args[n], XmNleftAttachment,  XmATTACH_FORM);         n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);         n ++;
  XtSetArg(args[n], XmNorientation, XmHORIZONTAL);              n ++;
  XtSetArg(args[n], XmNpacking, XmPACK_TIGHT);                  n ++;
  read->rowcol = XmCreateRowColumn(form, "rowcol", args, n);    n = 0;
  XtManageChild(read->rowcol);

  read_default_buttons();

  make_pbuttons(read->rowcol, session.buttons[READ_BTN_MENU], 
		BTN_ON, (XtPointer) read);

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET );         n ++;
  XtSetArg(args[n], XmNtopWidget, read->rowcol);                 n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);           n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM);          n ++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM);         n ++;
  XtSetArg(args[n], XmNsashHeight, 6);                           n ++;
  XtSetArg(args[n], XmNsashWidth, 12);                           n ++;
  XtSetArg(args[n], XmNspacing, 4);                              n ++;

  pane = XmCreatePanedWindow(form,"pane", args, n);              n = 0;


  XtSetArg(args[n], XmNpaneMinimum, 30);                         n ++;
  XtSetArg(args[n], XmNeditable, FALSE);                         n ++;
  XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT);             n ++;
  XtSetArg(args[n], XmNwordWrap, TRUE);                          n ++;
  XtSetArg(args[n], XmNrows,     4);                             n ++;
  XtSetArg(args[n], XmNcolumns,  80);                            n ++;
  XtSetArg(args[n], XmNscrollVertical, TRUE);                    n ++;
  XtSetArg(args[n], XmNscrollHorizontal, FALSE );                n ++;
  read->read_header = 
    XmCreateScrolledText(pane, "header", args, n);               n = 0;
  XtManageChild(read->read_header);

  translations = XtParseTranslationTable(GLOBAL_text_translations);
  XtOverrideTranslations(read->read_header, translations);

  XtSetArg(args[n], XmNpaneMinimum, 45);                         n ++;
  XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmSTATIC);        n ++;
  XtSetArg(args[n], XmNlistSizePolicy,XmCONSTANT);               n ++;
  XtSetArg(args[n], XmNvisibleItemCount, VISIBLE_ATTACHMENTS );  n ++; 
  XtSetArg(args[n], XmNselectionPolicy,XmSINGLE_SELECT);         n ++;
  read->read_attach = XmCreateScrolledList(pane,"list",args,n);  n = 0;

  XtAddCallback(read->read_attach,
		XmNsingleSelectionCallback, 
		(XtCallbackProc) read_select_attach, read);
  XtAddCallback(read->read_attach,
		XmNdefaultActionCallback, 
		(XtCallbackProc) read_exec_attach, read);

  XtManageChild(read->read_attach); 

  XtSetArg(args[n], XmNpaneMinimum, 30);                         n ++;
  XtSetArg(args[n], XmNeditable, FALSE);                         n ++;
  XtSetArg(args[n], XmNeditMode, XmMULTI_LINE_EDIT);             n ++;
  XtSetArg(args[n], XmNwordWrap, TRUE);                          n ++;
  if(preferences.read_height) {
    XtSetArg(args[n], XmNrows,   preferences.read_height);       n ++;
  }
  XtSetArg(args[n], XmNcolumns,  80);                            n ++;
  XtSetArg(args[n], XmNscrollVertical, TRUE);                    n ++;
  XtSetArg(args[n], XmNscrollHorizontal, FALSE );                n ++;
  read->read_text = 
    XmCreateScrolledText(pane, "text", args, n);                n = 0;

  XtManageChild(read->read_text);

  translations = XtParseTranslationTable(GLOBAL_text_translations);
  XtOverrideTranslations(read->read_text, translations);

  XtAddCallback(read->shell, XmNdestroyCallback, 
		(XtCallbackProc) read_destroy, read);

  XtManageChild(pane);
  XtManageChild(form);
  XtRealizeWidget(read->shell);
  XmProcessTraversal(read->read_text, XmTRAVERSE_CURRENT);
  XmProcessTraversal(read->read_text, XmTRAVERSE_CURRENT);
  read->is_realized = TRUE;
  return;
}

#ifdef __STDC__
void read_close_window(Widget w, Read *read, XtPointer xp)
#else
void read_close_window(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  XtRemoveCallback(read->shell, XmNdestroyCallback, 
		   (XtCallbackProc) read_destroy, read);
  XtDestroyWidget(read->shell);
  read->is_realized = FALSE;
  return;
}

#ifdef __STDC__
void read_help(Widget w, Read *read, XtPointer xp)
#else
void read_help(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  help(read->shell, READWINDOWHELPTITLE, 
       READWINDOWHELPFILE, DOCTYPE_ENRICHED);
  return;
}

#ifdef __STDC__
void read_next(Widget w, Read *read, XtPointer xp)
#else
void read_next(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  if(read->current->next)
    read_context_switch(read,read->current,read->current->next);
  return;
}

#ifdef __STDC__
void read_prev(Widget w, Read *read, XtPointer xp)
#else
void read_prev(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  if(read->current->prev)
    read_context_switch(read,read->current,read->current->prev);
  return;
}



#ifdef __STDC__
void read_address(Widget w, Read *read, XtPointer xp)
#else
void read_address(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  char *from;
  char *name;
  Address_Book_Info *info;

  if((read == NULL) 
     || (read->current == NULL) 
     || (read->current->header == NULL))
    return;

  from = get_header_field_contents("reply-to",read->current->header);
  if(from == NULL)
    from = get_header_field_contents("sender", read->current->header);
  if(from == NULL)
    from = get_header_field_contents("from", read->current->header);
  if(*from == NUL_TERM)
    return;

  name = input_string(read->shell,INPUTALIASSTR, NULL,ADDRTAKEHELPFILE);
  if(name == NULL) {
    fs_give((void **) &from);
    return;
  }

  if(session.address_book == NULL) {
    session.address_book = (Address_Book *) fs_get(sizeof(Address_Book));
    session.address_book->is_realized = FALSE;
    session.address_book->address_book_info = NULL;
  }
  
  info = new_address_book_info();
  info->name    = (unsigned char *) name;
  info->address = (unsigned char *) from;
  info->comment = (unsigned char *) cpystr(EMPTYSTR);

  if(session.address_book->address_book_info == NULL)
    session.address_book->address_book_info = info;
  else {
    info->prev = session.address_book->address_book_info;
    session.address_book->address_book_info->next = info;
    session.address_book->address_book_info = info;
  }
  if(session.address_book->is_realized == TRUE) {
    address_sort(session.address_book);
    address_reset(NULL, session.address_book, NULL);
  }
  save_defaults();
  return;

}





#ifdef __STDC__
void read_destroy(Widget w, Read *read, XtPointer xp)
#else
void read_destroy(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read->is_realized = FALSE;
  return;
}

#ifdef __STDC__
void read_copy(Widget w, Read *read, XtPointer xp)
#else
void read_copy(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  char *mailboxname;
  Boolean changed;
  char sequence[32];
  int result;

  if(read->current && read->current->mailstream && read->current->msgno) {

    mailboxname = 
      get_mailbox_name(read->shell, 
		       (read->current->server) 
		       ? read->current->server 
		       : EMPTYSTR,
		       (read->current->mailbox_type == MAILBOX_TYPE_NEWS) 
		       ? preferences.imap_server 
		       : read->current->server,
		       preferences.default_savebox,
		       &changed);

    if(mailboxname == NULL)
      return;

    if(*mailboxname == NUL_TERM) {
      fs_give((void **) &mailboxname);
      return;
    }

    push_cursor(WATCH_CURSOR); 

    if(changed == TRUE) {
      result = copy_message_to_mailbox(read->current->mailstream,
				       read->current->msgno,
				       mailboxname);
      if(result == SYSCALL_SUCCESS)
	mm_log(COPY_OK, NIL);
      else
	mm_log(COPY_FAILED, WARN);
    }
    else {
      sprintf(sequence,"%lu",read->current->msgno);
      result = mail_copy(read->current->mailstream, 
			 sequence, mailboxname); 
      if(result == T) 
	mm_log(COPY_OK, NIL);
    }
    fs_give((void **) &mailboxname);
    pop_cursor();
  }
  return;
}

#ifdef __STDC__
void read_move(Widget w, Read *read, XtPointer xp)
#else
void read_move(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  char *mailboxname;
  char sequence[32];
  int result;
  Boolean changed;

  if(read->current && read->current->mailstream && read->current->msgno) {
    mailboxname = 
      get_mailbox_name(read->shell, 
		       (read->current->server)
		       ? read->current->server
		       : EMPTYSTR,
		       (read->current->mailbox_type == MAILBOX_TYPE_NEWS) 
		       ? preferences.imap_server 
		       : read->current->server,
		       preferences.default_savebox,
		       &changed);
    
    if(mailboxname == NULL) 
      return;
    
    if(*mailboxname == NUL_TERM) {
      fs_give((void **) &mailboxname);
      return;
    }
    
    push_cursor(WATCH_CURSOR);
    
    if(changed == TRUE) {
      result = copy_message_to_mailbox(read->current->mailstream,
				       read->current->msgno,
				       mailboxname);
      if(result == SYSCALL_SUCCESS) {
	update_view_line_stream_msgno(read->current->mailstream,
				      read->current->msgno);
	mm_log(COPY_OK, NIL);
      }
      else
	mm_log(COPY_FAILED, WARN);
    }
    else {
      sprintf(sequence,"%lu",read->current->msgno);
      result = mail_move(read->current->mailstream, sequence, mailboxname);

      if(result == T) {
	update_view_line_stream_msgno(read->current->mailstream,
				      read->current->msgno);
	mm_log(MOVE_OK, NIL);
      }
    }
    fs_give((void **) &mailboxname);
    pop_cursor();
  }
  return;
}

#ifdef __STDC__
void read_full_header(Widget w, Read *read, XtPointer xp)
#else
void read_full_header(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read->current->show_long_header = TRUE;
  read->current->button_state |=  BTN_SHORT_HEADER;
  read->current->button_state &= ~(BTN_LONG_HEADER);
  read_context_switch(read,NULL, read->current);
  return;
}

#ifdef __STDC__
void read_short_header(Widget w, Read *read, XtPointer xp)
#else
void read_short_header(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read->current->show_long_header = FALSE;
  read->current->button_state |=  BTN_LONG_HEADER;
  read->current->button_state &= ~(BTN_SHORT_HEADER);
  read_context_switch(read,NULL, read->current);
  return;
}

#ifdef __STDC__
void read_savefull(Widget w, Read *read, XtPointer xp)
#else
void read_savefull(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_save_dispatch(read,HEADER_FULL);
  return;
}

#ifdef __STDC__
void read_savepart(Widget w, Read *read, XtPointer xp)
#else
void read_savepart(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_save_dispatch(read,HEADER_PART);
  return;
}

#ifdef __STDC__
void read_savenone(Widget w, Read *read, XtPointer xp)
#else
void read_savenone(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_save_dispatch(read,HEADER_NONE);
  return;
}

#ifdef __STDC__
void read_save_dispatch(Read *read, Header_Mode header_mode)
#else
void read_save_dispatch(read,header_mode)
     Read *read;
     Header_Mode header_mode;
#endif
{
  FILE *fp;
  char *filename;
  int errors = 0;
  char *header_text = NULL;
  char *body_text;
  Boolean append_it;
  filename = file_select(read->shell, NULL, NULL, NULL, TRUE, &append_it);
  if(filename == NULL)
    return;

  push_cursor(WATCH_CURSOR);

  if(header_mode == HEADER_FULL)
    header_text = read->current->header;
  if(header_mode == HEADER_PART)
    header_text = read->current->short_header;

  if(read->current->alt_text)
    body_text = read->current->alt_text;
  else
    body_text = read->current->current_text;


  if((fp = fopen(filename,(append_it == TRUE) ? "a" : "w")) != NULL) {
    (void) chmod(filename,S_IRWXU);
    if((header_mode != HEADER_NONE) && (header_text != NULL)) {
      if((fwrite(header_text,strlen(header_text),1,fp)) != 1)
	errors ++;
      if((fwrite(LFSTR,1,1,fp)) != 1)
	errors ++;
    }
    if((fwrite(body_text,strlen(body_text),1,fp)) != 1)
      errors ++;
    if((fclose(fp)) != SYSCALL_SUCCESS)
      errors ++;
  }
  else
    errors ++;

  fs_give((void **) &filename);

  if(errors)
    mm_log(SAVE_FAILED,WARN);
  else
    mm_log(SAVE_OK, NIL);

  pop_cursor();
}

#ifdef __STDC__
void read_printfull(Widget w, Read *read, XtPointer xp)
#else
void read_printfull(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_print_dispatch(w,read,HEADER_FULL);
  return;
}

#ifdef __STDC__
void read_printpart(Widget w, Read *read, XtPointer xp)
#else
void read_printpart(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_print_dispatch(w,read,HEADER_PART);
  return;
}

#ifdef __STDC__
void read_printnone(Widget w, Read *read, XtPointer xp)
#else
void read_printnone(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_print_dispatch(w,read,HEADER_NONE);
  return;
}

#ifdef __STDC__
void read_print_dispatch(Widget w, Read *read, Header_Mode header_mode)
#else
void read_print_dispatch(w,read,header_mode)
     Widget w;
     Read *read;
     Header_Mode header_mode;
#endif
{
  char *header = NULL;

  if(*preferences.print_command == NUL_TERM) {
    mm_log(NO_PRINT_COMMAND, WARN);
    return;
  }

  push_cursor(WATCH_CURSOR);
  
  if(header_mode == HEADER_FULL)
    header = read->current->header;
  if(header_mode == HEADER_PART)
    header = read->current->short_header;


  if(write_to_pipe(preferences.print_command, header,
		(read->current->alt_text)
		? read->current->alt_text : read->current->current_text,
		(read->current->alt_text)
		? strlen(read->current->alt_text) 
		: strlen(read->current->current_text)))

    mm_log(PRINT_FAILED, WARN);
  else
    mm_log(PRINT_OK, NIL);

  pop_cursor();
  return;
}

#ifdef __STDC__
char *find_url(char *s)
#else
char *find_url(s)
     char *s;
#endif
{
  char *ptr;
  char *tmp;
  char *ret;
  int n = 0;

  if((s == NULL) || (ptr = ML_Strstr(s,URL_SIG_STR)) == NULL)
    return(NULL);

  if(ptr > s)
    ptr --;
  while(ptr >= s && isalpha(*ptr))
	   ptr --;
  ptr ++;
  tmp = ptr;

  while((*ptr) && ((!isspace(*ptr)) && (*ptr != '\"') 
	&& (*ptr != '}') && (*ptr != ')') && (*ptr != '>'))) {
    ptr ++;
    n ++;
  }

  ret = (char *) fs_get((unsigned) n + 16);
  strncpy(ret,tmp,n);
  ret[n] = 0;
  return(ret);
}

#ifdef __STDC__
void read_browse_url(Widget w, Read *read, XtPointer xp)
#else
void read_browse_url(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  XmTextPosition left, right;
  char command[FILEBUFFLEN];
  char log[FILEBUFFLEN];
  char *temp_url = NULL;
  char *url = NULL;

  if(*preferences.url_command == NUL_TERM) {
    mm_log(NO_URL_COMMAND, WARN);
    return;
  }

  if((ML_Strstr(preferences.url_command,"%s")) == NULL) {
    mm_log(UNSUPPORTED_URL_COMMAND, WARN);
    return;
  }

  XmTextGetSelectionPosition(read->read_text, &left, &right);
  if(left != right) {
    temp_url = XmTextGetSelection(read->read_text);
  }
  else {
    temp_url = find_url((read->current->alt_text) 
		   ? read->current->alt_text : read->current->current_text);
  }

  if(temp_url == NULL)
    return;

  url = input_string(read->shell, SHOW_URL, temp_url, SHOWURLHELPFILE);
  fs_give((void **) &temp_url);

  if(url == NULL)
    return;

  if(*url == NUL_TERM) {
    fs_give((void **) &url);
    return;
  }

  push_cursor(WATCH_CURSOR);
  sprintf(command,preferences.url_command,url);
  sprintf(log,EXECUTING_URL, command);
  mm_log(log,NIL);
  system(command);
  fs_give((void **) &url);
  pop_cursor();
  return;
}

#ifdef __STDC__
void read_execfull(Widget w, Read *read, XtPointer xp)
#else
void read_execfull(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_exec_dispatch(w,read,HEADER_FULL);
  return;
}

#ifdef __STDC__
void read_execpart(Widget w, Read *read, XtPointer xp)
#else
void read_execpart(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_exec_dispatch(w,read,HEADER_PART);
  return;
}

#ifdef __STDC__
void read_execnone(Widget w, Read *read, XtPointer xp)
#else
void read_execnone(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_exec_dispatch(w,read,HEADER_NONE);
  return;
}

#ifdef __STDC__
void read_exec_dispatch(Widget w, Read *read, Header_Mode header_mode)
#else
void read_exec_dispatch(w,read,header_mode)
     Widget w;
     Read *read;
     Header_Mode header_mode;
#endif
{
  char *command;
  char *header = NULL;

  command = input_string(read->shell,INPUTCOMMANDSTR, 
			 session.last_command, SHELLCOMMANDHELPFILE);
  if(command == NULL)
    return;

  if(*command == NUL_TERM) {
    fs_give((void **) &command);
    return;
  }

  push_cursor(WATCH_CURSOR);

  if(header_mode == HEADER_FULL)
    header = read->current->header;
  if(header_mode == HEADER_PART)
    header = read->current->short_header;

  if(write_to_pipe(command, header,
		(read->current->alt_text)
		? read->current->alt_text : read->current->current_text,
		(read->current->alt_text)
		? strlen(read->current->alt_text) 
		: strlen(read->current->current_text)))

    mm_log(PIPE_FAILED, WARN);
  if(session.last_command != NULL)
    fs_give((void **) &session.last_command);
  session.last_command = command;

  pop_cursor();
  return;
}


#ifdef __STDC__
void read_select_attach(Widget w, Read *read, XmListCallbackStruct *xp)
#else
void read_select_attach(w,read,xp)
     Widget w;
     Read *read;
     XmListCallbackStruct *xp;
#endif
{
  Part_List *part_list;
  BODY *body = NULL;
  
  if(xp->item_position == read->current->selection) {
    read->current->selection = 0;
    read->current->button_state |= BTN_NOATTACHSELECT;
    check_buttons(read_menu,XtNumber(read_menu),
		  session.buttons[READ_BTN_MENU], 
		  read->current->button_state);
    return;
  }

  read->current->selection = xp->item_position;
  read->current->button_state &= (~BTN_NOATTACHSELECT);
  check_buttons(read_menu,XtNumber(read_menu),
		session.buttons[READ_BTN_MENU], read->current->button_state);


  for(part_list = read->current->part_list;
      ((part_list) && part_list->partnumber != read->current->selection);
      part_list = part_list->next);

  if(part_list) {
    if(part_list->part) 
      body = &(part_list->part->body);

    read_message_part(read->current,part_list->partstr,body);
  }
  stuff_read_window_list(read, TRUE);
  return;
}

#ifdef __STDC__
void read_view_attach(Widget w, Read *read, XtPointer xp)
#else
void read_view_attach(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  Part_List *part_list;
  BODY *body = NULL;
  int result;
  char **ptrptr = NULL;

  if(read->current->selection) {
    for(part_list = read->current->part_list;
	((part_list) && part_list->partnumber != read->current->selection);
	part_list = part_list->next);

    if(part_list) {
      if(part_list->part) 
	body = &(part_list->part->body);
      else
	body = read->current->body;

      /* On local connections, the body isn't cached. Grrrr. */
      
      if(body) {
	switch(body->type) {
	  
	case TYPEMULTIPART:
	  break;
	  
	case TYPEMESSAGE:

	  if(body->contents.msg.text == NULL) {
	    body->contents.msg.text =
	      mail_fetchbody(read->current->mailstream,
			     read->current->msgno,
			     (read->current->rfc_msg_leaf == TRUE) 
			     ? read->current->current_part_str
			     : part_list->partstr,
			     &body->size.bytes);
	    ptrptr = &body->contents.msg.text;
	  }
	  break;
	case TYPETEXT:
	case TYPEIMAGE:
	case TYPEAUDIO:
	case TYPEAPPLICATION:
	case TYPEOTHER:
	default:
	  if(body->contents.text == NULL) {
	    body->contents.text = (unsigned char *)
	      mail_fetchbody(read->current->mailstream,
			     read->current->msgno,
			     part_list->partstr, 
			     &body->size.bytes);
	    ptrptr = (char **) &body->contents.text;
	  }
	  break;
	}
	result = show_mime(read->shell,body);
      }
    }
  }
  
  if(ptrptr)
    *ptrptr = NULL;
  return;
}

#ifdef __STDC__
void read_exec_attach(Widget w, Read *read, XmListCallbackStruct *xp)
#else
void read_exec_attach(w,read,xp)
     Widget w;
     Read *read;
     XmListCallbackStruct *xp;
#endif
{
  Part_List *part_list;
  BODY *body = NULL;
  char **ptrptr = NULL;
  int result;
  

  read->current->selection = xp->item_position;

  if(read->current->selection) {
    for(part_list = read->current->part_list;
	((part_list) && part_list->partnumber != read->current->selection);
	part_list = part_list->next);

    if(part_list) {
      if(part_list->part) 
	body = &(part_list->part->body);
      else
	body = read->current->body;

      /* On local connections, the body isn't cached. Grrrr. */

      if(body) {
	switch(body->type) {

	case TYPEMULTIPART:
	  break;
	  
	case TYPEMESSAGE:
	  if(body->contents.msg.text == NULL) {
	    body->contents.msg.text =
	      mail_fetchbody(read->current->mailstream,
			     read->current->msgno,
			     (read->current->rfc_msg_leaf == TRUE) 
			     ? read->current->current_part_str
			     : part_list->partstr,
			     &body->size.bytes);
	    ptrptr = &body->contents.msg.text;
	  }
	  break;
	case TYPETEXT:
	case TYPEIMAGE:
	case TYPEAUDIO:
	case TYPEAPPLICATION:
	case TYPEOTHER:
	default:
	  if(body->contents.text == NULL) {
	    body->contents.text = (unsigned char *)
	      mail_fetchbody(read->current->mailstream,
			     read->current->msgno,
			     part_list->partstr, 
			     &body->size.bytes);
	    ptrptr = (char **) &body->contents.text;
	  }
	  break;
	}
	result = show_mime(read->shell,body);
      }
    }
  }

  if(ptrptr)
    *ptrptr = NULL;

  read->current->button_state &= (~BTN_NOATTACHSELECT);
  check_buttons(read_menu,XtNumber(read_menu),
		session.buttons[READ_BTN_MENU], 
		read->current->button_state);

  XmListSelectPos(read->read_attach,read->current->selection,FALSE);
  return;
}

#ifdef __STDC__
void read_kill_current(Widget w, Read *read, XtPointer xp)
#else
void read_kill_current(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  Read_Info *this_one = NULL;
  Read_Info *next_one = NULL;;

  if(read == NULL)
    return;

  this_one = read->current;

  if(this_one == NULL)
    return;

  if(this_one->expunged == TRUE) {
    for(next_one = read->read_info; next_one; next_one = next_one->prev)
      if(next_one->expunged == FALSE)
	break;
  }
  else {
    if(this_one->next)
      next_one = this_one->next;
    else
      if(this_one->prev)
	next_one = this_one->prev;
  }

  if(next_one) {
    read_context_switch(read,this_one,next_one);
    if(read->is_realized)
      check_buttons(read_menu,XtNumber(read_menu),
		    session.buttons[READ_BTN_MENU], 
		    read->current->button_state);
  }
  else {
    session.button_state |= BTN_NOREADOPEN;
    update_main_buttons();
    if(read->is_realized)
      read_close_window(w,read,xp);
  }
  kill_read_info(this_one);
  stuff_read_window_list(read, TRUE);
  return;
}


/* Wipe out the current read queue */

#ifdef __STDC__
void read_kill_all(Widget w, Read *read, XtPointer xp)
#else
void read_kill_all(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  Read_Info *this_one = NULL;
  Read_Info *next_one = NULL;;

  if(read == NULL)
    return;

  this_one = read->read_info;

  if(this_one == NULL)
    return;

  for(this_one = read->read_info; this_one; this_one = next_one ) {
    next_one = this_one->prev;
    kill_read_info(this_one);
  }
  session.button_state |= BTN_NOREADOPEN;
  update_main_buttons();
  if(read->is_realized)
    read_close_window(w,read,xp);
  stuff_read_window_list(read, TRUE);
  return;
}

/* 
 * kill this message, and do a context switch to any message
 * which isn't in this mailbox; which is being closed.
 * If there aren't any, close the window.
 */


#ifdef __STDC__
void read_close_kill_current(Widget w, Read *read, XtPointer xp)
#else
void read_close_kill_current(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  Read_Info *this_one = NULL;
  Read_Info *next_one = NULL;
  Read_Info *current  = NULL;

  if(read == NULL)
    return;

  this_one = read->current;

  if(this_one == NULL)
    return;

  for(current = read->read_info; current ; current = current->prev)
    if(current->mailstream != this_one->mailstream) {
      next_one = current;
      break;
    }
  
  if(next_one) {
    read_context_switch(read,this_one,next_one);
    if(read->is_realized)
      check_buttons(read_menu,XtNumber(read_menu),
		    session.buttons[READ_BTN_MENU], 
		    read->current->button_state);
  }
  else {
    session.button_state |= BTN_NOREADOPEN;
    update_main_buttons();
    if(read->is_realized)
      read_close_window(w,read,xp);
  }

  kill_read_info(this_one);
  return;
}

#ifdef __STDC__
void read_trash_current(Widget w, Read *read, XtPointer xp)
#else
void read_trash_current(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  Read_Info *this_one = NULL;
  Read_Info *next_one = NULL;
  char sequence[32];

  if(read == NULL)
    return;

  this_one = read->current;

  if(this_one == NULL)
    return;

  if(this_one->next)
    next_one = this_one->next;
  else
    if(this_one->prev)
      next_one = this_one->prev;

  if(read->current->mailstream && read->current->msgno) {
    sprintf(sequence,"%lu",read->current->msgno);
    push_cursor(WATCH_CURSOR);
    mail_setflag(read->current->mailstream, sequence, DELETED_FLAG);
    mm_flags(read->current->mailstream, read->current->msgno);

    pop_cursor();
  }

  if(next_one) {
    read_context_switch(read,this_one,next_one);
    if(read->is_realized)
      check_buttons(read_menu,XtNumber(read_menu),
		    session.buttons[READ_BTN_MENU], 
		    read->current->button_state);
  }
  else {
    session.button_state |= BTN_NOREADOPEN;
    update_main_buttons();
    if(read->is_realized)
      read_close_window(w,read,xp);
  }
  kill_read_info(this_one);
  stuff_read_window_list(read, TRUE);
  return;
}

#ifdef __STDC__
void kill_read_info(Read_Info *read_info)
#else
void kill_read_info(read_info)
     Read_Info *read_info;
#endif
{
  if((read_info == NULL) || (session.read == NULL))
    return;

  if(session.read->read_info == read_info) 
    session.read->read_info = read_info->prev;

  if(read_info->prev) {
    read_info->prev->next = read_info->next;
    if(read_info->next == NULL) 
      read_info->prev->button_state |= BTN_NONEXT;
    else
      read_info->prev->button_state &= ~(BTN_NONEXT);
  }
  if(read_info->next) {
    read_info->next->prev = read_info->prev;
    if(read_info->prev == NULL) 
      read_info->next->button_state |= BTN_NONEXT;
    else
      read_info->next->button_state &= ~(BTN_NONEXT);
  }
  free_read_info(read_info);

  return;
}

#ifdef __STDC__
void read_messagelist(Message_List *message_list)
#else
void read_messagelist(message_list)
     Message_List *message_list;
#endif
{
  Message_List *select_list;
  Read_Info *read_info;
  Read_Info *first_message = NULL;
  Message *message;

  create_read_window();


  for(select_list = message_list; select_list;
      select_list = select_list->next) {
    if(select_list->selected == TRUE) {
      message = select_list->message;
      if(message->fetched == FALSE)
	continue;
      read_info = new_read_info();

      if(first_message == NULL)
	first_message = read_info;

      read_info->mailstream = message->mailstream;
      read_info->msgno = message->msgno;
      read_info->server = cpystr(message->mailbox->host);
      read_info->current_part_str = cpystr(PART_ONE_STR);
      read_info->mailbox_type = message->mailbox->type;

      if(read_info->mailbox_type == MAILBOX_TYPE_NEWS)
	read_info->button_state |= BTN_ISNEWS;

      if((read_info->mailstream != NULL) 
	 && (*read_info->mailstream->user_flags == NULL))
	read_info->button_state |= BTN_NOKEYWORDS;

      read_info->button_state |= BTN_NOATTACHSELECT;

      if(preferences.pgp_pathname && *preferences.pgp_pathname) {
	if((access(preferences.pgp_pathname,X_OK)) == SYSCALL_FAILURE)
	  read_info->button_state |= BTN_NOPGP;
      }
      else
	read_info->button_state |= BTN_NOPGP;

      read_info->envelope = message->envelope;
      read_info->body = message->body;

      if((read_info->body) && (read_info->body->type == TYPEMULTIPART))
	read_info->attachments = read_info->body->contents.part;

      read_new_link(read_info);
    }
  }

  read_fetch(first_message, first_message->body);
  read_context_switch(session.read,NULL,first_message);
  stuff_read_window_list(session.read, TRUE);
  return;
}

#ifdef __STDC__
void read_rfc822(Read_Info *parent, char *partstr, BODY *body)
#else
void read_rfc822(parent,partstr,body)
     Read_Info *parent;
     char *partstr;
     BODY *body;
#endif
{
  Read_Info *read_info;
  char *basetxt = NULL;
  unsigned long length;
  char *ptr = NULL;

  create_read_window();
  read_info = new_read_info();
  parent->selection = 0L;
  read_info->mailstream = parent->mailstream;
  read_info->msgno = parent->msgno;
  read_info->server = cpystr(parent->server);
  read_info->mailbox_type = parent->mailbox_type;
  read_info->envelope = parent->envelope;
  read_info->base_part_str = cpystr(partstr);
  read_info->message_type = MESSAGE_PART;
  read_info->fetched = TRUE;
  if(read_info->mailbox_type == MAILBOX_TYPE_NEWS)
    read_info->button_state |= BTN_ISNEWS;

  if((read_info->mailstream != NULL) 
     && (*read_info->mailstream->user_flags == NULL))
    read_info->button_state |= BTN_NOKEYWORDS;

  if(preferences.pgp_pathname && *preferences.pgp_pathname) {
    if((access(preferences.pgp_pathname,X_OK)) == SYSCALL_FAILURE)
      read_info->button_state |= BTN_NOPGP;
  }
  else
    read_info->button_state |= BTN_NOPGP;

  read_info->button_state |= BTN_NOATTACHSELECT;

  basetxt = cpystr(mail_fetchbody(read_info->mailstream,
				  read_info->msgno,
				  partstr, &length));
  if(basetxt == NULL)
    basetxt = cpystr(EMPTYSTR);

  stripcr(basetxt);

  ptr = ML_Strstr(basetxt,"\n\n");

  if(ptr != NULL) {
    ptr ++;
    *ptr = NUL_TERM;
    ptr ++;
    read_info->header = cpystr(basetxt);
  }
  else
    read_info->header = cpystr(EMPTYSTR);

  read_info->short_header = get_short_header(read_info->header);
  if(read_info->short_header == NULL)
    read_info->short_header = cpystr(EMPTYSTR);

  read_new_link(read_info);
  
  if(body->contents.msg.body->type == TYPEMULTIPART) {
    read_info->body = body->contents.msg.body;
    read_info->current_part_str = (char *) fs_get(strlen(partstr) + 2);
    sprintf(read_info->current_part_str,"%s.1",partstr);
    read_info->attachments = read_info->body->contents.part;
    read_fetch(read_info,body);
  }
  else {
    read_info->body = body;
    read_info->current_part_str = cpystr(partstr);
    read_info->current_text = cpystr(ptr);
    read_info->rfc_msg_leaf = TRUE;
  }

  fs_give((void **) &basetxt);
  read_context_switch(session.read,session.read->current,read_info);
  stuff_read_window_list(session.read, TRUE);
  return;
}

#ifdef __STDC__
void read_message_part(Read_Info *read_info, char *partstr, BODY *body)
#else
void read_message_part(read_info,partstr,body)
     Read_Info *read_info;
     char *partstr;
     BODY *body;
#endif
{
  /* Don't recurse again... */

  if(read_info->rfc_msg_leaf == TRUE)
    return;

  if(read_info->current_part_str)
    fs_give((void **) &read_info->current_part_str);
  read_info->current_part_str = cpystr(partstr);
  read_info->message_type = MESSAGE_PART;
  read_info->rfc_msg_leaf = FALSE;

  if((body != NULL) && (body->type == TYPEMESSAGE) && (body->subtype != NULL)
     && ((strcasecmp(body->subtype,"rfc822")) == STRMATCH)) {
    read_rfc822(read_info,partstr,body);
    return;
  }
  read_fetch(read_info,body);
  read_context_switch(session.read,NULL,read_info);
  return;
}

#ifdef __STDC__
void read_new_link(Read_Info *read_info)
#else
void read_new_link(read_info)
     Read_Info *read_info;
#endif
{
  if(session.read->read_info) {
    session.read->read_info->next = read_info;
    session.read->read_info->button_state &= ~(BTN_NONEXT);
    read_info->button_state &= ~(BTN_NOPREV);
  }
  else
    read_info->button_state |= BTN_NOPREV;

  read_info->button_state |= BTN_NONEXT;
  read_info->prev = session.read->read_info;
  session.read->read_info = read_info;
  session.button_state &= (~BTN_NOREADOPEN);
  update_main_buttons();
  stuff_read_window_list(session.read, TRUE);
  return;
}

#ifdef __STDC__
void read_fetch(Read_Info *read_info, BODY *body)
#else
void read_fetch(read_info,body)
     Read_Info *read_info;
     BODY *body;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  char *src_text;
  unsigned long length = 0L;
  unsigned long newlength = 0L;
  unsigned long foo;
  char *decode_subject;
  char *decode_ptr;
  BODY *local_body = body;
  char buffer[FILEBUFFLEN];
  char *subject = NULL;

  if((local_body) && (local_body->type == TYPEMULTIPART))
    local_body = &(body->contents.part->body);

  push_cursor(WATCH_CURSOR);

  switch(read_info->message_type) {
  case MESSAGE_NORMAL:

    if(read_info->fetched == TRUE)
      break;

    if(read_info->header == NULL) {
      read_info->header = cpystr(mail_fetchheader(read_info->mailstream,
						  read_info->msgno));
      stripcr(read_info->header);
      if(read_info->header[strlen(read_info->header) - 1] == LFCHAR)
	read_info->header[strlen(read_info->header) - 1] = NUL_TERM;
    }

    read_info->short_header = get_short_header(read_info->header);
    if(read_info->short_header == NULL)
      read_info->short_header = cpystr(EMPTYSTR);

    src_text = mail_fetchbody(read_info->mailstream,
			      read_info->msgno,
			      read_info->current_part_str, &length);

    read_info->current_text = cpystr(src_text);

    if(read_info->current_text == NULL)
      read_info->current_text = cpystr(EMPTYSTR);
    
    stripcr(read_info->current_text);
    update_view_line_stream_msgno(read_info->mailstream, read_info->msgno);
    break;

  case MESSAGE_PART:
    if(read_info->current_text)
      fs_give((void **) &read_info->current_text);

    src_text = mail_fetchbody(read_info->mailstream,
			      read_info->msgno,
			      read_info->current_part_str, &length);

    read_info->current_text =  cpystr(src_text);

    if(read_info->current_text == NULL)
      read_info->current_text = cpystr(EMPTYSTR);
    
    stripcr(read_info->current_text);

    break;

  case MESSAGE_RAWPART:
  case MESSAGE_IN_MEMORY:
  case MESSAGE_FROM_FILE:
    
  default:
    break;
  }

  if(local_body) {

    if(read_info->alt_text)
      fs_give((void **) &read_info->alt_text);


    if(read_info->envelope) 
      subject = read_info->envelope->subject;
    if(subject == NULL)
      subject = "No subject";

    decode_subject = (char *) fs_get(strlen(subject) + 1);
    *decode_subject = NUL_TERM;
    while((decode_ptr = iso_decode(&subject, TRUE)) != NULL) {
      strcat(decode_subject,decode_ptr);
      fs_give((void **) &decode_ptr);
    }
      
    sprintf(buffer,"%-64.64s (Part %s%s)",
	    decode_subject,read_info->current_part_str,
	    (read_info->base_part_str) ? VIEWINGRFC822 : EMPTYSTR);
    XtSetArg(args[n], XmNtitle, buffer); n ++;
    XtSetValues(session.read->shell, args, n); n = 0;
    fs_give((void **) &decode_subject);

    if(src_text) {
      switch(local_body->encoding) {
      case ENCBASE64:
	read_info->alt_text = 
	  (char *) rfc822_base64(src_text,length,&newlength);
	if(read_info->alt_text)
	  read_info->alt_text[newlength] = NUL_TERM;
	break;
      case ENCQUOTEDPRINTABLE:
	read_info->alt_text =
	  (char *) rfc822_qprint(src_text,length,&newlength);
	if(read_info->alt_text)
	  read_info->alt_text[newlength] = NUL_TERM;
	break;
      case ENCOTHER:
      case ENC7BIT:
      case ENC8BIT:
      case ENCBINARY:
      default:
	break;
      }
    }
    if((read_info->alt_text) 
       && ((foo = strlen(read_info->alt_text)) < (newlength)))
      fs_give((void **) &read_info->alt_text);
  }
  read_info->fetched = TRUE;
  pop_cursor();
  return;
}

#ifdef __STDC__
void read_context_switch(Read *read, Read_Info *old, Read_Info *new)
#else
void read_context_switch(read,old,new) 
  Read *read;
  Read_Info *old, *new;
#endif
{
  char buffer[FILEBUFFLEN];
  char *subject;
  Arg args[ARGLISTSIZE];
  int n = 0;
  char *decode_subject = NULL;
  char *decode_ptr;

  unsigned long selection;

  if((read == NULL) || (read->is_realized == FALSE) || (new == NULL))
    return;

  /*
   * old isn't used here. It is only in the arg list to make
   * this function syntactically compatible with other context
   * switch functions in the program. The difference in the read 
   * window is that you can't type into it, so there's no old 
   * context to save. Instead we use this function whenever we 
   * need to update the contents of the read window, either to change
   * messages, or to navigate a multipart, or just to toggle the
   * header mode.
   */

  read->current = new;
  selection = read->current->selection;

  /* zap! */


  XmTextSetString(read->read_header, EMPTYSTR);
  XmTextSetString(read->read_text,EMPTYSTR);
  XmListDeselectAllItems(read->read_attach);
  XmListDeleteAllItems(read->read_attach); 


  switch(new->message_type) {
  case MESSAGE_NORMAL:
  case MESSAGE_PART:
    if(new->fetched == FALSE)
      read_fetch(new,new->body);

    if((new->show_long_header == TRUE) && (new->header))
      XmTextSetString(read->read_header,new->header);
    if((new->show_long_header == FALSE) && (new->short_header))
      XmTextSetString(read->read_header,new->short_header);

    if(new->alt_text)
      XmTextSetString(read->read_text,new->alt_text);
    else
      if(new->current_text)
	XmTextSetString(read->read_text,new->current_text);

    XtSetKeyboardFocus(read->shell, read->read_text);

    read_make_attachment_list(read);

    if(selection) {
      read->current->selection = selection;
      XmListSelectPos(read->read_attach,selection,FALSE);
      XmListSetPos(read->read_attach,selection);
      new->button_state &= (~BTN_NOATTACHSELECT);
    }
    else
      new->button_state |= BTN_NOATTACHSELECT;

    break;
  case MESSAGE_RAWPART:
  case MESSAGE_IN_MEMORY:
  case MESSAGE_FROM_FILE:
  default:
    break;
  }

  if(new && new->envelope && new->envelope->subject) {
    subject = new->envelope->subject;
    if(subject == NULL)
      subject = "No subject";
    decode_subject = (char *) fs_get(strlen(subject) + 1);
    *decode_subject = NUL_TERM;
    
    while((decode_ptr = iso_decode(&subject, TRUE)) != NULL) {
      strcat(decode_subject, decode_ptr);
      fs_give((void **) &decode_ptr);
    }
  }  
   
  sprintf(buffer,"%-64.64s (Part %s%s)",
	  (decode_subject) ? decode_subject : EMPTYSTR,
	  new->current_part_str, 
	  (new->base_part_str) ? VIEWINGRFC822 : EMPTYSTR);
  XtSetArg(args[n], XmNtitle, buffer); n ++;
  XtSetValues(read->shell, args, n); n = 0;
  if(decode_subject)
    fs_give((void **) &decode_subject);

  check_buttons(read_menu,XtNumber(read_menu),
		session.buttons[READ_BTN_MENU],new->button_state);
  XmProcessTraversal(read->read_text, XmTRAVERSE_CURRENT);
  return;
}

#ifdef __STDC__
void read_make_attachment_list(Read *read)
#else
void read_make_attachment_list(read)
     Read *read;
#endif
{
  /* Erase current list contents and start over */

  XmListDeselectAllItems(read->read_attach);
  XmListDeleteAllItems(read->read_attach); 

  read->current->selection = 0;

  if(read->current->part_list) 
    destroy_part_list(read->current->part_list);

  read->current->part_list = NULL;

  if(read->current->body == NULL) {
    check_buttons(read_menu,XtNumber(read_menu),
		  session.buttons[READ_BTN_MENU], read->current->button_state);
    return;
  }

  if(read->current->body->type != TYPEMULTIPART)
    read_add_this_part(read->read_attach,read);

  read_add_attach_strings(read->read_attach, read, 
			  read->current->attachments,0, 
			  (read->current->base_part_str) 
			  ? read->current->base_part_str : EMPTYSTR);

  read->current->button_state &= ~(BTN_NOATTACH);
  check_buttons(read_menu,XtNumber(read_menu),
		session.buttons[READ_BTN_MENU], read->current->button_state);
  return;
}

#ifdef __STDC__
void read_add_this_part(Widget w, Read *read)
#else
void read_add_this_part(w,read)
     Widget w;
     Read *read;
#endif
{
  char buffer[FILEBUFFLEN];
  char partbuff[FILEBUFFLEN];
  Part_List *part_list;
  
  XmString xstr;
  int len;
  struct mail_body_parameter *params;

  strcpy(buffer,type_to_name(read->current->body->type));
  strcat(buffer,TYPE_SEPARATOR_STR);
  strcat(buffer,(read->current->body->subtype) 
	 ? read->current->body->subtype : NOSUBTYPE );

  if(read->current->rfc_msg_leaf == TRUE)
    strcpy(partbuff,read->current->base_part_str);
  else {
    if(read->current->base_part_str)
      sprintf(partbuff,"%s.1", read->current->base_part_str);
    else
      sprintf(partbuff,"1");
  }

  strcat(buffer," (Part ");
  strcat(buffer,partbuff);
  strcat(buffer,") ");

  for(len = strlen(buffer); len < (COMPOSEWIDTH/2); len ++)
    strcat(buffer,SPACESTR);
  if((read->current->body->description) && 
     ((int) (strlen(buffer) 
	     + strlen(read->current->body->description)) < FILEBUFFLEN))
    strcat(buffer, read->current->body->description); 
  for(params = read->current->body->parameter; 
      params; params = params->next) {
    if((int) (strlen(buffer) + strlen(params->attribute) 
	+ strlen(params->value) + 2) >= FILEBUFFLEN)
      break;
    strcat(buffer,SPACESTR);
    strcat(buffer,params->attribute);
    strcat(buffer,"=");
    strcat(buffer,params->value);
  }
  
  xstr = XmStringCreateSimple(buffer);
  XmListAddItemUnselected(w,xstr,0);
  XmStringFree(xstr);

  part_list = (Part_List *) fs_get(sizeof(Part_List));

  part_list->partstr = cpystr("1");
  part_list->partnumber = 1;
  part_list->next = NULL;
  part_list->prev = NULL;
  part_list->part = NULL;

  read->current->part_list = part_list;
  return;
}

#ifdef __STDC__
void read_add_attach_strings(Widget w, Read *read, PART *part, 
			     int level, char *partstr)
#else
void read_add_attach_strings(w,read,part,level, partstr)
     Widget w;
     Read *read;
     PART *part;
     int level;
     char *partstr;
#endif
{
  int len;
  PART *curr;
  char buffer[FILEBUFFLEN];
  char partbuff[FILEBUFFLEN];

  struct mail_body_parameter *params;
  XmString xstr;
  Part_List *part_list;
  Part_List *curr_part_list;
  int subpart_cnt = 0;

  if(part == NULL)
    return;

  strcpy(partbuff,EMPTYSTR);

  for(curr = part; curr; curr = curr->next) {
    subpart_cnt ++;

    if(*partstr == NUL_TERM)
      sprintf(partbuff,"%d",subpart_cnt);
    else
      sprintf(partbuff,"%s.%d",partstr,subpart_cnt);

    strcpy(buffer,EMPTYSTR);
    for(len = 0; len < level; len ++)
      strcat(buffer,SPACESTR);
    strcat(buffer,type_to_name(curr->body.type));
    strcat(buffer,TYPE_SEPARATOR_STR);
    strcat(buffer,(curr->body.subtype) ? curr->body.subtype : NOSUBTYPE );

    strcat(buffer," (Part ");
    strcat(buffer,partbuff);
    strcat(buffer,") ");

    for(len = strlen(buffer); len < (COMPOSEWIDTH/2); len ++)
      strcat(buffer,SPACESTR);
    if((curr->body.description) 
       && ((int) (strlen(buffer) 
		  + strlen(curr->body.description)) < FILEBUFFLEN)) {
      strcat(buffer,curr->body.description);
      strcat(buffer,SPACESTR);
    }
    for(params = curr->body.parameter; params; params = params->next) {
      if((int) (strlen(buffer) + strlen(params->attribute) 
	  + strlen(params->value) + 2) >= FILEBUFFLEN)
	break;
      strcat(buffer,params->attribute);
      strcat(buffer,"=");
      strcat(buffer,params->value);
      strcat(buffer,SPACESTR);
    }

    xstr = XmStringCreateSimple(buffer);
    XmListAddItemUnselected(w,xstr,0);
    XmStringFree(xstr);
    
    part_list = (Part_List *) fs_get(sizeof(Part_List));

    part_list->partstr = cpystr(partbuff);
    part_list->next = NULL;
    part_list->part = curr;
    
    if(read->current->part_list == NULL) {
      read->current->part_list = part_list;
      part_list->partnumber = 1;
      part_list->prev = NULL;
    }
    else {
      for(curr_part_list = read->current->part_list; curr_part_list->next;
	curr_part_list = curr_part_list->next);

      curr_part_list->next = part_list;
      part_list->prev = curr_part_list;
      part_list->partnumber = curr_part_list->partnumber + 1;
    }

    if(curr->body.type == TYPEMULTIPART)
      read_add_attach_strings(w, read, curr->body.contents.part,
			      level+1, partbuff);
  }
  return;
}


#ifdef __STDC__
void read_reply_sender(Widget w, Read *read, XtPointer xp)
#else
void read_reply_sender(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  compose(REPLYSENDERSTR, MAIL_BEHAVIOUR, COMPOSE_REPLY, 
	  read->current, NULL, NULL);
  return;
}

#ifdef __STDC__
void read_reply_all(Widget w, Read *read, XtPointer xp)
#else
void read_reply_all(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  compose(REPLYALLSTR, MAIL_BEHAVIOUR, COMPOSE_REPLYALL, 
	  read->current, NULL, NULL);
  return;
}

#ifdef __STDC__
void read_forward(Widget w, Read *read, XtPointer xp)
#else
void read_forward(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  compose(FORWARDSTR, MAIL_BEHAVIOUR, COMPOSE_FORWARD, 
	  read->current, NULL, NULL);
  return;
}

#ifdef __STDC__
void read_forward_attach(Widget w, Read *read, XtPointer xp)
#else
void read_forward_attach(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  compose(FORWARDATTACHSTR, MAIL_BEHAVIOUR, COMPOSE_FORWARDATTACH, 
	  read->current, NULL, NULL);
  return;
}

#ifdef __STDC__
void read_remail(Widget w, Read *read, XtPointer xp)
#else
void read_remail(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  compose(REMAILSTR, MAIL_BEHAVIOUR, COMPOSE_REMAIL, 
	  read->current, NULL, NULL);
  return;
}

#ifdef __STDC__
void read_choosewin(Widget w, Read *read, XtPointer xp)
#else
void read_choosewin(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;

  XtTranslations translations;
  Widget form, menubar, dummy;

  if(read->list_is_realized == TRUE) {
    de_iconify(read->list_shell);
    return;
  }

  read->list_shell = XtAppCreateShell("MLreadlist","MLreadlist",
				    topLevelShellWidgetClass,
				    display, args, n ); 
  n = 0;

  setup_editres(read->list_shell);

  if(list_icon != (Pixmap) None)
    XtVaSetValues(read->list_shell,
		  XmNiconPixmap,list_icon,
		  NULL);
	
  form = XmCreateForm(read->list_shell, "form", args, n); n = 0;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  menubar = XmCreateMenuBar(form,"menubar", args, n); n = 0;
  XtManageChild(menubar);
  create_buttons(NULL, menubar,read_list_menu, 
		 XtNumber(read_list_menu), 
		 BTN_ON, (XtPointer) read, ROOTMENULEVEL);

  /* An invisible text field. This is used only to set the width. */

  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  dummy = XmCreateTextField(form,"dummy", args, n); n = 0;
  XtManageChild(dummy);

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, menubar); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNbottomAttachment, XmATTACH_FORM); n ++;
  
  XtSetArg(args[n], XmNscrollBarDisplayPolicy, XmSTATIC); n ++;
  XtSetArg(args[n], XmNlistSizePolicy,XmCONSTANT); n ++;
  XtSetArg(args[n], XmNselectionPolicy,XmSINGLE_SELECT); n ++;

  read->list_list = 
    XmCreateScrolledList(form,"list",args,n); n = 0;
  XtAddCallback(read->list_list,
		XmNsingleSelectionCallback, 
		(XtCallbackProc) read_list_select, read);
  XtAddCallback(read->list_list,
		XmNdefaultActionCallback, 
		(XtCallbackProc) read_list_double, read);

  translations = 
    XtParseTranslationTable(GLOBAL_modal_list_translations);
  XtOverrideTranslations(read->list_list,translations);
  stuff_read_window_list(read, FALSE);

  XtAddCallback(read->list_shell,
		XmNdestroyCallback, 
		(XtCallbackProc) read_list_destroy, read);


  XtManageChild(read->list_list); 
  XtManageChild(form);
  XtRealizeWidget(read->list_shell);
  read->list_is_realized = TRUE;
  return;
}

#ifdef __STDC__
void read_list_select(Widget w, Read *read, XmListCallbackStruct *xp)
#else
void read_list_select(w,read,xp)
     Widget w;
     Read *read;
     XmListCallbackStruct *xp;
#endif
{
  Read_Info *read_info;


  if(read->is_realized == FALSE)
    create_read_window();
  de_iconify(read->shell);
  for(read_info = read->read_info; read_info; read_info = read_info->prev) {
    if(read_info->number == xp->item_position) {
      if(read_info->selected == TRUE) {
	read_info->selected = FALSE;
	XmListDeselectPos(read->list_list,read_info->number);
      }
      else {
	read_info->selected = TRUE;
	read_context_switch(read,read->current,read_info);
      }
    }
    else
      read_info->selected = FALSE;
  }
  return;
}



#ifdef __STDC__
void read_list_double(Widget w, Read *read, XmListCallbackStruct *xp)
#else
void read_list_double(w,read,xp)
     Widget w;
     Read *read;
     XmListCallbackStruct *xp;
#endif
{
  return;
}


#ifdef __STDC__
void read_list_cancel(Widget w, Read *read, XtPointer xp)
#else
void read_list_cancel(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  XtRemoveCallback(read->list_shell,
		   XmNdestroyCallback, 
		   (XtCallbackProc) read_list_destroy, read);
  XtDestroyWidget(read->list_shell);
  read->list_is_realized = FALSE;
  return;
}

#ifdef __STDC__
void read_list_destroy(Widget w, Read *read, XtPointer xp)
#else
void read_list_destroy(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read->list_is_realized = FALSE;
  return;
}

#ifdef __STDC__
void read_list_help(Widget w, Read *read, XtPointer xp)
#else
void read_list_help(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  help(read->list_shell, READLISTHELPTITLE, READLISTHELPFILE, 
       DOCTYPE_ENRICHED);
  return;
}

#ifdef __STDC__
void stuff_read_window_list(Read *read, Boolean update)
#else
void stuff_read_window_list(read, update)
     Read *read;
     Boolean update;
#endif
{
  Read_Info *read_info;
  unsigned long n = 1L;
  char buffer[FILEBUFFLEN];
  XmString xstr;
  char from[40];
  char *subject;

  if(update) {
    if((read == NULL) || (read->list_is_realized == FALSE))
      return;
    XmListDeselectAllItems(read->list_list);
    XmListDeleteAllItems(read->list_list);
  }


  for(read_info = read->read_info;
      read_info; read_info = read_info->prev) {

    read_info->number = n;
    if(read_info->selected == TRUE)
      XmListSelectPos(read->list_list,n, FALSE);

    if(read_info->mailstream && read_info->envelope) {
      mail_fetchfrom(from,read_info->mailstream,read_info->msgno,36);
      subject = read_info->envelope->subject;
      if(subject == NULL)
	subject = EMPTYSTR;
      sprintf(buffer,"%s[%s] %-32.32s [%s] %-32.32s",
	      (read_info->base_part_str) ? "*" : " ",
	      SUBJECT_TEXT,
	      (*subject) ? subject : UNSET_STR,
	      FROM_TEXT,
	      (*from) ? from : UNSET_STR);
    }
    else
      sprintf(buffer,NON_MAILBOX_MSG);
    
    xstr = XmStringCreateSimple(buffer);
    XmListAddItemUnselected(read->list_list,xstr,0);
    XmStringFree(xstr);
    n ++;
  }
  return;
}


/* called from mm_expunged(). Just mark 'em, we'll clean up later. */

#ifdef __STDC__
void read_expunge(MAILSTREAM *mailstream, unsigned long msgno)
#else
void read_expunge(mailstream,msgno)
     MAILSTREAM *mailstream;
     unsigned long msgno;
#endif
{
  Read_Info *read_info;

  if((session.read == NULL) || (session.read->read_info == NULL))
    return;

  for(read_info = session.read->read_info; read_info;
      read_info = read_info->prev) {
    if(read_info->mailstream != mailstream)
      continue;
    if(read_info->msgno == msgno)
      read_info->expunged = TRUE;
    if(read_info->msgno > msgno)
      read_info->msgno --;
  }
  return;
}

/* 
 * Called after an expunge has returned. This is so we don't 
 * run into a c-client recursion if the next message needs to be 
 * fetched.
 */

#ifdef __STDC__
void read_after_expunge(void)
#else
void read_after_expunge()
#endif
{
  Read_Info *read_info;
  Boolean found;

  if((session.read == NULL) || (session.read->read_info == NULL))
    return;

  do {
    found = FALSE;
    for(read_info = session.read->read_info; read_info;
	read_info = read_info->prev) {
      if(read_info->expunged == TRUE) {
	found = TRUE;
	if(read_info == session.read->current) 
	  read_kill_current(session.read->shell,session.read,NULL);
	else
	  kill_read_info(read_info);
	break;
      }
    }
  } while (found == TRUE);

  stuff_read_window_list(session.read, TRUE);
  return;
}

#ifdef __STDC__
void read_set_deleted(Widget w, Read *read, XtPointer xp)
#else
void read_set_deleted(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_setflag(w,read,DELETED_FLAG);
  return;
}

#ifdef __STDC__
void read_set_seen(Widget w, Read *read, XtPointer xp)
#else
void read_set_seen(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_setflag(w,read,SEEN_FLAG);
  return;
}

#ifdef __STDC__
void read_set_flagged(Widget w, Read *read, XtPointer xp)
#else
void read_set_flagged(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_setflag(w,read,FLAGGED_FLAG);
  return;
}

#ifdef __STDC__
void read_set_answered(Widget w, Read *read, XtPointer xp)
#else
void read_set_answered(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_setflag(w,read,ANSWERED_FLAG);
  return;
}

#ifdef __STDC__
void read_clear_deleted(Widget w, Read *read, XtPointer xp)
#else
void read_clear_deleted(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_clearflag(w,read,DELETED_FLAG);
  return;
}

#ifdef __STDC__
void read_clear_seen(Widget w, Read *read, XtPointer xp)
#else
void read_clear_seen(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_clearflag(w,read,SEEN_FLAG);
  return;
}

#ifdef __STDC__
void read_clear_flagged(Widget w, Read *read, XtPointer xp)
#else
void read_clear_flagged(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_clearflag(w,read,FLAGGED_FLAG);
  return;
}

#ifdef __STDC__
void read_clear_answered(Widget w, Read *read, XtPointer xp)
#else
void read_clear_answered(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  read_clearflag(w,read,ANSWERED_FLAG);
  return;
}

#ifdef __STDC__
void read_set_keyword(Widget w, Read *read, XtPointer xp)
#else
void read_set_keyword(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  char *keyword = get_keyword(read->shell,read->current->mailstream);
  if(keyword) {
    read_setflag(w,read,keyword);
    fs_give((void **) &keyword);
    update_view_line_stream_msgno(read->current->mailstream,
				  read->current->msgno);
  }
  return;
}

#ifdef __STDC__
void read_unset_keyword(Widget w, Read *read, XtPointer xp)
#else
void read_unset_keyword(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  char *keyword = get_keyword(read->shell,read->current->mailstream);
  if(keyword) {
    read_clearflag(w,read,keyword);
    fs_give((void **) &keyword);
    update_view_line_stream_msgno(read->current->mailstream,
				  read->current->msgno);
  }
  return;
}

#ifdef __STDC__
void read_setflag(Widget w, Read *read, char *flag)
#else
void read_setflag(w,read,flag)
     Widget w;
     Read *read;
     char *flag;
#endif
{
  char sequence[32];

  if(read->current->mailstream && read->current->msgno) {
    sprintf(sequence,"%lu",read->current->msgno);
    push_cursor(WATCH_CURSOR);
    mail_setflag(read->current->mailstream, sequence, flag);
    mm_flags(read->current->mailstream, read->current->msgno);

    pop_cursor();
  }
  return;
}

#ifdef __STDC__
void read_clearflag(Widget w, Read *read, char *flag)
#else
void read_clearflag(w,read,flag)
     Widget w;
     Read *read;
     char *flag;
#endif
{
  char sequence[32];

  if(read->current->mailstream && read->current->msgno) {
    sprintf(sequence,"%lu",read->current->msgno);
    push_cursor(WATCH_CURSOR);
    mail_clearflag(read->current->mailstream, sequence, flag);
    mm_flags(read->current->mailstream, read->current->msgno);
    pop_cursor();
  }
  return;
}

#ifdef __STDC__
void pgp_verify(Widget w, Read *read, XtPointer xp)
#else
void pgp_verify(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  pgp_decode_dispatch(w,read,PGP_VRFY);
  return;
}

#ifdef __STDC__
void pgp_decode(Widget w, Read *read, XtPointer xp)
#else
void pgp_decode(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  pgp_decode_dispatch(w,read,PGP_DECR);
  return;
}

#ifdef __STDC__
void pgp_addkey(Widget w, Read *read, XtPointer xp)
#else
void pgp_addkey(w,read,xp)
     Widget w;
     Read *read;
     XtPointer xp;
#endif
{
  pgp_decode_dispatch(w,read,PGP_KADD);
  return;
}

#ifdef __STDC__
void pgp_decode_dispatch(Widget w, Read *read, int method)
#else
void pgp_decode_dispatch(w,read,method)
     Widget w;
     Read *read;
     int method;
#endif
{
  FILE *fp;
  char *pw;
  Remote_Auth *remote_auth;
  char *text;
  char *infilename = NULL;
  char *outfilename = NULL;
  char *stdoutname = NULL;
  char innamebuff[MAXPATHLEN];
  char outnamebuff[MAXPATHLEN];
  char stdoutbuff[MAXPATHLEN];
  char buffer[MAXPATHLEN];
  Binary_Buffer *binary_buffer;
  Boolean is_pgp = FALSE;
  remote_auth = login(read->shell, "PGP", "PGP",
		      preferences.pgp_username, NULL);

  if(remote_auth == NULL)
    return;

  if(remote_auth->username == NULL || remote_auth->password == NULL) {
    free_remote_auth(remote_auth);
    return;
  }
  text = XmTextGetString(read->read_text);

  infilename = tmpnam(innamebuff);
  outfilename = tmpnam(outnamebuff);
  stdoutname = tmpnam(stdoutbuff);
  
  push_cursor(WATCH_CURSOR);

  switch(method) {
    
  case PGP_VRFY:
    is_pgp = ((ML_Strstr(text,PGP_SIGNATU_STR)) != NULL) ? TRUE : FALSE;
    if(is_pgp == FALSE)
      mm_log(NO_PGP_SIG, WARN);
    sprintf(buffer,PGP_VRFY_CMD,infilename,outfilename,stdoutname);
    break;
  case PGP_DECR:
    is_pgp = ((ML_Strstr(text,PGP_MESSAGE_STR)) != NULL) ? TRUE : FALSE;
    if(is_pgp == FALSE)
      mm_log(NO_PGP_MESSAGE, WARN);
    sprintf(buffer,PGP_DECR_CMD,infilename,outfilename,stdoutname);
    break;
  case PGP_KADD:
    is_pgp = ((ML_Strstr(text,PGP_PUBLICK_STR)) != NULL) ? TRUE : FALSE;
    if(is_pgp == FALSE)
      mm_log(NO_PGP_PUBKEY, WARN);
    sprintf(buffer,PGP_KADD_CMD, stdoutname);
    break;
  default:
    break;
  }

  if(is_pgp == TRUE) {
    if(method != PGP_KADD) {
      if((fp = fopen(infilename,"w")) != NULL) {
	(void) chmod(infilename,S_IRWXU);
	fwrite(text,strlen(text),1,fp);
	(void) fclose(fp);
      }
    }
    pw = scramble(remote_auth->password);
    if((write_to_pipe(buffer, pw, 
		   (method == PGP_KADD) ?	 text : NULL, 
		   (method == PGP_KADD) ? strlen(text) : 0L)
	) == SYSCALL_SUCCESS) {
      wipeout(pw);
      binary_buffer = load_binary_file(outfilename);
      if(binary_buffer) {
	if(binary_buffer->data) {
	  if(strlen((char *) binary_buffer->data) == binary_buffer->length) {
	    fs_give((void **) &read->current->alt_text);
	    read->current->alt_text = cpystr((char *) binary_buffer->data);
	    XmTextSetString(read->read_text,(char *) binary_buffer->data);
	  }
	  else 
	    ask_save(read->shell,binary_buffer);
	}
	free_binary_buffer(binary_buffer);
      }
    }
    else {
      mm_log("PGP command failed.",WARN);
      wipeout(pw);
    }
    fs_give((void **) &pw);
    
    if((fp = fopen(stdoutname,"r")) != NULL) {
      while(fgets(buffer,sizeof(buffer),fp) != NULL)
	mm_log(buffer,MLNOTIFY);
      fclose(fp);
    }
  }
  fs_give((void **) &text);

  unlink(infilename);
  unlink(outfilename);  
  unlink(stdoutname);
  free_remote_auth(remote_auth);
  pop_cursor();
  return;
}
