/* textfncs.c
 *
 *
 * $Author: mtm $
 * $Date: 1995/05/09 01:27:15 $
 * $Id: textfncs.c,v 1.1 1995/05/09 01:27:15 mtm Exp mtm $
 *
 * Mike Macgirvin <Mike_Macgirvin@CAMIS.Stanford.EDU>
 *
 * Copyright 1995 by The Leland Stanford Junior University.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notices appear in all copies and that both the
 * above copyright notices and this permission notice appear in supporting
 * documentation, and that the name of The Leland Stanford Junior University 
 * not be used in advertising or publicity pertaining to distribution of the 
 * software without specific, written prior permission.  This software is made 
 * available "as is", and THE LELAND STANFORD JUNIOR UNIVERSITY DISCLAIMS ALL 
 * WARRANTIES, EXPRESS OR IMPLIED, WITH REGARD TO THIS SOFTWARE, INCLUDING 
 * WITHOUT LIMITATION ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS 
 * FOR A PARTICULAR PURPOSE, AND IN NO EVENT SHALL THE LELAND STANFORD JUNIOR 
 * UNIVERSITY BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR 
 * ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER 
 * IN AN ACTION OF CONTRACT, TORT (INCLUDING NEGLIGENCE) OR STRICT LIABILITY, 
 * ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS 
 * SOFTWARE.
 *
 */

/*
 * $Log: textfncs.c,v $
 * Revision 1.1  1995/05/09  01:27:15  mtm
 * Initial revision
 *
 * 
 */


#include "ml.h"

Boolean hex_flag = FALSE;
Boolean found_hex = FALSE;
static unsigned char hex1 = NUL_TERM;
Widget textshell;
int textdone;
int confirm_done;

Menu confirm_menu[] = 
{
  { NULL, "confirm_ok", NUL_TERM,
      confirm_ok, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "confirm_cancel", NUL_TERM,
      confirm_cancel, NULL, 0, NULL, NULL, BTN_ON },
};



Menu text_input_menu[] = 
{
  { NULL, "text_input_accept", NUL_TERM,
      text_input_accept, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "text_input_cancel", NUL_TERM,
      text_input_cancel, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "text_input_HELP", NUL_TERM,
      text_input_help, NULL, 0, NULL, NULL, BTN_ON },
};


Menu spell_menu[] = 
{
  { NULL, "spell_next", NUL_TERM,
      spell_next, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "spell_cancel", NUL_TERM,
      spell_cancel, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "spell_remember", NUL_TERM,
      spell_remember, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "spell_HELP", NUL_TERM,
      spell_help, NULL, 0, NULL, NULL, BTN_ON },
};


Menu search_menu[] = 
{
  { NULL, "search_search", NUL_TERM,
      search_search, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "search_replace", NUL_TERM,
      search_replace, NULL, 0, NULL, NULL, BTN_MAILBOX_NOEDIT },
  { NULL, "search_cancel", NUL_TERM,
      search_cancel, NULL, 0, NULL, NULL, BTN_ON },
  { NULL, "search_HELP", NUL_TERM,
      search_help, NULL, 0, NULL, NULL, BTN_ON },
};




/* 
 * Keep from dragging the current selection in a modal list widget into
 * another widget which has no keyboard focus ability, which core dumps.
 *
 */

char GLOBAL_modal_list_translations[] =
"    <Btn2Down>:        ListEndSelect()        \n\
     <Btn2Up>:          ListEndSelect()        \n\
     <Btn2Motion>:      ListEndSelect()        \n";      

char GLOBAL_text_translations[] =
"       ~Meta ~Alt Ctrl<Key>a:          beginning-of-line()             \n\
        ~Meta ~Alt Ctrl<Key>b:          backward-character()            \n\
        ~Meta ~Alt Ctrl<Key>d:          delete-next-character()         \n\
        ~Meta ~Alt Ctrl<Key>e:          end-of-line()                   \n\
        ~Meta ~Alt Ctrl<Key>f:          forward-character()             \n\
        ~Meta ~Alt Ctrl<Key>g:          process-cancel()                \n\
        ~Meta ~Alt Ctrl<Key>h:          delete-previous-character()     \n\
        ~Meta ~Alt Ctrl<Key>k:          delete-to-end-of-line()         \n\
        ~Meta ~Alt Ctrl<Key>n:          next-line()                     \n\
        ~Meta ~Alt Ctrl<Key>p:          previous-line()                 \n\
        ~Meta ~Alt Ctrl<Key>s:          search-text()                   \n\
        ~Meta ~Alt Ctrl<Key>v:          next-page()                     \n\
        ~Meta ~Alt Ctrl<Key>w:          cut-clipboard()                 \n\
        ~Meta ~Alt Ctrl<Key>y:          paste-clipboard()               \n\
        ~Meta ~Alt Ctrl<Key>/:          hex-input()                     \n\
        Meta ~Ctrl<Key>b:               backward-word()                 \n\
         Alt ~Ctrl<Key>b:               backward-word()                 \n\
        Meta ~Ctrl<Key>d:               delete-next-word()              \n\
         Alt ~Ctrl<Key>d:               delete-next-word()              \n\
        Meta ~Ctrl<Key>f:               forward-word()                  \n\
         Alt ~Ctrl<Key>f:               forward-word()                  \n\
        Meta ~Ctrl<Key>w:               copy-clipboard()                \n\
         Alt ~Ctrl<Key>w:               copy-clipboard()                \n\
        Meta ~Ctrl<Key>osfLeft:         backward-word()                 \n\
         Alt ~Ctrl<Key>osfLeft:         backward-word()                 \n\
        Meta ~Ctrl<Key>osfRight:        forward-word()                  \n\
         Alt ~Ctrl<Key>osfRight:        forward-word()                  \n\
        Meta ~Ctrl<Key>osfBackSpace:    delete-previous-word()          \n\
         Alt ~Ctrl<Key>osfBackSpace:    delete-previous-word()          \n\
        Meta ~Ctrl<Key>osfDelete:       delete-next-word()              \n\
         Alt ~Ctrl<Key>osfDelete:       delete-next-word()              \n\
                  <Key>osfPageUp:       previous-page()                 \n\
                  <Key>osfPageDown:     next-page()                     \n\
   ~Meta ~Alt Ctrl<Key>osfPageUp:       previous-page()                 \n\
   ~Meta ~Alt Ctrl<Key>osfPageDown:     next-page()                     \n\
        Meta ~Ctrl<Key>v:               previous-page()                 \n\
         Alt ~Ctrl<Key>v:               previous-page()                 \n  ";

char GLOBAL_text_field_translations[] = 

"	~Meta ~Alt Ctrl<Key>a:		beginning-of-line()		\n\
	~Meta ~Alt Ctrl<Key>b:		backward-character()		\n\
	~Meta ~Alt Ctrl<Key>d:		delete-next-character()		\n\
	~Meta ~Alt Ctrl<Key>e:		end-of-line()			\n\
	~Meta ~Alt Ctrl<Key>f:		forward-character()		\n\
	~Meta ~Alt Ctrl<Key>g:		process-cancel()		\n\
	~Meta ~Alt Ctrl<Key>h:		delete-previous-character()	\n\
	~Meta ~Alt Ctrl<Key>k:		delete-to-end-of-line()		\n\
	~Meta ~Alt Ctrl<Key>s:		search-text()			\n\
	~Meta ~Alt Ctrl<Key>w:		cut-clipboard()			\n\
        ~Meta ~Alt Ctrl<Key>y:          paste-clipboard()               \n\
        ~Meta ~Alt Ctrl<Key>/:          hex-input()                     \n\
	Meta ~Ctrl<Key>b:		backward-word()			\n\
	 Alt ~Ctrl<Key>b:		backward-word()			\n\
	Meta ~Ctrl<Key>d:		delete-next-word()		\n\
	 Alt ~Ctrl<Key>d:		delete-next-word()		\n\
	Meta ~Ctrl<Key>f:		forward-word()			\n\
	 Alt ~Ctrl<Key>f:		forward-word()			\n\
	Meta ~Ctrl<Key>w:		copy-clipboard()		\n\
	 Alt ~Ctrl<Key>w:		copy-clipboard()		\n\
	Meta ~Ctrl<Key>osfLeft:		backward-word()			\n\
	 Alt ~Ctrl<Key>osfLeft:		backward-word()			\n\
	Meta ~Ctrl<Key>osfRight:	forward-word()			\n\
	 Alt ~Ctrl<Key>osfRight:	forward-word()			\n\
	Meta ~Ctrl<Key>osfBackSpace:	delete-previous-word()		\n\
	 Alt ~Ctrl<Key>osfBackSpace:	delete-previous-word()		\n\
	Meta ~Ctrl<Key>osfDelete:	delete-next-word()		\n\
	 Alt ~Ctrl<Key>osfDelete:	delete-next-word()		\n ";


char GLOBAL_nonterminal_text_field_translations[] =
"	!<Key>Return:		next-tab-group()			\n\
	!<Key>Linefeed:		next-tab-group()			\n ";

char GLOBAL_terminal_text_field_translations[] =
"	<Key>Return:		activate()				\n\
	<Key>Linefeed:		activate()				\n ";

#ifdef __STDC__
char *locale_message(int m)
#else
char *locale_message(m)
     int m;
#endif
{
  if(locale_messages != NULL)
    return(locale_messages[m]);
  return(default_messages[m]);
}



#ifdef __STDC__
int ml_strcoll(unsigned char *s1, unsigned char *s2)
#else
int ml_strcoll(s1, s2)
     unsigned char *s1;
     unsigned char *s2;
#endif
{
  return(strcoll((char *) s1, (char *) s2));
}

#ifdef __STDC__
unsigned char *GetUnTextField(Widget w)
#else
unsigned char *GetUnTextField(w)
     Widget w;
#endif
{
  return((unsigned char *) XmTextGetString(w));
}





#ifdef __STDC__
char *GetTextField(Widget w)
#else
char *GetTextField(w)
     Widget w;
#endif
{
  return(XmTextGetString(w));
}

#ifdef __STDC__
void TextSetString(Widget w, unsigned char *str)
#else
void TextSetString(w, str)
     Widget w;
     unsigned char *str;
#endif
{
  XmTextSetString(w,(char *) str);
}



#ifdef __STDC__
void AppendText(Widget w, char *str)
#else
void AppendText(w, str)
     Widget w;
     char *str;
#endif
{
  
  XmTextPosition pos;

  if(!str)
    return;

  pos = XmTextGetLastPosition(w);
  XmTextInsert(w,pos,str);
  pos = XmTextGetLastPosition(w);
  XmTextSetInsertionPosition(w, pos);
  return;
}


#ifdef __STDC__
void InsertText(Widget w, char *str)
#else
void InsertText(w, str)
     Widget w;
     char *str;
#endif
{
  XmTextPosition pos;

  if(!str)
    return;

  pos = XmTextGetInsertionPosition(w);
  XmTextInsert(w,pos,str);
  XmTextSetInsertionPosition(w, pos + strlen(str));
  return;
}


#ifdef NEVER
#ifdef __STDC__
void text_field_edit(Widget w, XtPointer zilch, XtPointer call_data)
#else
void text_field_edit(w,zilch,call_data)
     Widget w;
     XtPointer zilch;
     XtPointer call_data;
#endif
{
  XmTextVerifyCallbackStruct *ptr = (XmTextVerifyCallbackStruct *) call_data;
  register char *n;

  if(ptr == NULL)
    return;

  if(ptr->text->length != 0) {
    for(n = ptr->text->ptr; *n != NUL_TERM; n ++) 
      if(*n == LFCHAR)
	*n = NUL_TERM;
    ptr->text->length = strlen(ptr->text->ptr);
    ptr->doit = TRUE;
  }

}
#endif 


#ifdef __STDC__
void text_nospace_edit(Widget w, XtPointer zilch, XtPointer call_data)
#else
void text_nospace_edit(w,zilch,call_data)
     Widget w;
     XtPointer zilch;
     XtPointer call_data;
#endif
{
  XmTextVerifyCallbackStruct *ptr = (XmTextVerifyCallbackStruct *) call_data;
  register char *n;

  if(ptr == NULL)
    return;
  if(ptr->text->length != 0) {
    for(n = ptr->text->ptr; *n != NUL_TERM; n ++) 
      if((*n == SPACECHAR) || (*n == TABCHAR))
	*n = '-';
    ptr->text->length = strlen(ptr->text->ptr);
    ptr->doit = TRUE;
  }
  return;
}


#ifdef __STDC__
void text_hex_edit(Widget w, XtPointer zilch, XtPointer call_data)
#else
void text_hex_edit(w,zilch,call_data)
     Widget w;
     XtPointer zilch;
     XtPointer call_data;
#endif
{

  unsigned char a;
  unsigned char x;

  XmTextVerifyCallbackStruct *ptr = (XmTextVerifyCallbackStruct *) call_data;

  if(ptr == NULL)
    return;
  if(hex_flag == FALSE) {
    ptr->doit = TRUE;
    found_hex = FALSE;
    hex1 = NUL_TERM;
    return;
  }
  else {
    x = *ptr->text->ptr;

    if(! isxdigit(x)) {
      hex_flag = FALSE;
      ptr->doit = TRUE;
      found_hex = FALSE;
      hex1 = NUL_TERM;
      return;
    }
    if(found_hex == FALSE) {
      found_hex = TRUE;
      if(isdigit(x))
	hex1 = x - '0';
      else
	hex1 = x - (isupper(x) ? 'A' - 10 : 'a' - 10);
      ptr->text->length = 0;
      ptr->doit = TRUE;
      return;
    }
    else {
      if(isdigit(x))
	a = x  - '0';
      else
	a = x - (isupper(x) ? 'A' - 10 : 'a' - 10);
      x = (hex1 << 4);
      x += a;

      *(ptr->text->ptr) = x;
      hex_flag = FALSE;
      found_hex = FALSE;
      ptr->doit = TRUE;
    }
  }
  return;

}

#ifdef __STDC__
void text_field_edit(Widget w, XtPointer zilch, XtPointer call_data)
#else
void text_field_edit(w,zilch,call_data)
     Widget w;
     XtPointer zilch;
     XtPointer call_data;
#endif
{

  unsigned char a;
  unsigned char x;

  XmTextVerifyCallbackStruct *ptr = (XmTextVerifyCallbackStruct *) call_data;
  register char *n;

  if(ptr == NULL)
    return;

  if((hex_flag == FALSE) || (ptr->text->length > 1)) {
    if(ptr->text->length != 0) {
      for(n = ptr->text->ptr; *n != NUL_TERM; n ++) 
	if(*n == LFCHAR)
	  *n = NUL_TERM;
      ptr->text->length = strlen(ptr->text->ptr);
    }
    ptr->doit = TRUE;
    found_hex = FALSE;
    hex1 = NUL_TERM;
    return;
  }
  else {
    x = *ptr->text->ptr;
    if(! isxdigit((unsigned char) x)) {
      hex_flag = FALSE;
      ptr->doit = TRUE;
      found_hex = FALSE;
      hex1 = NUL_TERM;
      return;
    }
    if(found_hex == FALSE) {
      found_hex = TRUE;
      if(isdigit((unsigned char) x))
	hex1 = x - '0';
      else
	hex1 = x - (isupper((unsigned char) x) ? 'A' - 10 : 'a' - 10);
      ptr->text->length = 0;
      ptr->doit = TRUE;
      return;
    }
    else {
      if(isdigit((unsigned char) x))
	a = x  - '0';
      else
	a = x - (isupper((unsigned char) x) ? 'A' - 10 : 'a' - 10);
      x = (hex1 << 4);
      x += a;
      if((x == LFCHAR) || (x == NUL_TERM))
	ptr->doit = FALSE;
      else {
	*(ptr->text->ptr) = x;
	ptr->doit = TRUE;
      }
      hex_flag = FALSE;
      found_hex = FALSE;
    }
  }
  return;

}




#ifdef __STDC__
void passwd_edit(Widget w, Remote_Auth *authst, XtPointer call_data)
#else
void passwd_edit(w,authst,call_data)
     Widget w;
     Remote_Auth *authst;
     XtPointer call_data;
#endif
{
  XmTextVerifyCallbackStruct * ptr;
  int n = 0;
  int num_inserted;

  ptr = (XmTextVerifyCallbackStruct *) call_data;
  if(ptr == NULL)
    return;

  if(ptr->text->length == 0) {
    delete_at(ptr->startPos,
	      ptr->endPos, 
	      authst->workspace);
  }
  else {
   num_inserted = insert_at(ptr->currInsert,
			     ptr->text->ptr,
			     authst->workspace);
    for(n = 0; n < num_inserted; n ++)
      ptr->text->ptr[n] = PASSWD_CHAR;
    ptr->doit = TRUE;
  }
  return;
}

#ifdef __STDC__
void delete_at(int pos1, int pos2, char *str)
#else
void delete_at(pos1,pos2,str)
     int pos1;
     int pos2;
     char *str;
#endif
{
  int i, j;
  char buf[FILEBUFFLEN];
  
  for(i = 0; i < pos1; i ++)
    buf[i] = str[i];

  j = i;
  for(i = pos1; i < pos2; i ++ )
    ;

  while(str[i]) {
    buf[j] = str[i];
    j++;
    i++;
  }

  buf[j] = NUL_TERM;
  strcpy(str,buf);

  for(i = 0; i < FILEBUFFLEN; i ++)
    buf[i] = NUL_TERM;

  return;
}


#ifdef __STDC__
int insert_at(int pos, char *ins, char *str)
#else
int insert_at(pos,ins,str)
     int pos;
     char *ins;
     char *str;
#endif
{
  int i, j, k;
  int base_len = strlen(str);
  int insert_len = strlen(ins);
  char buf[FILEBUFFLEN];

  if(pos >= base_len) {
    strcat(str,ins);
    return(insert_len);
  }
  else {
    for(i = 0; i < pos; i ++) 
      buf[i] = str[i];
    buf[i] = NUL_TERM;

    j = 0;
    for(k = pos; k < (pos + insert_len); k ++) {
      buf[k] = ins[j];
      j ++;
    }
    buf[pos + insert_len] = NUL_TERM;

    strcat(buf,&str[pos]);
    strcpy(str, buf);
  }
  for(i = 0; i < FILEBUFFLEN; i ++)
    buf[i] = NUL_TERM;
  return(insert_len);
}

/* 
 * scramble() produces a non (easily) readable copy of a string, 
 * in allocated space. It also works in reverse to unscramble 
 * previously scrambled strings. This program calls "wipeout" as 
 * soon as it is able to zero our the password strings it uses.
 * This is all just so we don't leave cleartext passwords laying 
 * around in core files. To steal a quote from "Road Warrior", 
 * ... "A clever fella'; a REAL clever fella'... might..."
 * But there's NOTHING we can do to fool a REAL clever fella'.
 * The user is gonna' get annoyed if we ask them for the same password 
 * over and over again. That could be even more dangerous across the 
 * net by means of "XKey snoops" than a core file with scrambled passwords. 
 * Anybody who is able, should make use of the server's autologin feature
 * which uses rsh protocols to exec the server when it's linked to 
 * "/etc/rimapd". PGP and FTP also use the authentication module,
 * so even that's not perfect. We just try and do the best we can.
 * Caller needs to free the returned string.
 */

#ifdef __STDC__
char *scramble(char *str)
#else
char *scramble(str)
     char *str;
#endif
{
  int i;
  char *ret;
  if(! str)
    return(NULL);
  ret = (cpystr(str));
  for(i = 0; (ret[i] != NUL_TERM) ; i ++)
    ret[i] = ret[i] ^ PASSWORD_PATTERN;
  return(ret);
}

/* Zero out a text string. */

#ifdef __STDC__
void wipeout(char *str)
#else
void wipeout(str)
     char *str;
#endif
{
  register char *ptr;

  if(! str)
    return;
  for(ptr = str; *ptr != NUL_TERM; ptr ++)
    *ptr = NUL_TERM;
  return;
}

#ifdef __STDC__
void zap_commas(char *str)
#else
void zap_commas(str)
     char *str;
#endif
{
  register char *ptr;

  if(! str)
    return;
 
  for(ptr = str; *ptr != NUL_TERM; ptr ++)
    if(*ptr == ',')
      *ptr = SPACECHAR;
  return;
}

#ifdef __STDC__
char *stripcr(char *str)
#else
char *stripcr(str)
     char *str;
#endif
{
  register int i,j;
  if (str) {			
    for (i = j = 0; str[i] != NUL_TERM; i++)
      if(str[i] != CRCHAR || str[i+1] != LFCHAR ) 
	str[j++] = str[i];
    str[j] = NUL_TERM;
  }
  return (str);
}


#ifdef __STDC__
char *striplf(char *str)
#else
char *striplf(str)
     char *str;
#endif
{
  register int i,j;
  if (str) {			
    for (i = j = 0; str[i] != NUL_TERM; i++)
      if(str[i] != LFCHAR ) 
	str[j++] = str[i];
    str[j] = NUL_TERM;
  }
  return (str);
}

/*
 * first_nonwhite returns a pointer to the first non-whitspace
 * character in a string. Warning: Don't free the result. Keep the
 * original base of the string around if it's in allocated space.
 * All this does is point to the first non-white character therein.
 */

#ifdef __STDC__
char *first_nonwhite(char *str)
#else
char *first_nonwhite(str)
     char *str;
#endif
{
  char *ptr = str;
  if(ptr != NULL)
    while(isspace(*(unsigned char *)ptr))
      ptr ++;
  return((char *) ptr);
}

#ifdef __STDC__
void remove_trailing_white(char *str)
#else
void remove_trailing_white(str)
     char *str;
#endif
{
  char *ptr = NULL;

  if((str == NULL) || (*str == NUL_TERM))
    return;
  ptr = str + ((strlen(str)) - 1);
  while(isspace(*(unsigned char *)ptr)) {
    *ptr = NUL_TERM;
    ptr --;
  }
  return;
}


#ifdef __STDC__
Binary_Buffer *load_binary_file(char *filename)
#else
Binary_Buffer *load_binary_file(filename)
     char *filename;
#endif
{
  FILE *fp;
  Binary_Buffer *binary_buffer = NULL;
  struct stat st;
  unsigned long bytes_read  = 0L;
  unsigned long bytes_total = 0L;
  char *ptr;

  if(((stat(filename,&st)) != SYSCALL_SUCCESS)
     || (st.st_size == 0)
     || ((fp = fopen(filename,"r")) == NULL))
    return(NULL);

  binary_buffer = (Binary_Buffer *) fs_get(sizeof(Binary_Buffer));
  binary_buffer->length = (unsigned long) st.st_size;
  binary_buffer->data = (unsigned char *) fs_get(st.st_size + 1);

  ptr = (char *) binary_buffer->data;

  do {
    bytes_read = fread(ptr, 1, ((unsigned long) st.st_size) - bytes_total, fp);
    bytes_total += bytes_read;
    ptr += bytes_read;
  } while ((bytes_read != 0) && (bytes_total < (unsigned long) st.st_size));
  
  fclose(fp);

  binary_buffer->data[binary_buffer->length] = NUL_TERM;
  if(bytes_total != (unsigned long) st.st_size) {
    free_binary_buffer(binary_buffer);
    binary_buffer = NULL;
  }
  return(binary_buffer);
}

#ifdef __STDC__
char *wrap_text(char *str, int linelen)
#else
char *wrap_text(str,linelen)
     char *str;
     int linelen;
#endif
{
  int i = 0;
  char *src = str;
  char *dst, *ptr;
  unsigned long dstsize;

  if(! str)
    return(NULL);

  /* allocate source length + overhead to allow expansion  */

  dstsize = (unsigned long) strlen(src) 
    + (((unsigned long) strlen(src)) / (unsigned long) linelen) + 2;
  
  ptr = (char *) fs_get(dstsize);
  dst = ptr;

  while( *src != NUL_TERM ) {
    i ++;
    switch(*src) {
    case TABCHAR:
      if((i + (TABSIZE - 1)) > linelen) {
	*dst = LFCHAR;
	i = 0;
	break;
      }
      *dst = *src;
      i += (TABSIZE - 1);      
      break;
    case LFCHAR:
      *dst = *src;
      i = 0;
      break;
    case SPACECHAR:
      if((i + wordlen(src + 1)) > linelen ) {
	*dst = LFCHAR;
	i = 0;
	break;
      }
      else {
	*dst = *src;
	break;
      }
    default:
      *dst = *src;
      break;
    }
    src ++;
    dst ++;
  }
  *dst = NUL_TERM;
  return(ptr);
}



#ifdef __STDC__
char *wrap_header_text(char *str, int linelen)
#else
char *wrap_header_text(str,linelen)
     char *str;
     int linelen;
#endif
{
  int i = 0;
  char *src = str;
  char *dst, *ptr;
  unsigned long dstsize;

  if(! str)
    return(NULL);

  /* allocate source length + overhead to allow expansion  */

  dstsize = (unsigned long) strlen(src) 
    + (2 * (((unsigned long) strlen(src)) / (unsigned long) linelen)) + 2;
  
  ptr = (char *) fs_get(dstsize);
  dst = ptr;

  while( *src != NUL_TERM ) {
    i ++;
    switch(*src) {
    case TABCHAR:
      if((i + (TABSIZE - 1)) > linelen) {
	*dst = LFCHAR;
	i = 0;
	break;
      }
      *dst = *src;
      i += (TABSIZE - 1);      
      break;
    case LFCHAR:
      *dst = *src;
      i = 0;
      break;
    case SPACECHAR:
      if((i + wordlen(src + 1)) > linelen ) {
	*dst = LFCHAR;
	i = 0;
	break;
      }
      else {
	*dst = *src;
	break;
      }
    default:
      *dst = *src;
      break;
    }
    src ++;
    dst ++;
  }
  *dst = NUL_TERM;
  return(ptr);
}


/* returns the number of chars in the string contained in 's' up
 * to the next whitespace character.
 */

#ifdef __STDC__
int wordlen(char *s)
#else
int wordlen(s)
     char *s;
#endif
{
  register int cnt = 0;
  register char *ptr = s;

  while((*ptr) && (!isspace(*ptr))) {
    ptr ++;
    cnt ++;
  }
  return(cnt);
}


#ifdef __STDC__
char *lftocrlf(char *src)
#else
char *lftocrlf(src)
     char *src;
#endif
{
  char *dst = NULL;
  register char *ptr;
  register unsigned int lines = 0;
  register unsigned int i;
  register unsigned int j;
  
  if(! src)
    return(NULL);

  for(ptr = src; *ptr != NUL_TERM ; ptr ++)
    if(*ptr == LFCHAR || *ptr == CRCHAR)
      lines ++;
  
  dst = (char *) fs_get(strlen(src) + lines + 1);
  
  for (i = j = 0; src[i] != NUL_TERM ; i++) {
    if (src[i] == LFCHAR)
      dst[j++] = CRCHAR;
    else 
      if(src[i] == CRCHAR && src[i+1] == LFCHAR)
	dst[j++] = src[i++];
    
    dst[j++] = src[i];
    
    if (src[i] == CRCHAR)
      dst[j++] = LFCHAR;
  }
    
  dst[j] = NUL_TERM;	

  return(dst);
}


#ifdef __STDC__
char *input_string(Widget w, char *title, 
		   char *default_string, char *help_file)
#else
char *input_string(w,title,default_string,help_file)
     Widget w;
     char *title;
     char *default_string;
     char *help_file;
#endif
{

  Arg args[ARGLISTSIZE];
  char buff[FILEBUFFLEN];
  char *ret = NULL;
  int n = 0;
  Widget form, menubar, label, text;
  XtTranslations translations;
  XmString xstr;
  textdone = 0;

  XtSetArg(args[n], XtNx, -1000); n ++;
  XtSetArg(args[n], XtNy, -1000); n ++;



  XtSetArg(args[n], XmNtitle, title); n ++;
  textshell = XtCreatePopupShell("text_input_shell",
				 topLevelShellWidgetClass, w,
				 args, n);
  n = 0;

  setup_editres(textshell);

  if(pirate_icon != (Pixmap) None)
    XtVaSetValues(textshell,
		  XmNiconPixmap,pirate_icon,
		  NULL);

  form = XmCreateForm(textshell, "text_input_form",    args, n); n = 0;


  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;

  menubar = XmCreateMenuBar(form,"text_input_menubar", args, n); n = 0;
  XtManageChild(menubar);

  create_buttons(NULL, menubar, 
		 text_input_menu, 
		 XtNumber(text_input_menu), BTN_ON, 
		 help_file, ROOTMENULEVEL);

  sprintf(buff,"%s :",title);

  XtSetArg(args[n], XmNtopAttachment,   XmATTACH_WIDGET );      n ++;
  XtSetArg(args[n], XmNtopWidget,       menubar         );      n ++;
  XtSetArg(args[n], XmNleftAttachment,  XmATTACH_FORM   );      n ++;
  XtSetArg(args[n], XmNborderWidth,     0               );      n ++;

  xstr = XmStringCreateSimple(buff);

  XtSetArg(args[n], XmNlabelString,     xstr            );      n ++;
  label = XmCreateLabel(form, "text_input_lbl", args, n );      n = 0;
  XtManageChild(label);
  XmStringFree(xstr);
  
  XtSetArg(args[n], XmNtopAttachment,   XmATTACH_WIDGET );      n ++;
  XtSetArg(args[n], XmNtopWidget,       menubar         );      n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM   );      n ++;
  XtSetArg(args[n], XmNleftAttachment,  XmATTACH_WIDGET );      n ++;
  XtSetArg(args[n], XmNleftWidget,      label           );      n ++;

  text = XmCreateTextField(form,"text_input_textfld",args, n);  n = 0;
  XtManageChild(text);

  if(default_string)
    AppendText(text,default_string);

  translations = XtParseTranslationTable(GLOBAL_text_field_translations);
  XtOverrideTranslations(text,translations);

  translations = 
    XtParseTranslationTable(GLOBAL_terminal_text_field_translations);
    XtOverrideTranslations(text,translations);  
    XtAddCallback(text, XmNactivateCallback, 
		  (XtCallbackProc) text_input_accept, NULL);

  XtAddCallback(text, XmNmodifyVerifyCallback, 
		(XtCallbackProc) text_field_edit, NULL);

  XtManageChild(form);
  push_cursor(PIRATE_CURSOR);
  XtPopup(textshell,XtGrabExclusive); 
  position_popup_widget(textshell);
  modal_main_loop(&textdone);

  ret = GetTextField(text);

  XtPopdown(textshell);
  XtDestroyWidget(textshell);
  
  pop_cursor();
  if((textdone > 0) && (*ret != NUL_TERM)) 
    return(ret);

  if(ret)
    fs_give((void **) &ret);

  return(NULL);

}

#ifdef __STDC__
void text_input_accept(Widget w, XtPointer zilch, XtPointer xp)
#else
void text_input_accept(w,zilch,xp)
     Widget w;
     XtPointer zilch;
     XtPointer xp;
#endif
{
  textdone = 1;
  return;
}


#ifdef __STDC__
void text_input_cancel(Widget w, XtPointer zilch, XtPointer xp)
#else
void text_input_cancel(w,zilch,xp)
     Widget w;
     XtPointer zilch;
     XtPointer xp;
#endif
{
  textdone = (-1);
  return;
}

#ifdef __STDC__
void text_input_help(Widget w, XtPointer zilch, XtPointer xp)
#else
void text_input_help(w,zilch,xp)
     Widget w;
     char *zilch;
     XtPointer xp;
#endif
{
  help(textshell,INPUTSTRINGHELPTITLE,zilch, DOCTYPE_ENRICHED);
  return;
}

#ifdef __STDC__
void text_unwrap(Widget w, XtPointer xp)
#else
void text_unwrap(w,xp)
     Widget w;
     XtPointer xp;
#endif
{

  XmTextPosition left, right;
  Time timestamp;
  char *the_text;
  char *ptr;

  XmTextGetSelectionPosition(w,&left,&right);
  if(left == right)
    return;

  the_text = XmTextGetSelection(w);

  if(session.compose->edit->buffer) 
    fs_give((void **) &session.compose->edit->buffer);
  session.compose->edit->buffer = cpystr(the_text);
  session.compose->edit->begin = left;
  session.compose->edit->end   = right;

  for(ptr = the_text; *ptr != NUL_TERM; ptr ++) {
    if(*ptr == LFCHAR) {
      if((*(ptr + 1)) == LFCHAR)
	ptr += 2;
      else
	*ptr = SPACECHAR;
    }
  }
  XmTextReplace(w,left,right,the_text);
  timestamp = XtLastTimestampProcessed(XtDisplay(w));
  XmTextSetSelection(w,left,right,timestamp);
  fs_give((void **) &the_text);
}



#ifdef __STDC__
void text_strip_prefix(Widget w, char *prefix)
#else
void text_strip_prefix(w,prefix)
     Widget w;
     char *prefix;
#endif
{

  XmTextPosition left, right;
  Time timestamp;
  char *the_text;
  char *ret;
  char *src;
  char *dst;

  XmTextGetSelectionPosition(w,&left,&right);
  if(left == right)
    return;

  the_text = XmTextGetSelection(w);
  ret = (char *) fs_get(strlen(the_text));

  dst = ret;
  for(src = the_text; *src != NUL_TERM; src ++) {
    if(src == the_text) {
      if(strncmp(src,prefix,strlen(prefix)) == STRMATCH) {
	src += (strlen(prefix) - 1);
	continue;
      }
    }
    if((*src == LFCHAR)) {
      if((*(src + 1)) && (strncmp(src+1,prefix,strlen(prefix)) == STRMATCH)) {
	*dst = *src;
	dst ++;
	src += strlen(prefix);
	continue;
      }
    }
    *dst = *src;
    dst ++;
  }
  *dst = NUL_TERM;

  if(session.compose->edit->buffer) 
    fs_give((void **) &session.compose->edit->buffer);
  session.compose->edit->buffer = cpystr(the_text);
  session.compose->edit->begin = left;
  session.compose->edit->end   = left + strlen(ret);

  XmTextReplace(w,left,right,ret);
  timestamp = XtLastTimestampProcessed(XtDisplay(w));
  XmTextSetSelection(w,left,left + strlen(ret),timestamp);
  fs_give((void **) &the_text);
  fs_give((void **) &ret);
}

#ifdef __STDC__
void text_rewrap(Widget w, int wraplen)
#else
void text_rewrap(w,wraplen)
     Widget w;
     int wraplen;
#endif
{

  XmTextPosition left, right;
  Time timestamp;
  char *the_text;
  char *ret;

  XmTextGetSelectionPosition(w,&left,&right);
  if(left == right || wraplen <= 0)
    return;


  the_text = XmTextGetSelection(w);

  ret = wrap_text(the_text,wraplen - 1);


  if(session.compose->edit->buffer) 
    fs_give((void **) &session.compose->edit->buffer);
  
  session.compose->edit->buffer = cpystr(the_text);
  session.compose->edit->begin = left;
  session.compose->edit->end   = left + strlen(ret);
  
  XmTextReplace(w,left,right,ret);
  timestamp = XtLastTimestampProcessed(XtDisplay(w));
  XmTextSetSelection(w,left,left + strlen(ret),timestamp);
  fs_give((void **) &the_text);
  fs_give((void **) &ret);
}

#ifdef __STDC__
void text_prefix(Widget w, char *prefix)
#else
void text_prefix(w,prefix)
     Widget w;
     char *prefix;
#endif
{

  XmTextPosition left, right;
  Time timestamp;
  int lines;
  char *the_text;
  char *ret;
  char *src;
  char *dst;

  XmTextGetSelectionPosition(w,&left,&right);
  if(left == right)
    return;

  the_text = XmTextGetSelection(w);

  lines = count_lines(the_text);
  ret = (char *) fs_get(strlen(the_text) 
			+ ((lines * (strlen(prefix) + 1)) + 1));
  
  strcpy(ret,prefix);
  dst = ret + strlen(prefix);
  
  for(src = the_text; *src != NUL_TERM; src ++) {
    if(*src == LFCHAR) {
      *dst = *src;
      dst ++;
      strcpy(dst,prefix);
      dst += strlen(prefix);
      continue;
    }
    *dst = *src;
    dst ++;
  }
  *dst = NUL_TERM;



  if(session.compose->edit->buffer)
    fs_give((void **) &session.compose->edit->buffer);

  session.compose->edit->buffer = cpystr(the_text);
  session.compose->edit->begin = left;
  session.compose->edit->end   = left + strlen(ret);


  XmTextReplace(w,left,right,ret);
  timestamp = XtLastTimestampProcessed(XtDisplay(w));
  XmTextSetSelection(w,left,left + strlen(ret),timestamp);
  fs_give((void **) &the_text);
  fs_give((void **) &ret);
}

#ifdef __STDC__
char *ML_Strstr(char *cs, char *ct)
#else
char *ML_Strstr(cs,ct)
     char *cs;
     char *ct;
#endif
{
  char *s;
  char *t;
  while (cs = strchr (cs,*ct)) {/* for each occurance of the first character */
				/* see if remainder of string matches */
    for (s = cs + 1, t = ct + 1; *t && *s == *t; s++, t++);
    if (!*t) return cs;		/* if ran out of substring then have match */
    cs++;			/* try from next character */
  }
  return NIL;			/* not found */
}

#ifdef __STDC__
int count_lines(char *s)
#else
int count_lines(s)
     char *s;
#endif
{
  int n = 0;
  char *ptr;
  
  if(s == NULL)
    return(0);

  for(ptr = s; *ptr; ptr ++)
    if(*ptr == LFCHAR)
      n ++;

  return(n);
}


/* 
 * XmTextInsertString() seems to have a bug which screws up the scroll
 * bars when inserting more than a screenful at a time. This is a
 * function to bypass it. We break up the existing text into that before 
 * and after the insert position, and then recombine with our inserted text,
 * using XmTextSetString() to blast it onto the screen. Before finishing up,
 * the new insert position is set.
 */

#ifdef __STDC__
void text_blast(Widget w, char *str)
#else
void text_blast(w,str)
     Widget w;
     char *str;
#endif
{
  char *begin;
  char *end;
  char *existing;

  XmTextPosition pos = XmTextGetInsertionPosition(w);
 
  existing = XmTextGetString(w);

  if(pos) {
    begin = (char *) fs_get(pos + 1);
    strncpy(begin,existing,pos);
    begin[pos] = NUL_TERM;
  }
  else
    begin = cpystr(EMPTYSTR);
  
  end = cpystr(existing + pos);

  fs_give((void **) &existing);      /* free it up for re-use. */

  existing = (char *) fs_get(strlen(begin) + strlen(str) + strlen(end) + 1);
  strcpy(existing,begin);
  strcat(existing,str);
  strcat(existing,end);
  XmTextSetString(w, existing);
  XmTextSetInsertionPosition(w, pos + strlen(str));
  fs_give((void **) &existing);
  fs_give((void **) &begin);
  fs_give((void **) &end);
}
  

#ifdef __STDC__
void search_text(Widget w, XtPointer xp)
#else
void search_text(w,xp)
     Widget w;
     XtPointer xp;
#endif
{
  make_text_search_window(w);
  return;
}

#ifdef __STDC__
void hex_input(Widget w, XtPointer xp)
#else
void hex_input(w,xp)
     Widget w;
     XtPointer xp;
#endif
{
  hex_flag = TRUE;
}




#ifdef __STDC__
void spell_do_search(Widget w, Search_Win *search_win, XtPointer xp)
#else
void spell_do_search(w, search_win, xp)
     Widget w;
     Search_Win *search_win;
     XtPointer xp;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;

  XmTextPosition new_position, last_position;
  Boolean result = FALSE;

  last_position = XmTextGetLastPosition(search_win->parent);

  XmTextSetHighlight(search_win->parent, 0L, 
		     last_position,
		     XmHIGHLIGHT_NORMAL);

  result = XmTextFindString(search_win->parent,
			    search_win->position,
			    search_win->search_text,
			    XmTEXT_FORWARD,
			    &new_position);
  if(result == TRUE) {
    if(new_position == search_win->position) {
      search_win->position ++;
      spell_do_search(w,search_win,xp);
      return;
    }
    XmTextShowPosition(search_win->parent, new_position);
    search_win->position = new_position;
    XmTextSetHighlight(search_win->parent,new_position,
		       new_position + strlen(search_win->search_text),
		       XmHIGHLIGHT_SELECTED);
    XtSetArg(args[n], XmNsensitive, TRUE); n ++;
    XtSetValues(search_win->sbutton,args, n); n = 0;
    XtSetArg(args[n], XmNsensitive, TRUE); n ++;
    XtSetValues(search_win->rbutton,args, n); n = 0;
  }
  else {
    XtSetArg(args[n], XmNsensitive, FALSE); n ++;
    XtSetValues(search_win->sbutton,args, n); n = 0;
    XtSetArg(args[n], XmNsensitive, FALSE); n ++;
    XtSetValues(search_win->rbutton,args, n); n = 0;
    spell_next(w,search_win,xp);
  }
  return;
}


#ifdef __STDC__
void spell_do_replace(Widget w, Search_Win *search_win, XtPointer xp)
#else
void spell_do_replace(w, search_win, xp)
     Widget w;
     Search_Win *search_win;
     XtPointer xp;
#endif
{

  if(search_win->replace_text != NULL)
    fs_give((void **) &search_win->replace_text);
  search_win->replace_text = XmTextGetString(search_win->replacew);
  if((strcmp(search_win->replace_text, search_win->search_text)) == STRMATCH) {
    search_win->position ++;
    spell_do_search(w,search_win,xp);
    return;
  }
  XmTextReplace(search_win->parent,
		search_win->position,
		search_win->position + strlen(search_win->search_text),
		search_win->replace_text);
  search_win->position ++;   /* step over the current guy */
  spell_do_search(w,search_win,xp);
  return;
}

#ifdef __STDC__
void make_text_spell_window(Widget w, String_List *string_list)
#else
void make_text_spell_window(w, string_list)
     Widget w;
     String_List *string_list;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  Widget form, menubar;


  Search_Win *search_win = NULL;

  if((session.compose != NULL) && (session.compose->search_win == NULL)) {
    search_win = (Search_Win *) fs_get(sizeof(Search_Win));
    session.compose->search_win = search_win;
  }
  else
    search_win = session.compose->search_win;
  
  search_win->parent = w;
  search_win->is_realized = FALSE;
  search_win->reverse = FALSE;
  search_win->replace = TRUE;
  search_win->button_state = BTN_ON;
  search_win->search_text = NULL;
  search_win->replace_text = NULL;
  search_win->position = 0L;
  search_win->string_list = string_list;
  search_win->base = string_list;

  XtSetArg(args[n], XtNx, -1000); n ++;
  XtSetArg(args[n], XtNy, -1000); n ++;

  search_win->shell = XtCreateWidget("spell_shell",
				     topLevelShellWidgetClass, top,
				     args, n);
  n = 0;

  setup_editres(search_win->shell);

  if(pirate_icon != (Pixmap) None)
    XtVaSetValues(search_win->shell,
		  XmNiconPixmap,pirate_icon,
		  NULL);

  form = XmCreateForm(search_win->shell, "spell_form", args, n); n = 0;

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;

  menubar = XmCreateMenuBar(form,"spell_menubar", args, n); n = 0;
  XtManageChild(menubar);

  create_buttons(NULL, menubar, 
		 spell_menu, 
		 XtNumber(spell_menu), BTN_ON, 
		 (XtPointer) search_win, 
		 ROOTMENULEVEL);
  
  XtSetArg(args[n], XmNsensitive, FALSE ); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM ); n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, menubar); n ++;
  search_win->sbutton 
    = XmCreatePushButton(form,"spell_search_button",args,n); n = 0;
  XtAddCallback(search_win->sbutton, XmNactivateCallback,
		(XtCallbackProc) spell_do_search, search_win);
  XtManageChild(search_win->sbutton);

  XtSetArg(args[n], XmNsensitive, FALSE); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNleftWidget,search_win->sbutton); n ++;
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, menubar); n ++;
  search_win->rbutton 
    = XmCreatePushButton(form,"spell_replace_button", args, n); n = 0;
  XtAddCallback(search_win->rbutton, XmNactivateCallback,
		(XtCallbackProc) spell_do_replace, search_win);
  XtManageChild(search_win->rbutton);

  search_win->search_text = cpystr(string_list->string);

  search_win->searchw = create_text_field(form, search_win->sbutton, 
		      "spell_word", string_list->string, 0, NULL, NULL);

  XtSetArg(args[n], XmNeditable, FALSE ); n ++;
  XtSetValues(search_win->searchw, args, n ); n = 0;

  search_win->replacew = 
    create_text_field(form, search_win->searchw, "spell_replace", 
		      string_list->string, 0, 
		      (XtPointer) spell_accept, (XtPointer) search_win);

  XtAddCallback(search_win->shell, XmNdestroyCallback,
		(XtCallbackProc) spell_destroy, search_win);

  search_win->replace_text = cpystr(string_list->string);

  XtManageChild(form);
  XtManageChild(search_win->shell);
  XtRealizeWidget(search_win->shell);
  position_popup_widget(search_win->shell);
  search_win->is_realized = TRUE;
  spell_do_search(w,search_win,NULL);
  return;
}


#ifdef __STDC__
void spell_accept(Widget w, Search_Win *search_win, XtPointer xp)
#else
void spell_accept(w, search_win, xp)
     Widget w;
     Search_Win *search_win;
     XtPointer xp;
#endif
{
  spell_do_replace(w,search_win,xp);
  return;
}

#ifdef __STDC__
void spell_next(Widget w, Search_Win *search_win, XtPointer xp)
#else
void spell_next(w, search_win, xp)
     Widget w;
     Search_Win *search_win;
     XtPointer xp;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  search_win->position = 0L;
  search_win->string_list = search_win->string_list->next;

  if((search_win->string_list != NULL)
     && (search_win->string_list->string != NULL)) {
    XmTextSetString(search_win->searchw, search_win->string_list->string);
    XmTextSetString(search_win->replacew,search_win->string_list->string);
    if(search_win->search_text != NULL)
      fs_give((void **) &search_win->search_text);
    search_win->search_text = cpystr(search_win->string_list->string);
    if(search_win->replace_text != NULL)
      fs_give((void **) &search_win->replace_text);
    search_win->replace_text = XmTextGetString(search_win->replacew);
    XtSetArg(args[n], XmNsensitive, FALSE); n ++;
    XtSetValues(search_win->sbutton, args, n ); n = 0;
    XtSetArg(args[n], XmNsensitive, FALSE); n ++;
    XtSetValues(search_win->rbutton, args, n ); n = 0;
    spell_do_search(w,search_win,xp); 
  }
  else
    spell_cancel(w,search_win,xp);
  return;
}


#ifdef __STDC__
void spell_cancel(Widget w, Search_Win *search_win, XtPointer xp)
#else
void spell_cancel(w, search_win, xp)
     Widget w;
     Search_Win *search_win;
     XtPointer xp;
#endif
{
  char command[FILEBUFFLEN];

  /* This is ridiculous, but it just happens to work. */

  if(access(SPELLOUTFILE,R_OK) == SYSCALL_SUCCESS) {
    sprintf(command,SPELL_SORT_COMMAND,SPELLSTOPFILE,
	    SPELLOUTFILE,SPELLSTOPFILE,SPELLJUNKFILE,
	    SPELLJUNKFILE,SPELLSTOPFILE,SPELLOUTFILE);
    mm_log(UPDATING_STOP_FILE, NIL);
    set_watch_cursors();
    system(command);
    pop_cursor();
  }
  XmTextSetHighlight(search_win->parent, 0L, 
		     XmTextGetLastPosition(search_win->parent),
		     XmHIGHLIGHT_NORMAL);
  if(search_win->search_text != NULL)
    fs_give((void **) &search_win->search_text);
  if(search_win->replace_text != NULL)
    fs_give((void **) &search_win->replace_text);
  search_win->position = 0L;
  free_string_list(search_win->base, TRUE);
  search_win->base = NULL;
  search_win->is_realized = FALSE;
  XtRemoveCallback(search_win->shell, XmNdestroyCallback,
		   (XtCallbackProc) spell_destroy, search_win);
  XtDestroyWidget(search_win->shell);
  return;
}


#ifdef __STDC__
void spell_destroy(Widget w, Search_Win *search_win, XtPointer xp)
#else
void spell_destroy(w, search_win, xp)
     Widget w;
     Search_Win *search_win;
     XtPointer xp;
#endif
{
  XmTextSetHighlight(search_win->parent, 0L, 
		     XmTextGetLastPosition(search_win->parent),
		     XmHIGHLIGHT_NORMAL);
  if(search_win->search_text != NULL)
    fs_give((void **) &search_win->search_text);
  if(search_win->replace_text != NULL)
    fs_give((void **) &search_win->replace_text);
  search_win->position = 0L;
  free_string_list(search_win->base, TRUE);
  search_win->base = NULL;
  search_win->is_realized = FALSE;
  return;
}

#ifdef __STDC__
void spell_remember(Widget w, Search_Win *search_win, XtPointer xp)
#else
void spell_remember(w, search_win, xp)
     Widget w;
     Search_Win *search_win;
     XtPointer xp;
#endif
{
  FILE *fp;
  fp = fopen(SPELLOUTFILE,"a");
  if(fp)
    fprintf(fp,"%s\n", search_win->search_text);
  fclose(fp);
  spell_next(w,search_win,xp);
  return;
}

#ifdef __STDC__
void spell_help(Widget w, Search_Win *search_win, XtPointer xp)
#else
void spell_help(w, search_win, xp)
     Widget w;
     Search_Win *search_win;
     XtPointer xp;
#endif
{
  help(search_win->shell, SPELLHELPTITLE, SPELLHELPFILE, DOCTYPE_ENRICHED );
  return;
}





#ifdef __STDC__
void make_text_search_window(Widget w)
#else
void make_text_search_window(w)
     Widget w;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  Widget form, menubar;
  Boolean editable;

  Search_Win *search_win;
  

  search_win = (Search_Win *) fs_get(sizeof(Search_Win));

  search_win->parent = w;
  search_win->is_realized = FALSE;
  search_win->reverse = FALSE;
  search_win->replace = TRUE;
  search_win->button_state = BTN_ON;
  search_win->search_text = NULL;
  search_win->replace_text = NULL;
  search_win->position = 0L;
  search_win->string_list = NULL;
  search_win->base = NULL;

  XtSetArg(args[n], XtNx, -1000); n ++;
  XtSetArg(args[n], XtNy, -1000); n ++;


  search_win->shell = XtCreateWidget("search_shell",
				     topLevelShellWidgetClass, top,
				     args, n);
  n = 0;

  setup_editres(search_win->shell);

  if(pirate_icon != (Pixmap) None)
    XtVaSetValues(search_win->shell,
		  XmNiconPixmap,pirate_icon,
		  NULL);

  XtSetArg(args[n], XmNeditable, &editable ); n ++;
  XtGetValues(search_win->parent, args, n);
  search_win->editable = editable;


  form = XmCreateForm(search_win->shell, "search_form", args, n); n = 0;

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;

  menubar = XmCreateMenuBar(form,"search_menubar", args, n); n = 0;
  XtManageChild(menubar);

  create_buttons(NULL, menubar, 
		 search_menu, 
		 XtNumber(search_menu), BTN_ON, 
		 (XtPointer) search_win, 
		 ROOTMENULEVEL);
  
  search_win->searchw = create_text_field(form, menubar, 
					  "search_word", NULL, 0, 
					  (XtPointer)search_search,
					  (XtPointer)search_win);

  search_win->replacew = 
    create_text_field(form, search_win->searchw, "search_replace_word", 
		      NULL, 0, 
		      (XtPointer) search_replace, (XtPointer) search_win);

  if(search_win->editable == FALSE) {
    XtSetArg(args[n], XmNeditable, FALSE); n ++;
    XtSetValues(search_win->replacew, args, n); n = 0;
    search_win->button_state |= BTN_MAILBOX_NOEDIT; /* it'll work */
  }
  

  XtAddCallback(search_win->shell, XmNdestroyCallback,
		(XtCallbackProc) search_destroy, search_win);

  check_buttons(search_menu,XtNumber(search_menu), 
		NULL, search_win->button_state);

  XtManageChild(form);
  XtManageChild(search_win->shell);
  XtRealizeWidget(search_win->shell);
  position_popup_widget(search_win->shell);
  return;
}




#ifdef __STDC__
void search_search(Widget w, Search_Win *search_win, XtPointer xp)
#else
void search_search(w, search_win, xp)
     Widget w;
     Search_Win *search_win;
     XtPointer xp;
#endif
{
  char *currword;

  XmTextPosition new_position, last_position;
  Boolean result = FALSE;

  last_position = XmTextGetLastPosition(search_win->parent);

  currword = XmTextGetString(search_win->searchw);
  if(search_win->search_text == NULL) {
    search_win->position = 0L;
    search_win->search_text = cpystr(currword);
  }
  else {
    if((strcmp(currword,search_win->search_text)) != STRMATCH) {
      fs_give((void **) &search_win->search_text);
      search_win->search_text = cpystr(currword);
      search_win->position = 0L;
    }
  }

  XmTextSetHighlight(search_win->parent, 0L, 
		     last_position,
		     XmHIGHLIGHT_NORMAL);

  result = XmTextFindString(search_win->parent,
			    search_win->position,
			    search_win->search_text,
			    XmTEXT_FORWARD,
			    &new_position);

  if(result == TRUE) {
    if(new_position == search_win->position) {
      search_win->position ++;
      search_search(w,search_win,xp);
      return;
    }
    XmTextShowPosition(search_win->parent, new_position);
    search_win->position = new_position;
    XmTextSetHighlight(search_win->parent,new_position,
		       new_position + strlen(search_win->search_text),
		       XmHIGHLIGHT_SELECTED);
  }
  else
    XBell(display,1000);

  return;
}

#ifdef __STDC__
void search_replace(Widget w, Search_Win *search_win, XtPointer xp)
#else
void search_replace(w, search_win, xp)
     Widget w;
     Search_Win *search_win;
     XtPointer xp;
#endif
{
  if(search_win->editable == FALSE)
    return;
  if(search_win->replace_text != NULL)
    fs_give((void **) &search_win->replace_text);
  search_win->replace_text = XmTextGetString(search_win->replacew);
  if((strcmp(search_win->replace_text, search_win->search_text)) == STRMATCH) {
    search_win->position ++;
    search_search(w,search_win,xp);
    return;
  }
  XmTextReplace(search_win->parent,
		search_win->position,
		search_win->position + strlen(search_win->search_text),
		search_win->replace_text);
  search_win->position ++;   /* step over the current guy */
  search_search(w,search_win,xp);
  return;
}


#ifdef __STDC__
void search_cancel(Widget w, Search_Win *search_win, XtPointer xp)
#else
void search_cancel(w, search_win, xp)
     Widget w;
     Search_Win *search_win;
     XtPointer xp;
#endif
{
  XmTextSetHighlight(search_win->parent, 0L, 
		     XmTextGetLastPosition(search_win->parent),
		     XmHIGHLIGHT_NORMAL);
  if(search_win->search_text != NULL)
    fs_give((void **) &search_win->search_text);
  if(search_win->replace_text != NULL)
    fs_give((void **) &search_win->replace_text);
  XtRemoveCallback(search_win->shell, XmNdestroyCallback,
		   (XtCallbackProc) search_destroy, search_win);
  XtDestroyWidget(search_win->shell);
  fs_give((void **) &search_win);
  return;
}


#ifdef __STDC__
void search_destroy(Widget w, Search_Win *search_win, XtPointer xp)
#else
void search_destroy(w, search_win, xp)
     Widget w;
     Search_Win *search_win;
     XtPointer xp;
#endif
{
  XmTextSetHighlight(search_win->parent, 0L, 
		     XmTextGetLastPosition(search_win->parent),
		     XmHIGHLIGHT_NORMAL);
  if(search_win->search_text != NULL)
    fs_give((void **) &search_win->search_text);
  if(search_win->replace_text != NULL)
    fs_give((void **) &search_win->replace_text);

  fs_give((void **) &search_win);
  return;
}

#ifdef __STDC__
void search_help(Widget w, Search_Win *search_win, XtPointer xp)
#else
void search_help(w, search_win, xp)
     Widget w;
     Search_Win *search_win;
     XtPointer xp;
#endif
{
  help(search_win->shell, SEARCHREPHELPTITLE, 
       SEARCHREPHELPFILE, DOCTYPE_ENRICHED);
  return;
}


#ifdef __STDC__
Boolean ml_confirm(Widget w, char *prompt)
#else
Boolean ml_confirm(w,prompt)
     Widget w;
     char *prompt;
#endif
{
  Arg args[ARGLISTSIZE];
  int n = 0;
  Widget shell, form, menubar, label;
  Boolean result;
  XmString xstr;

  XtSetArg(args[n], XtNx, -1000); n ++;
  XtSetArg(args[n], XtNy, -1000); n ++;

  shell = XtCreatePopupShell("confirm_shell",
			     topLevelShellWidgetClass, w,
			     args, n);
  n = 0;

  setup_editres(shell);

  if(pirate_icon != (Pixmap) None)
    XtVaSetValues(shell,
		  XmNiconPixmap,pirate_icon,
		  NULL);

  form = XmCreateForm(shell, "confirm_form", args, n); n = 0;

  XtSetArg(args[n], XmNtopAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM); n ++;
  XtSetArg(args[n], XmNrightAttachment, XmATTACH_FORM); n ++;

  menubar = XmCreateMenuBar(form,"confirm_menubar", args, n); n = 0;
  XtManageChild(menubar);

  create_buttons(NULL, menubar, 
		 confirm_menu, 
		 XtNumber(confirm_menu), BTN_ON, 
		 &result, 
		 ROOTMENULEVEL);

  xstr = XmStringCreateSimple(prompt);
  
  XtSetArg(args[n], XmNtopAttachment, XmATTACH_WIDGET); n ++;
  XtSetArg(args[n], XmNtopWidget, menubar);             n ++;
  XtSetArg(args[n], XmNleftAttachment, XmATTACH_FORM);  n ++;
  XtSetArg(args[n], XmNborderWidth, 0);                 n ++;

  XtSetArg(args[n], XmNlabelString,xstr);               n ++;
  label = XmCreateLabel(form,"confirm_lbl",args,n);     n = 0;
  XtManageChild(label);
  XmStringFree(xstr);

  XtManageChild(form);
  XtManageChild(shell);
  XtPopup(shell,XtGrabExclusive); 
  position_popup_widget(shell);

  push_cursor(PIRATE_CURSOR);
  confirm_done = 0;
  modal_main_loop(&confirm_done);
				       
  XtPopdown(shell);
  XtDestroyWidget(shell);
  pop_cursor();
  return(result);

}

#ifdef __STDC__
void confirm_ok(Widget w, Boolean *result, XtPointer xp)
#else
void confirm_ok(w, result, xp)
     Widget w;
     Boolean *result;
     XtPointer xp;
#endif
{
  *result = TRUE;
  confirm_done = MODAL_LOOP_DONE;
  return;
}

#ifdef __STDC__
void confirm_cancel(Widget w, Boolean *result, XtPointer xp)
#else
void confirm_cancel(w, result, xp)
     Widget w;
     Boolean *result;
     XtPointer xp;
#endif
{
  *result = FALSE;
  confirm_done = MODAL_LOOP_DONE;
  return;
}
